/*==================================================================
    Author : Dmitri Bandourin

    created: March 1999
    
    Purpose: 
    In case of new global alignment constants
    for a subdetector this subroutine read old GEDE
    parameters and write to GEDE the new ones
====================================================================*/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

#include <vector.h>
#include "arte/arte.hh"

#define EXT1 extern
#include "alca/ReadGlAlDB.h"
#define EXT2 extern
#include "alca/FillGD.h"
#define EXT3 extern 
#include "alca/TDnext.h"

char *dbName = "GlobAl_DB";

extern "C" {
int acGlobAlRead( int,char*,int,int);
int acGlobAlNext( char*,int,int);
void acGlobAlAlign(float *,float *,float *,float *,float,float,float (*)[3]);
void acGlobAlChange();
}

void acGlobAlChange()
{
  static FILE *fp = fopen("Gl_test","w");
  float rmin[3],rmax[3],rsmn[2],rsmx[2],cos,sin; 
  float rot[3][3];

  static int Tprev = 0;
  static int Dprev = 0;
  static int Tnext = 999999;
  static int Dnext = 999999;

  int sdet = 0;
  static int ic[9] = {0,0,0,0,0,0,0,0,0};
  short chGEDE = 0;
  short TN = 0,TR = 0;

  ArtePointer<EVHD> event(1);

  int DateEvt =  event->date;
  int TimeEvt =  event->time;

  int cmp_cur =0;
  int cmp_max =0;
  for ( ArteTableIterator<GEDE> iv; iv.valid(); iv.next() ) 
    { cmp_cur = ArtePointer<GEDE>(iv)->cmp;
      cmp_max = cmp_cur > cmp_max ? cmp_cur : cmp_max; }


  for ( ArteTableIterator<GEDE> iv; iv.valid(); iv.next() ) 
    {
      int SubDet  = ArtePointer<GEDE>(iv)->cmp;
      if(SubDet >= 1 && SubDet <= cmp_max) 
       {
         if( SubDet != sdet)
           {
             sdet = SubDet; 
	     chGEDE = 0;
             if(Tnext > TimeEvt && Dnext  >= DateEvt &&
                TimeEvt > Tprev && DateEvt >= Dprev  &&
                ic[sdet] == 0)
	       { 
                 TR=acGlobAlRead( SubDet,dbName,TimeEvt,DateEvt);
                 TN=acGlobAlNext( dbName,TimeEvt,DateEvt); 
                 Tprev = ReadGlAlDB.TimePrev; Dprev = ReadGlAlDB.DatePrev;
                 Tnext = TDnext.TimeNext; Dnext = TDnext.DateNext;
                 if( TR == -1)
                   {Tprev = Tnext ; Dprev = Dnext;}
                 if( sdet == cmp_max && TN == -1)
                   {Tnext = 999999; Dnext  = 999999;}
                 if( TR != -1)  ic[sdet]++;
	         if( TR ==  1)  chGEDE = 1;
               }
             else if(TimeEvt > Tnext && DateEvt >= Dnext)
               {            
                 ic[sdet] = 1; 
                 TR=acGlobAlRead( SubDet,dbName,TimeEvt,DateEvt);
                 Tprev = ReadGlAlDB.TimePrev; Dprev = ReadGlAlDB.DatePrev;
	         if( TR == 1) chGEDE = 1;
                 if( sdet == cmp_max) 
                   {
                     TN=acGlobAlNext( dbName,TimeEvt,DateEvt);
                     Tnext = TDnext.TimeNext; Dnext = TDnext.DateNext;
                     if( TN == -1 ) 
                       { Tnext = 999999; Dnext = 999999; 
                         Tprev = Tnext ; Dprev = Dnext;}
                   }
               }         
           }
         if( chGEDE == 1 )
           {
	    // short lay  = ArtePointer<GEDE>(iv)->lay;   // # layer
	    //ArtePointer<GESL> gesl = (ArtePointer<GESL>)
	    //                           ArtePointer<GEDE>(iv)->gesl;
	    // short sl  = gesl->nsl;            // # superlayer

            rmin[0] = ArtePointer<GEDE>(iv)->xmin; // Xmin 
            rmax[0] = ArtePointer<GEDE>(iv)->xmax; // Xmax 
            rmin[1] = ArtePointer<GEDE>(iv)->ymin; // Ymin 
            rmax[1] = ArtePointer<GEDE>(iv)->ymax; // Ymax 
            rmin[2] = ArtePointer<GEDE>(iv)->zmin; // Zmin 
            rmax[2] = ArtePointer<GEDE>(iv)->zmax; // Zmax 
            rsmn[0] = ArtePointer<GEDE>(iv)->sxmn; // Xmin of sens. area
            rsmx[0] = ArtePointer<GEDE>(iv)->sxmx; // Xmax of sens. area
            rsmn[1] = ArtePointer<GEDE>(iv)->symn; // Ymin of sens. area
            rsmx[1] = ArtePointer<GEDE>(iv)->symx; // Ymax of sens. area

//... Get right-handed rot[][] (Mother -> Layer system).

            rot[0][0] = ArtePointer<GEDE>(iv)->rot[0];
            rot[1][0] = ArtePointer<GEDE>(iv)->rot[1];
            rot[2][0] = ArtePointer<GEDE>(iv)->rot[2];
            rot[0][1] = ArtePointer<GEDE>(iv)->rot[3];
            rot[1][1] = ArtePointer<GEDE>(iv)->rot[4];
            rot[2][1] = ArtePointer<GEDE>(iv)->rot[5];
            rot[0][2] = ArtePointer<GEDE>(iv)->rot[6];
            rot[1][2] = ArtePointer<GEDE>(iv)->rot[7];
            rot[2][2] = ArtePointer<GEDE>(iv)->rot[8];
            cos       = ArtePointer<GEDE>(iv)->cos;
            sin       = ArtePointer<GEDE>(iv)->sin;
//... Define new GEDE parameters.

            acGlobAlAlign(rmin,rmax,rsmn,rsmx,cos,sin,rot);

//... Write down to GEDE table coordinates.
            ArtePointer<GEDE>(iv)->xmin = FillGD.XMIN;// new  Xmin 
            ArtePointer<GEDE>(iv)->xmax = FillGD.XMAX;// new  Xmax 
            ArtePointer<GEDE>(iv)->ymin = FillGD.YMIN;// new  Ymin 
            ArtePointer<GEDE>(iv)->ymax = FillGD.YMAX;// new  Ymax 
            ArtePointer<GEDE>(iv)->zmin = FillGD.ZMIN;// new  Zmin 
            ArtePointer<GEDE>(iv)->zmax = FillGD.ZMAX;// new  Zmax 
            ArtePointer<GEDE>(iv)->sxmn = FillGD.SXMN;// new  Xmin of sens. area
            ArtePointer<GEDE>(iv)->sxmx = FillGD.SXMX;// new  Xmax of sens. area
            ArtePointer<GEDE>(iv)->symn = FillGD.SYMN;// new  Ymin of sens. area
            ArtePointer<GEDE>(iv)->symx = FillGD.SYMX;// new  Ymax of sens. area

//... Write down to GEDE table new left-handed rot[][] (Layer -> old Mother system).
            ArtePointer<GEDE>(iv)->rot[0] = FillGD.Rot[0][0];
            ArtePointer<GEDE>(iv)->rot[1] = FillGD.Rot[1][0];
            ArtePointer<GEDE>(iv)->rot[2] = FillGD.Rot[2][0];
            ArtePointer<GEDE>(iv)->rot[3] = FillGD.Rot[0][1];
            ArtePointer<GEDE>(iv)->rot[4] = FillGD.Rot[1][1];
            ArtePointer<GEDE>(iv)->rot[5] = FillGD.Rot[2][1];
            ArtePointer<GEDE>(iv)->rot[6] = FillGD.Rot[0][2];
            ArtePointer<GEDE>(iv)->rot[7] = FillGD.Rot[1][2];
            ArtePointer<GEDE>(iv)->rot[8] = FillGD.Rot[2][2];
             
// Let's check what we have done.
 
            int prt = 0;
            if(prt == -1) {
               fprintf(fp,"\n\n matrix rot OLD (in MOTH system):  
            \n %7.3f %7.3f %7.3f\n %7.3f %7.3f %7.3f\n %7.3f %7.3f %7.3f\n",
                       rot[0][0],rot[0][1],rot[0][2],
                       rot[1][0],rot[1][1],rot[1][2],
                       rot[2][0],rot[2][1],rot[2][2]);
               fprintf(fp,"  \n matrix rot NEW (in MOTH system):  
            \n %7.3f %7.3f %7.3f\n %7.3f %7.3f %7.3f \n %7.3f %7.3f %7.3f\n",
                       FillGD.Rot[0][0],FillGD.Rot[0][1],FillGD.Rot[0][2],
                       FillGD.Rot[1][0],FillGD.Rot[1][1],FillGD.Rot[1][2],
                       FillGD.Rot[2][0],FillGD.Rot[2][1],FillGD.Rot[2][2]);

               fprintf(fp,"\n\n rmin OLD: %7.3f %7.3f %7.3f",
                       rmin[0],rmin[1],rmin[2]);
               fprintf(fp,"  \n rmin NEW: %7.3f %7.3f %7.3f",
                       FillGD.XMIN,FillGD.YMIN,FillGD.ZMIN);
               fprintf(fp,"\n\n rmax OLD: %7.3f %7.3f %7.3f",
                       rmax[0],rmax[1],rmax[2]);
               fprintf(fp,"  \n rmax NEW: %7.3f %7.3f %7.3f",
                       FillGD.XMAX,FillGD.YMAX,FillGD.ZMAX);

               fprintf(fp,"\n\n rsmn OLD: %7.3f %7.3f",rsmn[0],rsmn[1]);
               fprintf(fp,"  \n rsmn NEW: %7.3f %7.3f",FillGD.SXMN,FillGD.SYMN);
               fprintf(fp,"\n\n rsmx OLD: %7.3f %7.3f",rsmx[0],rsmx[1]);
               fprintf(fp,"  \n rsmx NEW: %7.3f %7.3f",FillGD.SXMX,FillGD.SYMX);	    
             }
          }
      }
   }
}	  


