/*================================================================== 
   Author : Dmitri Bandourin

    created: March 1999

    Purpose: 
    The subroutine finds time and date of previous
    Leda table with alignment constants and reads
    those for a subdetector SubDet
====================================================================*/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "ledaC++.hh"

#define EXT1 
#include "alca/ReadGlAlDB.h"
extern "C"{
#include "alca/GlobAl.h"
	  
int acGlobAlRead( int SubDet, char* dbName, int TimeEvt, int DateEvt)
 {
  static FILE *fp = fopen("Gl_read","w");

  MizziDatabase mydb;
  Tables x;
  x = mydb.open(dbName,0);
 
  fprintf(fp,"\n\n TimeEvt %d DateEvt %d",TimeEvt,DateEvt);
  GLOBAL_ALGN_TEST->initialize();
  LedaCheckDD();

  GLOBAL_ALGN_TEST -> book( mydb );
  mydb.stamp(DateEvt,TimeEvt);     
  int xe = GLOBAL_ALGN_TEST -> fetch_data( DBle );
 
  if( !xe) 
    {
      GLOBAL_ALGN_TEST -> remove -> all();
      GLOBAL_ALGN_TEST -> unbook();
      mydb.close();
      return -1;
    }

  ReadGlAlDB.DatePrev = TableMajor(x);
  ReadGlAlDB.TimePrev = TableMinor(x);
  fprintf(fp,"\n Previous table exists for\n"); 
  fprintf(fp,"     Date %d, Time %d",ReadGlAlDB.DatePrev,ReadGlAlDB.TimePrev);

  GLOBAL_ALGN_TEST -> set_keys();

  if( SubDet )
    {
      int i,j;    

      LedaPointer<class GLOBAL_ALGN_TEST> FilePointer;
      FilePointer = GLOBAL_ALGN_TEST->get->key(SubDet);
      if(!FilePointer)
	{
          fprintf(fp,"\nRead: No record for SubDetector = %d",SubDet);
          for( i = 0; i <= 2; i++) { 
             ReadGlAlDB.dR[i] = 0.0;
             for( j = 0; j <= 2; j++) { 
               if( i != j ) ReadGlAlDB.M[i][j] = 0.0; 
               if( i == j ) ReadGlAlDB.M[i][j] = 1.0; 
            }
          } 
          ReadGlAlDB.Z0 = 0.0;
          ReadGlAlDB.TX = 0.0;
          ReadGlAlDB.TY = 0.0;
          ReadGlAlDB.FZ = 0.0;

          GLOBAL_ALGN_TEST -> remove -> all();
          GLOBAL_ALGN_TEST -> unbook();
          mydb.close();
	  return 0;
	}
      else
        {
          for( i = 0; i <= 2; i++) { 
            ReadGlAlDB.dR[i] = FilePointer->dR[i];
            for( j = 0; j <= 2; j++) { 
              ReadGlAlDB.M[i][j] = FilePointer->M[i][j];
            }
          } 
          ReadGlAlDB.Z0 = FilePointer->Z0;
          ReadGlAlDB.TX = FilePointer->TX;
          ReadGlAlDB.TY = FilePointer->TY;
          ReadGlAlDB.FZ = FilePointer->FZ;

          fprintf(fp,"\n ************************************************* \n");
          printf("\n\n Global alignment constants for Subdetector %d
          and  TimePrev = %d DatePrev = %d
                    are read \n\n"
          ,SubDet, ReadGlAlDB.TimePrev,ReadGlAlDB.DatePrev);
          fprintf(fp,"\n Global alignment constants for Subdetector %d
          and  TimePrev = %d DatePrev = %d
                    are read: \n\n"
          ,SubDet, ReadGlAlDB.TimePrev,ReadGlAlDB.DatePrev);
          fprintf(fp,"    Rotation matrix: \n");
          fprintf(fp,"\t%9.4f%9.4f%9.4f\n",
          ReadGlAlDB.M[0][0],ReadGlAlDB.M[0][1],ReadGlAlDB.M[0][2]); 
          fprintf(fp,"\t%9.4f%9.4f%9.4f\n",
          ReadGlAlDB.M[1][0],ReadGlAlDB.M[1][1],ReadGlAlDB.M[1][2]); 
          fprintf(fp,"\t%9.4f%9.4f%9.4f\n",
          ReadGlAlDB.M[2][0],ReadGlAlDB.M[2][1],ReadGlAlDB.M[2][2]); 
          fprintf(fp,"    Translation vector: \n");
          fprintf(fp,"\tdX=%9.4f dY=%9.4f dZ=%9.4f\n",
          ReadGlAlDB.dR[0],ReadGlAlDB.dR[1],ReadGlAlDB.dR[2]); 
          fprintf(fp,"    Shearing parameters:\n");
          fprintf(fp, "\tTX=%9.4f TY=%9.4f\n",ReadGlAlDB.TX,ReadGlAlDB.TY);
          fprintf(fp,"    Scaling parameter:\n");
          fprintf(fp, "\tFZ=%9.4f\n",ReadGlAlDB.FZ);
          fprintf(fp,"    Reference point: \n");
          fprintf(fp,"\tZ0=%9.4f\n",ReadGlAlDB.Z0);
          fprintf(fp,"\n ************************************************* \n\n");
        }
    }
    else 
      return -1;
  
  GLOBAL_ALGN_TEST -> remove -> all();
  GLOBAL_ALGN_TEST -> unbook();
  mydb.close();
 
  return 1;

 }	  
}

