*-- Author :    Hartwig Albrecht   02/02/95

      SUBROUTINE ATINIT

************************************************************************
*
* Description: Program initialization
*
* Called from: ATMAIN
*
* External references: ...
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER IZEB(4), DUMMY, FAINIT
      DATA IZEB /4, -2, LLOGF, LSTDO/

#include "arte/Arte.ff"

C general initialization

      CALL UTINIT

C Geant version

      CALL HGVERS

C Zebra initialization

      CALL MZEBRA (IZEB)
      CALL ZPHASE (0)

C Physics geerator initialization
      CALL LUINIT

C length of working space declared in user routines:

      CALL USPACE

C initialize MM package

      CALL MMINIT (JLAST)

C Default units

      CALL IOINIT

C Table description

      CALL USAUTT

C establish hierarchy of tables

      CALL MMHIER

C Print title

      CALL LITITL ('TPL')
      IF (HBVERS .EQ. ' ')  CALL MEERRC (897634,
     +  'Arte needs the Unix variable HBVERS which is not given')

C Quasi BLOCK DATA for Lund

      CALL ALDATA

C Kuip initialization

      CALL KUINIT (400 000)
      CALL USKUIP
      CALL ATKUIP
      CALL IOKUIP
      CALL MMKUIP
      CALL DBKUIP
      CALL GARTKUIP
      CALL STAGEKUIP
      CALL LIKUIP1
      CALL LIKUIP2
      CALL DIKUIP
      CALL METAKUIP
      CALL PARTKUIP
      CALL LUNDKUIP
      CALL HGKUIP
      CALL DGKUIP
      CALL GINTRI
      CALL DDKUIP
      CALL USAUTH
      CALL FLKUIP
      CALL RIREKUIP       
      CALL RCKUIP
c      CALL L1KUIP
c      CALL SUSIKUIP

C DbArteBridge initialization

      CALL DBINIT ()

C FARM initialization

      DUMMY = FAINIT ()

C Staging

      CALL UTSTIN

C read constants

      CALL ATCONS

C Geant initialization - part I

      CALL GINIT
      CALL HGCONS

C check validity of program arguments

      IF (IBATCH .GT. 1)  CALL MEERRC (1783645,
     +  'ATINIT: parameter BATCH or INTERACTIVE not given')

      END

************************************************************************
* End of ATINIT
************************************************************************
