/*-- Author :    Serguei Moukhine   31/03/98 */

#include <string.h>

void chhtot_ (int *H, char *T, int *N)

/************************************************************************
**
** Description: Copy Hollerith string H (type integer) containing N words
**              into C/C++ text string T (terminated by \0).
**              The rest of H is filled with blank spaces.
**
** Called from: anywhere
**
** External references: strncpy
**
** Argument in/out description
**   H      in     input array.
**   T      out    output string.
**   N      in     dimension of H (in integer words)
**
** Caution: string T must have enough space to keep H without trailing
**          blanks but with terminating \0
** 
************************************************************************/

{
int  sizeOfIn;
int  n;
char *inPtr;

sizeOfIn = *N * sizeof(int);
inPtr    = (char *)H;

/*
** Calculate n of characters to copy
*/

for (n=sizeOfIn; n>=1 && inPtr[n-1] == ' '; n--);

/*
** Copy string
*/

strncpy(T,inPtr,n);
T[n] = '\0';

}
/************************************************************************
** End of CHHTOT
************************************************************************/
