*-- Author :    Hartwig Albrecht   05/03/95

      SUBROUTINE IOOPEN (LUN, COPT, LREC, IOS)

************************************************************************
*
* Description: open data set for LUN or one of the concat. data sets
*
* Called from: anywhere
*
* External references: IOCLOS, IFOPEN
*
* Argument in/out description
*   LUN    in     logical unit number
*   COPT   in     options: for Zebra files: see Zebra manual
*                          for non-Zebra files:
*                          G for Gpack
*                          M for Gpack with shared memory access
*                          I for input
*                          O for output (and not for old !!!)
*                          ON for output on a new file
*   LREC   in     record length for direct access
*                 0 for sequential access
*                 Shared Memory size for GPACK Shared Memory
*   IOS    out    io status
*                 0:  ok
*                 -1: no more data sets
*                 +1: try it once more
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      INTEGER I, IOS, L, LREC, LUN, CHIND1
      CHARACTER COPT*(*), CNEW*8, CMESS*120, CNAM*120, CSTR*80

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      L = LUN
      CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CSTR)

 10   CALL CHHTOC (IQ(HQMEIO_NAME(1,L)), CNAM)
      IF (IMEIO_FLAG(L) .GT. 0)  GO TO 20

      CMESS = 'OPEN: no file given for'
      CALL CHAPBC (CMESS, CSTR)
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL MEERRC (27123946, CMESS)
      IOS = -1
      GO TO 90

 20   IF (IMEIO_FLAG(L) .NE. 1)  GO TO 30
      CMESS = 'open'
      CALL CHAPBC (CMESS(6:), CSTR)
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL CHAPPC (CMESS,':')
      CALL CHAPBC (CMESS, CNAM)
      IF(CSTR(1:4) .EQ. 'READ') THEN
         CALL MESELP (CMESS, 'P')
      ELSE 
         CALL MEWARN (CMESS)
      ENDIF 

      IQ(IQMEIO_CURRENT(LUN)) = L
      IQ(IQMEIO_RLENG(L)) = LREC
      IQ(IQMEIO_FLAG(L)) = 3

      IF( CHIND1(COPT,'L').NE.0)THEN
         CNEW = 'L'
         IF( CHIND1(COPT,'I').NE.0 .AND.
     &       CHIND1(COPT,'O').EQ.0 )THEN
           CALL CHAPPC( CNEW , 'r' )
         ENDIF 
         IF( CHIND1(COPT,'I').NE.0 .AND.
     &       CHIND1(COPT,'O').NE.0 )THEN
           CALL CHAPPC( CNEW , 'r+' )
         ENDIF 
         IF( CHIND1(COPT,'I').EQ.0 .AND.
     &       CHIND1(COPT,'O').NE.0 )THEN
           CALL CHAPPC( CNEW , 'w+' )
         ENDIF 

      ELSE

        CNEW = COPT
        IF (CHIND1 (COPT,'F') .EQ. 0 .AND.
     +      CHIND1 (COPT,'B') .EQ. 0)  THEN
          IF (CHIND1 (COPT, 'A') .NE. 0)  THEN
            CALL CHAPPC (CNEW , 'F')
          ELSE
            CALL CHAPPC( CNEW , 'B' )
          END IF
        END IF

        IF (CHIND1 (COPT, 'N') .NE. 0 .OR.
     +      CHIND1 (COPT, 'X') .NE. 0 .OR.
     +      CHIND1 (COPT, 'L') .NE. 0 .OR.
     +      CHIND1 (COPT, 'G') .NE. 0 .OR.
     +      CHIND1 (COPT, 'M') .NE. 0)  THEN
          I = CHIND1 (COPT,'F')
          IF (I .NE. 0)  THEN
            CALL MEERRC (87344,
     +       'IOOPEN: option F (for fixed) not allowed for Gpack/Zebra')
            COPT(I:I) = ' '
          END IF
          IF (CHIND1 (COPT,'B') .EQ. 0)  CALL CHAPPC (CNEW , 'B')
        END IF

        DO  I = 1, LEN(CNEW)
          IF (CNEW(I:I) .EQ. 'O')  CNEW(I:I) = ' '
        END DO
        IF (CHIND1(COPT,'I') .NE. 0)  THEN
          CALL CHAPPC( CNEW , 'O' )
        ENDIF 

      END IF

      CALL CHCTOH (COPT, IQ(HQMEIO_ZOPTION(1,L)), NMEIO_ZOPTION)

      CALL IFOPEN (LUN, CNAM, CNEW, LREC, IOS, IQ(IQMEIO_CFOPEN(L)))

      IQ(IQMEIO_IOSTAT(L)) = IOS
      IF (IOS .LE. 0)  GO TO 90

 30   IF (IMEIO_FLAG(L) .GT. 3)  GO TO 40

      CMESS = 'OPEN: file'
      CALL CHAPBC (CMESS, CSTR)
      CALL CHAPBC (CMESS, 'already open')
      CALL MEWARN (CMESS)
      IF (IMEIO_CONCAT(L) .EQ. 0)  GO TO 90
      CALL IOCLOS (LUN)
      IOS = 1
      GO TO 90

 40   L = IMEIO_CONCAT(L)
      IF (L .NE. 0)  GO TO 10

      CMESS = 'OPEN: no more files for'
      CALL CHAPBC (CMESS, CSTR)
      CALL CHAPBC (CMESS, 'on')
      CALL CHAPBI (CMESS, LUN)
      CALL MEWARN (CMESS)
      IOS = -1

 90   END

************************************************************************
* End of IOOPEN
************************************************************************
