*-- Author :    Hartwig Albrecht   26/04/95

      SUBROUTINE MMDROP (JL)

************************************************************************
*
* Description: drop table JL
*
* Called from: anywhere
*
* External references: MZDROP
*
* Argument in/out description
*  JL      in     bank address
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/MEMS.fi"

      INTEGER I, IS, IL, JL(1), LOCF
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"

      IL = LOCF (JL) - LARLN1

C inside link area ?

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 80

C a parallel table cannot be dropped

      IF (IMEMO_FLAG(IL) .EQ. -2)  GO TO 70

C drop table JL

      IF (JL(1) .NE. 0)  THEN
        IQ(IQMEMO_DROP(IL)) = IQ(IQMEMO_DROP(IL)) + 1
        CALL MZDROP (IMEMO_DIV(IL), JL(1), ' ')
      END IF

      IF (JL(1) .NE. 0)  THEN
C        C78 = 'MMDROP: non-zero Zebra link for'
C        CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), C4)
C        CALL CH78BC (C4)
C        CALL ME78MC (634135, 10, ILARGEST)

C the next statement may be dangerous but cures one of the evils of Zebra

        JL(1) = 0
      END IF

C drop all subordinate tables

      DO 10 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
        IS = IMEMS_SUB(I)
        IF (JLINK(IS) .NE. 0)  THEN
          CALL MZDROP (IMEMO_DIV(IS), JLINK(IS), ' ')
          IQ(IQMEMO_DROP(IS)) = IQ(IQMEMO_DROP(IS)) + 1
        END IF

        IF (JLINK(IS) .NE. 0)  THEN
C          C78 = 'MMDROP: non-zero Zebra link for'
C          CALL CHHTOC (IQ(HQMEMO_NAME(IS)), C4)
C          CALL CH78BC (C4)
C          CALL ME78MC (634135, 10, ILARGEST)

C the next statement may be dangerous but cures one of the evils of Zebra

          JLINK(IS) = 0
        END IF

 10   CONTINUE

C take care about relations

c      IF (IMEMO_FLAG(IL) .GT. 0)  CALL MMDREL (IL)

c      DO 20 I = IMEMO_SUB1(IL), IMEMO_SUB2(IL)
c        IS = IMEMS_SUB(I)
c        IF (IMEMO_FLAG(IS) .GT. 0)  CALL MMDREL (IS)
c 20   CONTINUE

      GO TO 90

 70   CALL CHHTOC (IQ(HQMEMO_NAME(1,IS)), C4)
      CALL MEERRC (765341,
     +  'MMDROP: table ' // C4 // ' not dropped (parallel table)')
      GO TO 90

 80   CALL MEERRC (47545,
     +  'MMDROP: link JL not inside ARTE link area')

 90   END

************************************************************************
* End of MMDROP
************************************************************************
