*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMOPEN (LUN, IOF, IOS)

************************************************************************
*
* Description: open a file for Zebra I/O
*
* Called from: MMRTAB etc.
*
* External references:
*
* Argument in/out description
*   LUN    in     >0: logical unit
*   IOF    in     -1: only input; 1: only output
*   IOS    out    -1: no more data; 0: ok; never > 0
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, LCUR, IOF, IOS, CHIND1, LREC, NREC, N
      CHARACTER CSTR*80, CMESS*120, COPT*8

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      IOS = 0
      CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CSTR)

      LCUR = LUN
 10   IF (IMEIO_FLAG(LCUR) .GT. 1)  THEN

C Already open ?

      IF (IMEIO_FLAG(LCUR) .EQ. 3 .OR.
     +    IMEIO_FLAG(LCUR) .EQ. 2)  GO TO 90
        LCUR = IMEIO_CONCAT(LCUR)
        IF (LCUR .GT. 0)  GO TO 10

        CMESS = 'MMOPEN: no more files for'
        CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CSTR)
        CALL CHAPBC (CMESS, CSTR)
        CALL CHAPBC (CMESS, 'on')
        CALL CHAPBI (CMESS, LUN)
        CALL MEWARN (CMESS)
        IOS = -1
        GO TO 90
      END IF

C file foreseen for Arte input/output ?

      IF (HMEIO_BIT(LUN) .EQ. 0 .AND. LUN .NE. LNOTEO)  THEN
        C78 = 'MMOPEN: no Arte table flagged for i/o '
        CALL CH78BC (CSTR)
        CALL CH78BC ('on')
        CALL CH78BI (LUN)
        CALL ME78EC (672346)
        GO TO 90
      END IF

      CALL CHHTOC (IQ(HQMEIO_ZOPTION(1,LCUR)), COPT)

C which data format ?

      N = 0
      IF (CHIND1 (COPT, 'N') .NE. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 1
      END IF
      IF (CHIND1 (COPT, 'A') .NE. 0 .AND.
     +    CHIND1 (COPT, 'L') .EQ. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 1
      END IF
      IF (CHIND1 (COPT, 'X') .NE. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 1
      END IF
      IF (CHIND1 (COPT, 'L') .NE. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 1
      END IF
      IF (CHIND1 (COPT, 'G') .NE. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 2
      END IF
      IF (CHIND1 (COPT, 'M') .NE. 0)  THEN
        N = N + 1
        IQ(IQMEIO_PACK(LCUR)) = 2
      END IF
      IF (N .GT. 1)  CALL MEERRC (684355,
     +  'OPEN: the format specifiers NAXLGM are mutually exclusive')

      IF (N .EQ. 0)  THEN
        CALL MEERRC (346345,
     +     'OPEN: no data format (one of GMNXLA) specified')
        IQ(IQMEIO_PACK(LCUR)) = 2
        CALL CHAPPC (COPT, 'G')            
      END IF

      IF (IOF .LE. 0 .AND. CHIND1 (COPT, 'I') .EQ. 0)
     +  CALL CHAPPC (COPT, 'I')
      IF (IOF .GE. 0 .AND. CHIND1 (COPT, 'O') .EQ. 0)
     +  CALL CHAPPC (COPT, 'O')

C Gpack io

      NREC = LREC
      IF (IMEIO_PACK(LCUR) .EQ. 2) THEN
        IF( CHIND1(COPT, 'M'). NE. 0)                 ! if Shared Memory
     +    NREC = FMEIO_MAXOUT(LCUR) * 1024 * 1024     ! use File Length
        CALL GARTSETGPACK(LUN)
      ENDIF

C Fortran/C/GPACK OPEN (IOS < 0: no more files; >0: next attempt

      CALL IOOPEN (LUN, COPT, NREC, IOS)
      IF (LCUR .NE. IMEIO_CURRENT(LUN))  CALL MEERRC (6753457,
     +  'MMOPEN: wrong concatenation of files. Ask expert')

      IF (IOS .LT. 0)  GO TO 90
      IF (IOS .GT. 0)  GO TO 10

C Zebra file initialization:

      IF ( IMEIO_PACK(LCUR) .EQ. 1)  THEN
        IF( CHIND1(COPT, 'L'). EQ. 0)  THEN
          CALL FZFILE ( LUN ,   0 , COPT)
        ELSE
          IQUEST(1) = IMEIO_CFOPEN(LCUR)
          IF( IQUEST(1) .LE. 0 )THEN
            C78='MMOPEN: error FZFILE for C-input/output'
            CALL CH78CC('IQUEST(1)=')
            CALL CH78AI( IQUEST(1)  )
            CALL CH78CC( 'LUN='     ) 
            CALL CH78AI(  LUN       )
            CALL ME78EC (6356)
            CALL IOCLOS(  LUN       ) 
            GO TO 10          
          ENDIF 
          CALL FZFILE (LUN, 0, COPT) 
        ENDIF 

C error from FZFILE?

        IF (IQUEST(1) .EQ. 0)  GO TO 30
        C78 = 'MMOPEN: FZFILE returns IQUEST(1) ='
        CALL CH78BI (IQUEST(1))
        CALL ME78EC (92)
        CALL IOCLOS (LCUR)
        GO TO 10
      END IF

 30   IF (FMEIO_MAXOUT(LCUR) .NE. 0) THEN
        IF (IMEIO_PACK(LCUR) .EQ. 1)
     +    CALL FZLIMI (LCUR, FMEIO_MAXOUT(LCUR) / 4.)
        IF (IMEIO_PACK(LCUR) .EQ. 2)
     +    CALL GARTLIMI (LCUR, FMEIO_MAXOUT(LCUR))
      END IF

 90   END

************************************************************************
* End of MMOPEN
************************************************************************
