//                              -*- Mode: C++ -*-
//: CmdCareLambda.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCARELAMBDA_HH_
#define CMDCARELAMBDA_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"

/*
CLASS
  CmdCareLambda
  Class to deal with the care/lambda kuip command
*/

class CmdCareLambda : public CmdBase {
public:
  //-- Constructors
  CmdCareLambda();
  //-- Destructor
  // Destructor: currently void
  virtual ~CmdCareLambda();
  
  //-- Behavioural operations
  //   Reset stored data to default values
  virtual void defValues();
  //--
  //   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  //   Read acommand from external
  virtual void read();
# endif
  //--
  //   Dump internal data
  virtual void dump();

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  SubCal subcal;
  float  lambda;
};

#endif  //   CMDCARELAMBDA_HH_
