//                              -*- Mode: C++ -*-
//: CmdCareShowDcal.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 10/12/98
// Last Update ........
//

#ifndef CMDCARESHOWDCAL_HH_
#define CMDCARESHOWDCAL_HH_

#include "care/CmdBase.hh" 


/**
class  CmdCareShowDcal.
  Class to deal with the care/showdcal kuip command
  It shows in a formatted way the contents of the
  DCAL bank
*/

class CmdCareShowDcal : public CmdBase {
public:
  /// Constructor
  CmdCareShowDcal();
  //-- Destructor
  /// Destructor: currently void
  virtual ~CmdCareShowDcal();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  ///   Read a command from external
  virtual void read();
# endif
  //--
  //    Dump internal data
  virtual void dump();

private:
  ///////////////////// Data Part /////////////////////////////////
  int start;
  int end;
};

#endif  //   CMDCARESHOWDCAL_HH_

