#ifndef _ECHF_status_hh_
#define _ECHF_status_hh_


struct Echfs
{
  enum ECStat {
    /* bits 0-7 general usage */
    /* binary values:      ON(1)/ OFF(0) */
    usable  =        0x1, /* Use/Do not use this channel in reconstruction */
    readout =        0x2, /* Channel Read-out/not read from front end boards */
    pretrig =        0x4, /* Channel used/not used for pretrigger */
    noisy   =        0x8, /* Channel noisy/not noisy */
    pmon    =       0x10, /* PM of the channel ON/OFF */
    bit5    =       0x20, /* not assigned yet =first bit is bit0,*/
    bit6    =       0x40, /* not assigned yet =first bit is bit0,*/
    bit7    =       0x80, /* not assigned yet =first bit is bit0,*/

    /* bits 8-15: calibration methods currently used */
    daqu    =      0x100, /* DAQ info used/not used */
    slopesu =      0x200, /* calib with slopes used/not used */
    integru =      0x400, /* calib with integral used/not used */
    mip1u   =      0x800, /* MIP standalone calib. used/not used */
    mip2u   =     0x1000, /* MIP with tracks calib used/not used */
    pizerou =     0x2000, /* calib with neutral pions used/not used */
    eoverpu =     0x4000, /* calib with E/P methods */
    bit15   =     0x8000, /* not assigned yet =first bit is bit0,*/
    usedcal =     0xFF00, /* all used calibration methods */

    /* bits 16-23: calibration methods currently available */
    daqa    =    0x10000, /* DAQ info aval/not aval */
    slopesa =    0x20000, /* calib with slopes aval/not aval */
    integra =    0x40000, /* calib with integral aval/not aval */
    mip1a   =    0x80000, /* MIP standalone calib. aval/not aval */
    mip2a   =   0x100000, /* MIP with tracks calib aval/not aval */
    pizeroa =   0x200000, /* calib with neutral pions aval/not aval */
    eoverpa =   0x400000, /* calib with E/P methods aval/not aval */
    bit24   =   0x800000, /* not assigned yet =first bit is bit0,*/
    avalcal =   0xFF0000, /* all available calibration methods */

    /* other spare bits */
    bit25   =  0x2000000, /* not assigned yet =first bit is bit0,*/
    bit26   =  0x4000000, /* not assigned yet =first bit is bit0,*/
    bit27   =  0x8000000, /* not assigned yet =first bit is bit0,*/
    bit28   = 0x10000000, /* not assigned yet =first bit is bit0,*/
    bit29   = 0x20000000, /* not assigned yet =first bit is bit0,*/
    bit30   = 0x40000000, /* not assigned yet =first bit is bit0,*/
    bitsign = 0x80000000  /* Do not use sign bit to avoid complications*/
  };
};


#endif
