        integer function otrsec(imod,x,y,nsec)
******************************************************************
*
* Returns sector number for OTR
*
* Parameters:
*   imod   - number of this module type (index in tables of otrgeo.fi)
*   x      - X coordinate of the GEDE center
*   y      - Y coordinate of the GEDE center
*   nsec   - number of sectors in this module
*
* Author: Alexander Lanyov, Mar 1999.
*
******************************************************************
        implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGMOTH.fi"
#include "gean/otrgeo.fi"

        logical diam10
        integer imod,nsec
        real x,y
        character*4 slnam

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c First set up logical variable showing whether we are in "10-mm region".
c For MC chambers these include also some of 5-mm chambers.

        diam10 = otdiam(imod) .eq. 1.
     @           .or. (cotnam(imod)(:3).eq.'mc5' .and. abs(x).gt.55.2)
     @           .or. (cotnam(imod)(:3).eq.'mc6' .and. abs(x).gt.53.6)
     @           .or. (cotnam(imod)(:3).eq.'mc8' .and. abs(x).gt.55.7)

        if (diam10) then                   ! 10 mm tubes
           if (ignore_g10(imod) .or. nsec.eq.1) then  ! 10 mm through whole length
              if (x.gt.0) then
                 otrsec = 11
              else
                 otrsec = 12
              end if
           else                            ! 10 mm cutted in the middle
              if (x.gt.0) then
                 if (y.gt.0) then
                    otrsec = 7
                 else
                    otrsec = 8
                 end if
              else
                 if (y.gt.0) then
                    otrsec = 9
                 else
                    otrsec = 10
                 end if
              end if
           end if
        else                             ! 5 mm
           if (y .gt. 20.5) then
              otrsec = 1
           else if (y .gt. 0.) then
              if (x .ge. 0.) then
                 otrsec = 3
              else
                 otrsec = 5
              end if
           else if (y .gt. -20.5) then
              if (x .ge. 0.) then
                 otrsec = 4
              else
                 otrsec = 6
              end if
           else
              otrsec = 2
           end if
        end if

        return
        end
