
      SUBROUTINE SZ2G96(ISL)

************************************************************************
*
* SZ2G96
* written by Siegmund Nowak, 01/07/96
*
* This routines generates the geometry for the 'PK's scint hodoscope
*
*       called from GEOMAIN
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*    ISL      in          superlayer number in NESL table 
*************************************************************************

      IMPLICIT NONE

      INTEGER I,IVOL,IVOLC,IROT,ISET,IDET,MEDNUM,ISL
      REAL PAR(3),PARA(8),XMSC,XMSG,XMSP
      REAL XPOS,YPOS,ZPOS, DXSC, DYSC, DZSC 
      REAL DXSG , DYSG , DZSG , DRSP , DZSP, PXSC(4), PYSC(4), PZSC(4)
      CHARACTER*4 CSL
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA DXSC /36./, DYSC /3.0/, DZSC /1.0/
      DATA DXSG / 7./, DYSG /3.0/, DZSG /1.0/
      DATA DRSP /2.85/,DZSP /10./
      DATA PXSC /   -3.,     .5,   1.1,    0./,
     +     PYSC /  12.5,   -8.2,  -8.8,  -7.9/,
     +     PZSC /  -56.,   -56.,  -24.,   63./
#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     install rotation matrices  
      CALL CRROTM(IROT,180.,0, 90.,90.,90.,0.)

c     install superlayer volume for the P.K. counter
      CURRSL = ISL
      CALL UHTOC(HNESL_NAME(ISL),4,CSL,4)
      IF(INESL_MFL(ISL).EQ.0) THEN
         CALL CGGESL(CSL,'MOTH',0)
      ELSE
         CALL CGGESL(CSL,'MAGN',0)
      ENDIF

c     horizontal counter
      PAR(1) = .5* DXSC
      PAR(2) = .5* DYSC
      PAR(3) = .5* DZSC
      CALL GSVOLU('SZ2C', 'BOX ', MEDNUM(3,'LUCITE'),PAR,3,IVOLC)
      CALL GSATT('SZ2C','COLO',4)
      CALL GRADLN(IVOLC,XMSC)
      XMSC = DZSC/XMSC

c     light guide
      PAR(1) = .5* DXSG
      PAR(2) = .5* DYSG
      PAR(3) = .5* DZSG
      CALL GSVOLU('SZ2G', 'BOX ', MEDNUM(1,'LUCITE'),PAR,3,IVOL)
      CALL GSATT('SZ2G','COLO',110)
      CALL GRADLN(IVOL,XMSG)
      XMSG = DZSC/XMSG

c     photomultiplier
      PAR(1) = 0.
      PAR(2) = DRSP
      PAR(3) = .5*DZSP
      CALL GSVOLU('SZ2P', 'TUBE', MEDNUM(1,'ALUMINIUM'),PAR,3,IVOL)
      CALL GRADLN(IVOL,XMSP)
      XMSP = DRSP/XMSP

      DO I=1,4
       XPOS =  PXSC(I) 
       YPOS =  PYSC(I) 
       ZPOS =  PZSC(I) 

       CALL GSPOS('SZ2C',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,0,'ONLY')
       PARA(1) = XPOS - .5*DXSC + 0.5*(FNESL_X1(ISL)+FNESL_X2(ISL))
       PARA(2) = XPOS + .5*DXSC + 0.5*(FNESL_X1(ISL)+FNESL_X2(ISL))
       PARA(3) = YPOS - .5*DYSC + 0.5*(FNESL_Y1(ISL)+FNESL_Y2(ISL))
       PARA(4) = YPOS + .5*DYSC + 0.5*(FNESL_Y1(ISL)+FNESL_Y2(ISL))
       PARA(5) = ZPOS - .5*DZSC + 0.5*(FNESL_Z1(ISL)+FNESL_Z2(ISL))
       PARA(6) = ZPOS + .5*DZSC + 0.5*(FNESL_Z1(ISL)+FNESL_Z2(ISL))
       CALL CRGCAL(1,IVOLC,PARA)
       IQ(IQGCAL_NCL_L()) = I
       IQ(IQGCAL_SEC_L()) = 1
       Q(QGCAL_EFF_L()) = 1.
       Q(QGCAL_MS_L())= XMSC*(.0136*(1.+.038*ALOG(XMSC)))**2

       XPOS = XPOS + .5*(DXSC+DXSG)
       CALL GSPOS('SZ2G',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,0,'ONLY')
       XPOS = XPOS + .5*(DXSG+DZSP)
       CALL GSPOS('SZ2P',NGCAL()+1,CSL,XPOS, YPOS,ZPOS,IROT,'ONLY')
      ENDDO

      CALL GSDET(CSL,'SZ2C',1,'SZ2C',5,LGESL_HOD3,50,20,ISET,IDET)

      RETURN
      END




