#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <vector.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/zgeom.h"
#include "gean/gclink.h"

 
extern "C" {
    int mednum_(int&,const char*,int);
    void gsvolu_(char*, char*, int*, float [], int*, int*);
    void gsatt_(char*,char*,int*); }

void zgcal::fin() {   
       extern vector<hgcal> *hg_cal;
       for(unsigned int i = 0; i<hg_cal->size();i++){
	  vector<hgcal>::iterator cal = hg_cal->begin() + i;
          delete [] cal->pt_castru;
       }
       delete hg_cal;
}

  
void zgcal::Set_default() {
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       memset(cal,0,sizeof(hgcal));
//    ************* default values **********************************   
      cal->ncalx = cal->ncaly = 1;
      cal->caba_size = 11.15; 
      cal->zcal[0] = cal->zcal[1] = cal->zcal[2] = 0.;   
      cal->zwall[0] = cal->zwall[1] = cal->zwall[2] = 0.;   
      cal->zwall[3] = cal->zwall[4] = cal->zwall[5] = 0.;   
      cal->dzwall[0] = cal->dzwall[1] = cal->dzwall[2] = 0.;   
      cal->dzwall[3] = cal->dzwall[4] = cal->dzwall[5] = 0.;   
//    ************* end of default values ***************************
}

void zgcal::Read_calsubgroup() { 
       extern vector<hgcal> *hg_cal;
       hgcal cal;
       memset(&cal,'0',sizeof(hgcal));
       hg_cal->push_back(cal); 
}     

void zgcal::Read_ncal(char *card) { 
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int nitem=sscanf(card,"%d %d",&cal->ncalx,&cal->ncaly);
       if(nitem!=2) { 
         arteMsg <<"zgcal: Check ncal ";  arteMsg.error();
       }
}
 
void zgcal::Read_poscal(char *card) {
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;      
       int nitem=sscanf(card,"%f %f",&cal->cal_xmin,&cal->cal_xmax); 
       if (nitem!=2) {
         arteMsg <<"zgcal: Check cal_xmin/cal_xmax "; arteMsg.error();
       } 
       card+=itemlength(card,nitem);
       nitem=sscanf(card,"%f %f",&cal->cal_ymin,&cal->cal_ymax); 
       if (nitem!=2) {
          arteMsg <<"zgcal: Check cal_ymin/cal_ymax ";  arteMsg.error();
      }
}

void zgcal::Read_caba_size(char *card) { 
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int nitem=sscanf(card,"%f",&cal->caba_size); 
       if (nitem!=1) { 
          arteMsg <<"zgcal: Check caba_size ";  arteMsg.error();
      }
}

void zgcal::Read_zcal(char *card) {      
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int j=0, nitem=1;
       while (nitem > 0  && j < 3)  {    
         nitem=sscanf(card,"%f",&cal->zcal[j]); 
         if (nitem!=1) { 
            arteMsg <<"zgcal: Check zcal ";   arteMsg.error();    
	  }
         card+=itemlength(card,nitem);
         j = j+1;              
      }  
} 

void zgcal::Read_zcwall(char *card) {      
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int j=0, nitem=1;
       while (nitem > 0  && j < 6)  {
         nitem=sscanf(card,"%f",&cal->zwall[j]); 
         if (nitem!=1) {
            arteMsg <<"zgcal: Check zcwall ";     arteMsg.error();
	 }
         card+=itemlength(card,nitem);
         j = j+1;            } 
}

void zgcal::Read_dzwall(char *card) { 
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int j=0, nitem=1;
       while (nitem > 0  && j < 6)  {
         nitem=sscanf(card,"%f",&cal->dzwall[j]); 
         card+=itemlength(card,nitem);
         j = j+1;            }  
}   
     
void zgcal::Read_cast(char *card, FILE *filepointer) { 
       char tags[61], buffer[256]; 
       extern vector<hgcal> *hg_cal;
       vector<hgcal>::iterator cal = hg_cal->begin() + hg_cal->size() -1;
       int castlen = cal->ncalx*cal->ncaly +1 ;
       cal->pt_castru = new char[castlen];
       memset(cal->pt_castru,' ',castlen);
       int nitem=sscanf(card,"%s",tags);
       tags[cal->ncalx] ='\0'; 
       int j = 1;
       strcpy(cal->pt_castru,tags);
       while (j < cal->ncaly) {
         if(fgets(buffer,256,filepointer) == NULL) {
            arteMsg <<"zgcal: Check cast ";  arteMsg.error();
	  }
         else  {
           card=&buffer[0];
           nitem=sscanf(card,"%s",tags);
           tags[cal->ncalx] = '\0';
           strcat(cal->pt_castru,tags);
           j = j+1; 
         }
       }  
} 







