*CMZ :          24/03/96  13.08.13  by  Hartwig Albrecht
*CMZ :  2.01/01 25/10/95  15.59.46  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   13/09/95

      REAL FUNCTION RLU (DUMMY)

************************************************************************
*
* Description: Random number generator for LUND: RANECU (CERNLIB V114)
*              RANECU has been chosen in order to be consistent with
*              GEANT. (Lund recommends RANMAR which is somewhat clumsy).
*
*              RLUNEW has to be called for every new seed
*
* Called from: LUND
*
* External references: RANECU
*
* Argument in/out description
*  INEW    in     ne 0: start a new series of randum numbers
*
************************************************************************

      IMPLICIT NONE
      INTEGER DUMMY

#include "jets/LUDATR.fi"

      INTEGER INEW
      DATA INEW /1/
      SAVE INEW

      IF (INEW .NE. 0)  THEN
        MRLU(1) = 100
        INEW = 0
      END IF

      IF (MRLU(1) .GE. 100)  THEN
        CALL RANECU (RRLU, 100, 1)
        MRLU(1) = 1
        RLU = RRLU(1)
      ELSE
        MRLU(1) = MRLU(1) + 1
        RLU = RRLU(MRLU(1))
      END IF

      END

************************************************************************
* End of RLU
************************************************************************
