*-- Author :    Hartwig Albrecht   19/10/95
*-- modified by Thomas Lohse       March 8, 1999
      SUBROUTINE KALUND

************************************************************************
*
* Description: LUND command
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/TOPP.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"
#include "pyth/PYINT2.fi"

      INTEGER L, TPNAM1
      integer mes_id_1, mes_id_2, mes_id_3, mes_id_4
      CHARACTER*12 CH

      save mes_id_1, mes_id_2, mes_id_3, mes_id_4

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

C Lund initialization:

      IF (FIOMIX(5) .NE. 0.)  CALL MEERRC (mes_id_1,
     +  'IOMIX and LUND commands are mutually exclusive')
      IF (LUNDINIT .NE. 1)  THEN
        CALL ALTOPP
        CALL ALTDEC
        LUNDINIT = 1
      END IF

      FIOMIX(1) = 1.
      FIOMIX(2) = 0.
      FIOMIX(3) = 0.
      FIOMIX(4) = 0.
      FIOMIX(5) = 0.

      CALL KUGETC (CH, L)

      IF (CH(1:2) .EQ. 'CC')  THEN
        MSEL = 4
      ELSE IF (CH(1:2) .EQ. 'BB')  THEN
        MSEL = 5
      ELSE IF (CH(1:2) .EQ. 'IN')  THEN
        MSEL = 1
      ELSE IF (CH(1:1) .EQ. 'J')   THEN
        MSEL = 0
        MSUB(86) = 1
        MSUB(87) = 1
        MSUB(88) = 1
        MSUB(89) = 1
      ELSE IF (CH(1:1) .EQ. 'U')   THEN
        MSEL = 0
        MSUB(86) = 1
        MSUB(87) = 1
        MSUB(88) = 1
        MSUB(89) = 1
        KFPR(86,1) = 553
        KFPR(87,1) = 10551
        KFPR(88,1) = 20553
        KFPR(89,1) = 555
      ELSE
        MSEL = 1
        CALL MEERRC (mes_id_2,
     +   'LUND: phys. process must be one of cc, bb, inel, Jpsi, Upsi')
      END IF

      CALL KUGETC (CH, L)
      IF (L .NE. 0 .AND. CH(1:2) .NE. 'IN')  THEN
        CALL MEERRC (mes_id_3,
     +    'LUND: 2nd phys. process must be inelastic')
        GO TO 90
      END IF

      CALL KUGETR (FIOMIX(2))
      IF (L .EQ. 0)  FIOMIX(2) = 0.

      LUNDRPART = 0
      call KUGETS (CH, L)
      IF (L .NE. 0)  THEN
        LUNDRPART = TPNAM1 (CH)
        IF (LUNDRPART .NE. 0)  THEN
          LUNDRPART = ITOPP_LUND(LUNDRPART)
        ELSE
          CALL MEERRC(mes_id_4, 'LUND: required particle is unknown')
        END IF
      END IF

 90   END

************************************************************************
* End of KALUND
************************************************************************
