  
* routine to add a pad to the HITB table
* made by Boris Fominykh 15.03.1999
* bug correction 20.04.1999 by Boris Fominykh

      SUBROUTINE MUADDP(IV,NPAD)
C+    ==========================

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"

      INTEGER IV,NPAD,FLAG,NPMX,NROW,NPD,IUD
      REAL XD1,XD2,YD1,YD2,YS1,YS2,XL1,XL2,YL1,YL2,ALSX,ALSY
      REAL XPAD,YPAD,ZPAD,ZD1,ZD2,DXPAD,DYPAD,DYPD1,DYPD2,DYPD3

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
C     -------------------
* input control
      IF(IV.LE.0.OR.IV.GT.IQ(JGEDE+2)) RETURN

* number of pads in row
      NPMX =IGEDE_NWI(3,IV)
      IF(NPAD.LT.0.OR.NPAD.GT.2*NPMX-1) RETURN
      NROW =NPAD/NPMX
      NPD  =NPAD-NROW*NPMX

* chamber coordinates
      XD1 =  FGEDE_XMIN(IV)    ! x of left corner
      XD2 =  FGEDE_XMAX(IV)    ! x of right corner
      YD1 =  FGEDE_YMIN(IV)    ! y of low edge
      YD2 =  FGEDE_YMAX(IV)    ! y of upper edge
      ZD1 =  FGEDE_ZMIN(IV)    ! z of low edge
      ZD2 =  FGEDE_ZMAX(IV)    ! z of upper edge
      YS1 =  FGEDE_SYMN(IV)    ! Ymin of sensitive volume
      YS2 =  FGEDE_SYMX(IV)    ! Ymax of sensitive volume
* up or down 
      IF(ABS(YD1).GT.ABS(YD2)) THEN
        IUD = 1
      ELSE
        IUD = 0
      ENDIF
      YL2  =0.01*REAL(IGEDE_NWI(4,IV)) ! y-dist between pads
      DXPAD=FGEDE_XFW(2,IV)            ! x-size of pad
      DYPD1=FGEDE_XFW(3,IV)            ! y-size of first pad
      DYPD2=FGEDE_XFW(4,IV)            ! y-size of standard pad
      ZPAD =FGEDE_ZFW(2,IV)            ! z-position of pad
      ALSX =FGEDE_SXMX(IV)-FGEDE_SXMN(IV)
      XL1  =(XD2-XD1-ALSX)/2.  ! x-dist from edge to pad
      XL2  =(ALSX-2.*DXPAD)    ! x-dist between pads
      ALSY =YS2-YS1
      YL1  =(YD2-YD1-ALSY)/2.  ! y-dist from edge to pad
* y-size of last pad
      DYPD3=ALSY-DYPD1-YL2-(DYPD2+YL2)*REAL(NPMX-2)
* the pad position and size
      IF(NROW.EQ.0) XPAD=XD1+XL1+DXPAD*.5
      IF(NROW.EQ.1) XPAD=XD2-XL1-DXPAD*.5
      DYPAD=0.
      IF(NPD.EQ.0) THEN
        IF(IUD.EQ.0) YPAD=YD1+YL1+0.5*DYPD1
        IF(IUD.EQ.1) YPAD=YD2-YL1-0.5*DYPD1
        DYPAD=DYPD1
      ENDIF
      IF(NPD.GT.0.AND.NPD.LT.NPMX-1) THEN
        IF(IUD.EQ.0) 
     + YPAD=YD1+YL1+DYPD1+YL2+(DYPD2+YL2)*REAL(NPD-1)+0.5*DYPD2
        IF(IUD.EQ.1) 
     + YPAD=YD2-YL1-DYPD1-YL2-(DYPD2+YL2)*REAL(NPD-1)-0.5*DYPD2
        DYPAD=DYPD2
      ENDIF
      IF(NPD.EQ.NPMX-1) THEN
        IF(IUD.EQ.0) YPAD=YD2-YL1-0.5*DYPD3
        IF(IUD.EQ.1) YPAD=YD1+YL1+0.5*DYPD3
        DYPAD=DYPD3
      ENDIF
* fix the first entry per volume
      FLAG=0
      IF(IGEDE_HIT1(IV).GT.IGEDE_HITL(IV)) FLAG=1
* book the new entry
      CALL MMBOOK(JHITB,1)
* check that HITB exists
      IF(JHITB.LE.0) RETURN
      IF(FLAG.EQ.1) IQ(IQGEDE_HIT1(IV)) = IQ(JHITB+2)

      IF(XPAD.LT.XD1.OR.XPAD.GT.XD2) 
     *  print*,'muaddp: wrong X ',XD1,XPAD,XD2,' IV,NPAD ',IV,NPAD
      IF(YPAD.LT.YD1.OR.YPAD.GT.YD2) 
     *  print*,'muaddp: wrong Y ',YD1,YPAD,YD2,' IV,NPAD ',IV,NPAD
      IF(ZPAD.LT.ZD1.OR.ZPAD.GT.ZD2) 
     *  print*,'muaddp: wrong Z ',ZD1,ZPAD,ZD2,' IV,NPAD ',IV,NPAD

CC      print*,'muaddp: added the pad X,Y,Z ',XPAD,YPAD,ZPAD,
CC     +         ' dX,dY ',DXPAD,DYPAD,' IV ',IV,' NPAD,NPD ',NPAD,NPD

      Q(QHITB_X_L())      =  XPAD
      Q(QHITB_Y_L())      =  YPAD
      Q(QHITB_Z_L())      =  ZPAD
      Q(QHITB_Q_L())      =  DXPAD
      Q(QHITB_R_L())      =  DYPAD
      IQ(IQHITB_GEDE_L()) = IV
      IQ(IQGEDE_HITL(IV)) = IQ(JHITB+2)

      RETURN
      END
