*
* B.Fominykh  28.05.97
*
* calculation of multiple scattering error
*
      SUBROUTINE MURMSC(Z1,Z2,ERMSC1,ERMSC2,THETS)
C-    ============================================
* input:  Z1    - pointer to cluster with larger Z
*         Z2    - pointer to cluster with small Z
* 0utput: ERMSC1 - total error for cluster 1 (incl. calo)
*         ERMSC2 - error for scat. between clusters 1 and 2
*         THETS  - total angle error for cluster 1
*
* middle z-position of muon chambers
      REAL ZCH(4)
* geometry of muon shield
      REAL ZSH(4),DZSH(4),XSH(4),DXSH(4),YSH(4),DYSH(4)
* middle z-position and rad length of calorimeter
      REAL ZCAL,RLCAL
* rad length of iron in cm
      REAL RL_IRON
*
      INTEGER IS
      REAL CST,THET,ER,ER2,ERMSC1,ERMSC2,Z1,Z2,ZF,X,Y,Z,RL
      REAL THETS,WW,RW
#include "murec/MUCKALF.fi"
#include "murec/MUCPAR.fi"
#include "murec/MUCTAB.fi"
#include "arte/Arte.fi"
      DATA ZCH / 1630.5, 1743.6, 1877.9, 1892.7 /
      DATA ZSH / 1490., 1650., 1770., 1905. /
      DATA DZSH/ 121.5,  88.5,   99.,    5. /
      DATA XSH / -375., -399., -420., -200. /
      DATA DXSH/ 741.7,  798.,  840.,  400. /
      DATA YSH / -256., -279., -294., -150. /
      DATA DYSH/  521.,  567.,  596.,  300. /
      DATA ZCAL /1331./, RLCAL /20./
      DATA RL_IRON / 1.76 /
#include "arte/Arte.ff"
C*     -------------------------------
*
      ERMSC1=0.
      ERMSC2=0.
      THETS =0.
      IF(DABS(PARAM(4)).GT.1000.) GOTO 200
      IF(DABS(PARAM(5)).GT.1000.) GOTO 200
      CST=1./SQRT(1.+PARAM(4)**2+PARAM(5)**2)
      ER =0.
      ER2=0.
* momentum
      TN=DSQRT(PARAM(2)**2+PARAM(3)**2)/PARAM(1)
      P=150.
      IF(TN.GT.0.01) P=1.2/(TN-0.007)+1.
*
* the contribution of calorimeter
***      IF(PARAM(1).LT.ZCAL) THEN
      THET=13.6/1000./P*SQRT(RLCAL/CST)*
     +        (1.+0.038*ALOG(RLCAL/CST))
      ER=ER+((Z1-ZCAL)*THET)**2/3.
      THETS=THETS+THET**2
***      ENDIF
* loops over muon shields
      DO 20 IS=1,4
        ZF=ZSH(IS)+DZSH(IS)
        IF(Z1.LT.ZF) GOTO 20
        Z=ZSH(IS)+0.5*DZSH(IS)
        X=PARAM(4)*(Z-PARAM(1))+PARAM(2)
        IF(X.LT.XSH(IS)) GOTO 20
        IF(X.GT.XSH(IS)+DXSH(IS)) GOTO 20
        Y=PARAM(5)*(Z-PARAM(1))+PARAM(3)
        IF(Y.LT.YSH(IS)) GOTO 20
        IF(Y.GT.YSH(IS)+DYSH(IS)) GOTO 20
        RL=DZSH(IS)/RL_IRON/CST        
        THET=13.6/1000./P*SQRT(RL)*
     +              (1.+0.038*ALOG(RL))
        ER=ER+((Z1-ZSH(IS))*THET)**2/3.
        THETS=THETS+THET**2
        IF(Z2.LT.ZSH(IS)) THEN
          ER2=ER2+((Z1-ZSH(IS))*THET)**2/3.
        ENDIF
  20  CONTINUE
  21  ERMSC1=SQRT(ER)
      ERMSC2=SQRT(ER2)
*
  200 CONTINUE
      RETURN
      END
