// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include <math.h>
#include "arte/arte.hh"
#include "rang/Thin.hh"
#include "rang/zfpar.hh"
#include "rang/utfeld.hh"
#include "rang/RadEl.hh"
#include "rang/ParticleType.hh"

void rangerThin::processNoise(rangerParticleType pType) {

  rangerScatThin scat( ms(), state->qPEst(),
		       state->tx(),
		       state->ty());

  state->applyScat( scat );

  if (pType == ELECTRON) {
    rangerRadEl rad( radiationThickness(), state->qP() );
    state->applyRadEl( rad );
  }
  state->applyDeDx( radiationThickness() );
}


void rangerThin::predProcessNoise(rangerParticleType pType) {

//   double sqxy = sqrt(1 + predictedState->tx() * predictedState->tx() 
// 		     + predictedState->ty() * predictedState->ty());
                                 // traversed distance in medium correction

  rangerScatThin scat( ms(), predictedState->qPEst(),
		       predictedState->tx(),
		       predictedState->ty());

  predictedState->applyScat( scat );

  if (pType == ELECTRON) {
    rangerRadEl rad( radiationThickness(), predictedState->qP() );
    predictedState->applyRadEl( rad );
  }

  predictedState->applyDeDx( radiationThickEff() );

#ifdef FULL
  cout << "rangerThin::processNoise: correction applied, cov matrix is now "
       << state->cov() << endl;
#endif
}
