*-- Author :    Rainer Mankel   28/09/95

      subroutine dmnav()

*     **** set up domain layer navigation table
      implicit none

#include "rang/zdomain.fi"
#include "rang/zdomdir.fi"
#include "rang/zfout.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
      integer max_nav
      parameter (max_nav=9)
      integer start_domain, start_sector, window, nav, target_domain,
     +    ii, target_sector, target_window

      integer nav_sect(max_nav,max_sector_dm)
      data nav_sect /
     +    1, 9, 7, 3, 5,19,20,13,14,       ! outer tracker
     +    2, 8,10, 4, 6,17,18,15,16,
     +    3, 7,14, 4, 1, 0, 0, 0, 0,
     +    4, 8,16, 3, 2, 0, 0, 0, 0,
     +    5, 9,19, 6, 1, 0, 0, 0, 0,
     +    6,10,17, 5, 2, 0, 0, 0, 0,
     +    7, 1, 3,11, 8, 4, 0, 0, 0,
     +    8, 2, 4,11, 7, 3, 0, 0, 0,
     +    9, 1, 5,12,10, 6, 0, 0, 0,
     +   10, 2, 6,12, 9, 5, 0, 0, 0,
     +   11, 7, 8, 0, 0, 0, 0, 0, 0,
     +   12, 9,10, 0, 0, 0, 0, 0, 0,
     +   13,14,20, 1,21,22, 0, 0, 0,       ! MSGC
     +   14, 3,13, 1,20,16, 4,21,22,
     +   15,16,18, 2,23,22, 0, 0, 0,
     +   16, 4,15, 2,18,14, 3,22,23,
     +   17, 6,18, 2,15,19, 5,23,24,
     +   18,15,17, 2,23,24, 0, 0, 0,
     +   19, 5,20, 1,13,17, 6,24,21,
     +   20,13,19, 1,21,24, 0, 0, 0,
     +   21, 0, 0, 0, 0, 0, 0, 0, 0,       ! main tracker Si
     +   22, 0, 0, 0, 0, 0, 0, 0, 0,
     +   23, 0, 0, 0, 0, 0, 0, 0, 0,
     +   24, 0, 0, 0, 0, 0, 0, 0, 0,
     +   25, 0, 0, 0, 0, 0, 0, 0, 0,
     +   26, 0, 0, 0, 0, 0, 0, 0, 0,
     +   27, 0, 0, 0, 0, 0, 0, 0, 0,
     +   28, 0, 0, 0, 0, 0, 0, 0, 0,
     +   29,30,32, 0, 0, 0, 0, 0, 0,       ! VD Si
     +   30,29,31, 0, 0, 0, 0, 0, 0,
     +   31,30,32, 0, 0, 0, 0, 0, 0,
     +   32,31,29, 0, 0, 0, 0, 0, 0/
      save nav_sect
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      n_dn = 0           ! reset domain window navigation table

      do window=1,n_dw   ! loop over domain windows
       start_domain = domain_dw(window)
       start_sector = secshad_dw(window)

       nnavf_dw(window) = 0
       nnavb_dw(window) = 0

       do nav=1,max_nav  ! loop over sectors
        target_sector = nav_sect(nav,start_sector)
        if (target_sector.gt.0) then
*        **** loop over downstream domains
         do 10 target_domain=start_domain+1,min(start_domain+3,n_dm)
          do ii=1,nwin_dm(target_domain)  ! loop over target dom windows
           target_window = win1_dm(target_domain) + ii - 1
           if (secshad_dw(target_window).eq.target_sector) then
            if (n_dn.lt.maxtarg_dn) then
             n_dn = n_dn + 1
             wintarg_dn(n_dn) = target_window
             nnavf_dw(window) = nnavf_dw(window) + 1
             if (nnavf_dw(window).eq.1) navf1_dw(window) = n_dn
             go to 11
            else
             print *,' () dmnav: overflowing n_dn=', n_dn
             stop 'dmnav'
            endif
           endif
          enddo ! domain windows
 10      continue ! target domains
 11      continue ! break when target found
        endif
       enddo ! sectors

       do nav=1,max_nav  ! loop over sectors
        target_sector = nav_sect(nav,start_sector)
        if (target_sector.gt.0) then

*        **** loop over upstream domains
         do 20 target_domain=start_domain-1,max(start_domain-3,1),-1
          do ii=1,nwin_dm(target_domain)  ! loop over target dom windows
           target_window = win1_dm(target_domain) + ii - 1
           if (secshad_dw(target_window).eq.target_sector) then
            if (n_dn.lt.maxtarg_dn) then
             n_dn = n_dn + 1
             wintarg_dn(n_dn) = target_window
             nnavb_dw(window) = nnavb_dw(window) + 1
             if (nnavb_dw(window).eq.1) navb1_dw(window) = n_dn
             go to 21
            else
             print *,' () dmnav: overflowing n_dn=', n_dn
             stop 'dmnav'
            endif
           endif
          enddo ! domain windows
 20      continue ! target domains
 21      continue ! break when target found

        endif
       enddo ! sectors
      enddo ! windows

      if (llog_zfout) print *,' dmnav: # navigation windows created=',
     +     n_dn

      end
