*CMZ :  4.02/00 19/07/96  13.56.48  by  Rainer Mankel
*CMZ :  4.01/00 02/10/95  18.03.51  by  Rainer Mankel
*-- Author :    Rainer Mankel   29/09/95

      subroutine tfdmust(izf,dl,imust)

*     **** determines if domain layer dl is a must/can/cannot,
*     **** and return the search window (in terms of local coordinate)
*     ****   imust=+1 ("must"): prediction clearly within borders
*     ****          0 ("can") : prediction compatible with borders
*     ****         -1 ("cannot"): prediction clearly without borders

      implicit none
      integer izf, ipl, imust, dw, dl
      real tfxint, x_pred, y_pred, dx_window
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      dw = win_dl(dl)
      if (nlayplane_dl(dl).eq.0) then
       print *,' () tfdmust: no layer planes for dl=', dl
       imust = 0
       go to 999
      endif
      ipl = gede_dp(layplane1_dl(dl))
      if (ipl.eq.0) then
       print *,' () tfdmust: no planes for dl=', dl
       imust = 0
       go to 999
      endif

      if (l_2dx) then
*      **** 0-deg planes
       x_pred = xx_zf(1,izf)
     +          + xx_zf(3,izf) * (fgede_zmin(ipl) - z_zf(izf))
       dx_window = 5.0
       if (x_pred.lt.(xmin_dw(dw)-dx_window).or.
     +     x_pred.gt.(xmax_dw(dw)+dx_window)) then
        imust = -1
       else
        imust = 0
       endif
      elseif (l_2dy) then
*      **** stereo planes
       x_pred = tfxint(fgede_zmin(ipl))
       y_pred = xx_zf(2,izf)
     +          + xx_zf(4,izf) * (fgede_zmin(ipl) - z_zf(izf))

       if (x_pred.lt.xmin_dw(dw)-dx_window.or.
     +     x_pred.gt.xmax_dw(dw)+dx_window.or.
     +     y_pred.lt.ymin_dw(dw)-2.0.or.
     +     y_pred.gt.ymax_dw(dw)+2.0)   then
        imust = -1
       else
        imust = 0
       endif


      elseif (l_svd.or.l_mag) then
*      **** 3D tracking
       x_pred = xx_zf(1,izf)
     +          + xx_zf(3,izf) * (fgede_zmin(ipl) - z_zf(izf))
       y_pred = xx_zf(2,izf)
     +          + xx_zf(4,izf) * (fgede_zmin(ipl) - z_zf(izf))

       if (diag_level.ge.5) then
        print *,' tfdmust: x_pred, y_pred, dw, xmin_dw...=',
     +         x_pred, y_pred, dw,xmin_dw(dw),xmax_dw(dw),
     +                            ymin_dw(dw),ymax_dw(dw)
       endif

       if (x_pred.lt.xmin_dw(dw)-dx_window.or.
     +     x_pred.gt.xmax_dw(dw)+dx_window.or.
     +     y_pred.lt.ymin_dw(dw)-2.0.or.
     +     y_pred.gt.ymax_dw(dw)+2.0)   then
        imust = -1
       else
        imust = 0
       endif

      else
       print *,' () tfdmust: mode error '
       stop 'tfdmust'
      endif

 999  end



