
*-- Author :    Rainer Mankel   29/09/95

      subroutine tfdzone(base,method,zone,nmax,target_vec,n_target)

*     **** return vector of possible target domain layers
      implicit none
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"

      integer base,              ! number of starting domain layer
     +        method,            ! navigation method used
     +        zone,              ! navigation depth
     +        nmax,              ! dimension of target_vec
     +        target_vec(nmax),  ! returned vector of target planes
     +        n_target           ! number of returned target planes
      real    u                  ! predicted coordinate (used to
                                 ! determine band in base)

      integer delt_zone, llast, iplast, iplay, bwindow, pwindow,
     +        pdomain, pdn, step
      logical init              ! .true. if navigation table is read

#include "arte/Arte.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

      save init
      data init /.false./

#include "arte/Arte.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

      if (.not.init) then

      endif  ! initialization

*     **** return zone vector
      n_target = 0

*     **** find previous layers in same domain window
      llast = base
      iplast = 0
      do iplay=1,zone
       if (diag_level.ge.6) then
        print *,
     +         ' tfdzone: llast,iplast,method,prvlay_dl(method,llast)=',
     +         llast,iplast,method,prvlay_dl(method,llast)
       endif
       if (prvlay_dl(method,llast).ne.0) then
        llast = prvlay_dl(method,llast)
        iplast = iplay
       endif
      enddo

      if (iplast.eq.zone) then ! target found within same domain
       n_target = 1
       target_vec(1) = llast
       go to 999
      endif

      delt_zone = zone - iplast ! remaining depth to be probed
      bwindow = win_dl(base)

      do 10 pdn=navb1_dw(bwindow),
     +                            navb1_dw(bwindow)+nnavb_dw(bwindow)-1
     +                            ! loop over navigation target windows
       pwindow = wintarg_dn(pdn)

       do 20 step=1,delt_zone
        if (step.gt.1) pwindow = prvwin_dw(pwindow)
        if (pwindow.le.0) go to 21
        if (abs(domain_dw(pwindow)-domain_dw(bwindow)).gt.3) go to 21
     +                            ! no jump over more than 2 domains

        llast = layerlst_dw(method,pwindow)
        iplast = 0

        if (delt_zone.eq.1.and.llast.gt.0) then
         if (n_target.lt.nmax) then
          n_target = n_target + 1   ! accept target domain layer
          target_vec(n_target) = llast
          go to 21
         else
          print *,' () tfdzone: overflowing n_target, nmax=',
     +                                      n_target, nmax
          stop 'tfdzone'
         endif
        endif

        do iplay=1,delt_zone-1
         if (prvlay_dl(method,llast).ne.0) then
          llast = prvlay_dl(method,llast)
          iplast = iplay
         endif
        enddo ! iplay

        if (iplast.eq.(delt_zone-1)) then ! target found
         if (n_target.lt.nmax) then
          n_target = n_target + 1   ! accept target domain layer
          target_vec(n_target) = llast
         else
          print *,' () tfdzone: overflowing n_target, nmax=',
     +                                      n_target, nmax
          stop 'tfdzone'
         endif
         go to 21
        endif
 20    continue
 21    continue ! step
 10   continue ! pwindow

      if (diag_level.ge.6) then
      print *,' tfdzone: final result: n_target=', n_target
      print *,
     +     '         target_vec=',
     +     (target_vec(step),secshad_dw(win_dl(target_vec(step))),
     +     step=1,n_target)
      endif

 999  end




