*-- Author :    Rainer Mankel   18/01/94

      subroutine tfmseedx()

*     **** pattern recognition strategy center
*     **** tfmseedx uses domain navigation
*     **** 0-deg projection only

      implicit none
#include "arte/Arte.fi"
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zseed.fi"
#include "rang/zdomain.fi"
#include "rang/zfpar.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
      logical lnext, ltest
      integer ic, seed_dl1, seed_dl2, i_dh, j_dh, cmp,
     +        iih1, iih2, iih3, iih4, ift, nca_x, jft, iii, jjj
      real dzpl, xhit1, xhit2
      logical remove_seed
      parameter (remove_seed=.true.)
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      l_diag = .false.
      diag_level = 0
      l_graf = .false.

*     **** always reset seed pointers
      icaczs(1) = 0
      icaczs(2) = 0

      call tfcut(0)
      call tfclr()              ! clear pattern recognition common block

*     **** loop over seeding domain sets
      do 10 ic=1,nseedh_ds      ! loop over horizontal seeds
         seed_dl1 = dlayh_ds(1,ic)
         seed_dl2 = dlayh_ds(2,ic)

***         print *,' ====> domains ', seed_dl1, seed_dl2,
***     +        ' windows ', win_dl(seed_dl1), win_dl(seed_dl2),
***     +        ' sector ', secshad_dw(win_dl(seed_dl1))
         do 20 iii=1,9999       ! loop over hits in first seeding domain
            if (iii.eq.1) then
               i_dh = hit1_dp(seed_dl1)
            else
               i_dh = nxthit_dh(i_dh)
            endif
            if (i_dh.eq.0) go to 20
            iih1 = hitb_dh(i_dh)

***            print *,' hit1=', iih1
            if (remove_seed) then
               if (segstor_zfpar) then
                  if (phitb_rseg(iih1).gt.0) go to 20
               else
                  if (phitb_rtra(iih1).gt.0) go to 20
               endif
            endif
            ihitzs(1,1) = iih1
            xhit1 = fhitb_x(iih1)
            cmp = igede_cmp( ihitb_gede(iih1) )

            do 30 jjj=1,9999    ! loop over hits in 2nd seeding domain
               if (jjj.eq.1) then
                  j_dh = hit1_dp(seed_dl2)
               else
                  j_dh = nxthit_dh(j_dh)
               endif
               if (j_dh.eq.0) go to 30
               iih2 = hitb_dh(j_dh)
***               print *,' hit2=', iih2

               if (remove_seed) then
                  if (segstor_zfpar) then
                     if (phitb_rseg(iih2).gt.0) go to 30
                  else
                     if (phitb_rtra(iih2).gt.0) go to 30
                  endif
               endif

               if (igede_cmp( ihitb_gede(iih2) ).ne.cmp) go to 30
               ihitzs(2,1) = iih2
               xhit2 = fhitb_x(iih2)
               dzpl = abs(fhitb_z(iih2) - fhitb_z(iih1))
***               print *,' dzpl=', dzpl
               if (abs(xhit2-xhit1).gt.(0.5*(dzpl+0.5))) go to 30
*              **** construct seed from 2 hits
               igenzs = 1

***               print *,' call seed for iih1,iih2=', iih1, iih2
               if (cmp.eq.2) then
                  call tfr2x(iih1,iih2,lnext) ! wire chamber seed
               elseif (cmp.eq.3) then
                  call tfs2x(iih1,iih2,lnext)
               else
                  print *,' tfmseedx: unsupported cmp for ipl=',
     +                 ihitb_gede(iih1)
                  lnext = .false.
               endif
 30         continue

 20      continue               ! hits in iplseed1
 10   continue

 999  end






