*CMZ :  4.04/00 02/09/96  12.58.04  by  Rainer Mankel
*CMZ :  4.02/00 04/06/96  11.33.23  by  Rainer Mankel
*-- Author :    Rainer Mankel   30/05/96

      subroutine tfsasegx(ift)

*     **** save x projection of candidate ft into /zdlx/
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
      integer ift,izf,ii,dw,dlx,dom,dom_last,message_id_1

      logical dlx_filled(max_dlx)

      do dlx=1,max_dlx
         dlx_filled(dlx) = .false.
         dw_dlx(dlx) = 0
      enddo

      do dw=1,n_dw              ! clear navigable domain window flags
         lx_dlx(dw) = .false.
      enddo

      dom_last = 0
      do ii=1,nhit_ft(ift)
         if (ii.eq.1) then
            izf = last_ft(ift)
         else
            izf = prev_zf(izf)
         endif
         if (izf.eq.0) then
            print *,' () tfsasegx: izf=', izf
            stop 'tfsasegx'
         endif

         dom = laydom_dl(domlay_zf(izf)) ! domain
         if (dom.ne.dom_last) then
            if (dom.gt.dom0_dlx.and.dom.le.dom2_dlx) then
               z_dlx (dom-dom0_dlx) = z_zf(izf)
               x_dlx (dom-dom0_dlx) = xx_zf(1,izf)
               tx_dlx(dom-dom0_dlx) = xx_zf(3,izf)
               dlx_filled(dom-dom0_dlx) = .true.
               dw_dlx(dom-dom0_dlx) = win_dl(domlay_zf(izf))
            else
               print *,' () tfsasegx: invalid dom=', dom
               stop 'tfsasegx'
            endif
            dom_last = dom
         endif

         lx_dlx(win_dl(domlay_zf(izf))) = .true.
      enddo

      do dlx=1,max_dlx
         if (dlx_filled(dlx)) then
            dlx1_dlx = dlx
            go to 11
         endif
      enddo
 11   continue

      do dlx=max_dlx,1,-1
         if (dlx_filled(dlx)) then
            dlx2_dlx = dlx
            go to 21
         endif
      enddo
 21   continue

      do dlx=dlx1_dlx+1,dlx2_dlx-1      ! check if fill contiguous
         if (.not.dlx_filled(dlx)) then ! window missing in x proj
**            print *,' tfsasegx: not filled dlx=', dlx
            if (dlx.gt.(dlx1_dlx+1)) then ! try fixup
               if (dlx_filled(dlx-1)) then ! extrapolate from prev dom
                  z_dlx (dlx) = z_dm(dom0_dlx+dlx)
                  x_dlx (dlx) = x_dlx (dlx-1) 
     +                       + (z_dlx(dlx)-z_dlx(dlx-1)) * tx_dlx(dlx-1)
                  tx_dlx(dlx) = tx_dlx(dlx-1)
                  if (navf1_dw(dw_dlx(dlx-1)).gt.0.and.
     +                 navf1_dw(dw_dlx(dlx-1)).le.n_dn) then
                     if (wintarg_dn(navf1_dw(dw_dlx(dlx-1))).gt.0) then
                        lx_dlx(wintarg_dn(navf1_dw(dw_dlx(dlx-1))))
     +                       = .true.
                     endif
                  else
                     print *,' tfsasegx: missing target'
                  endif
                  dlx_filled(dlx) = .true.
               endif
            endif
            if (dlx.lt.dlx2_dlx+1.and..not.dlx_filled(dlx)) then
               if (dlx_filled(dlx+1)) then ! extrapolate from next dom
                  z_dlx (dlx) = z_dm(dom0_dlx+dlx)
                  x_dlx (dlx) = x_dlx (dlx+1) 
     +                       + (z_dlx(dlx)-z_dlx(dlx+1)) * tx_dlx(dlx+1)
                  tx_dlx(dlx) = tx_dlx(dlx+1)

                  if (navb1_dw(dw_dlx(dlx+1)).gt.0.and.
     +                 navb1_dw(dw_dlx(dlx+1)).le.n_dn) then
                     if (wintarg_dn(navb1_dw(dw_dlx(dlx+1))).gt.0) then
                        lx_dlx(wintarg_dn(navb1_dw(dw_dlx(dlx+1))))
     +                       = .true.
                     endif
                  else
                     print *,' tfsasegx: missing target'
                  endif
                  dlx_filled(dlx) = .true.
               endif
            endif
            if (.not.dlx_filled(dlx)) then
               call mepric(message_id_1,1,
     +              'tfsasegx: double dlx gap on thread')
               z_dlx (dlx) = z_dlx (dlx-1) ! desperate fixup
               x_dlx (dlx) = x_dlx (dlx-1)
               tx_dlx(dlx) = tx_dlx(dlx-1)
               dlx_filled(dlx) = .true.
            endif
         endif
      enddo

      qpt_dlx = xx_zf(5,last_ft(ift)) ! curvature estimate

*     **** pointers
      ft_dlx = ift

      if (diag_level.ge.3) then
         call tflft(ift,' ')
         print *,' tfsasegx: contents of dlx buffer:'
         do dlx=dlx1_dlx,dlx2_dlx
            dom = dom0_dlx+dlx
            print '((a),i6,3f16.3)','dom,z,x,tx=',dom,z_dlx(dlx),
     +           x_dlx(dlx),tx_dlx(dlx)
         enddo
         print *,' tfsasegx: navigable windows for ift=', ift
         do dw=1,n_dw
            if (lx_dlx(dw)) then
               print *,' dw=', dw,' domain=', domain_dw(dw)
            endif
         enddo
         if (l_diag) call tfwait()
      endif

      end

