*-- Author :    Rainer Mankel   19/05/95

      subroutine tfstat()

*     **** pattern recognition efficiencies etc

#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"

#include "pris/zpstat.fi"
#include "rang/zfout.fi"

      integer ncounter, code_eplus, code_eminus, code_muplus,
     +        code_muminus, tpname
      parameter (ncounter=9)
                 ! counter=1  for e+-
                 !         2  for mu+-
                 !         3  for l+-
                 !         4  for pi+-
                 !         5  for J/Psi
                 !         6  for K0S
                 !         7  for B0
                 !         8  for charged tracks
                 !         9  for ghosts

      integer counter_mc_evt(ncounter), ! reference mc objects per evt
     +        counter_mc_all(ncounter), !           ||        (all evts)
     +        counter_rc_evt(ncounter), ! reference rc objects per evts
     +        counter_rc_all(ncounter), !           ||        (all evts)
     +        counter_ef_all(ncounter), ! defined efficiency evts
     +        counter_ge_evt(ncounter), ! generated mc objects per evt
     +        counter_ge_all(ncounter)  !           ||        (all evts)
      
      real    counter_evtef (ncounter), ! current evt efficiencies
     +        counter_allef (ncounter), ! current run efficiencies
     +        accumul_ef_all(ncounter)  ! summed efficiency   (all evts)
      integer counter_bgen_evt  ! golden Bs
      integer counter_bgen_all
      integer counter, ii, mc, jaux, rc, nrc, ialia, it, gold, jgold,
     +        mcgold, counter_lep, lepton, n_events
      character*20 cname
      real mass, charge, pmc, fracmc
      character*20 counter_name(ncounter) ! name of counter
      logical lrefpat(7,maxgold), lrc(7,maxgold)

      data n_events /0/

      data counter_name / 'golden e+-', 'golden mu+-', 'golden l+-',
     +      'golden pi+-', 'golden J/Psi', 'golden K0S', 'golden B0',
     +      'charged tracks', 'ghosts' /

      data counter_mc_evt /ncounter*0/,
     +     counter_mc_all /ncounter*0/,
     +     counter_rc_evt /ncounter*0/,
     +     counter_rc_all /ncounter*0/,
     +     counter_ef_all /ncounter*0/,
     +     accumul_ef_all /ncounter*0./,
     +     counter_ge_evt /ncounter*0./,
     +     counter_ge_all /ncounter*0./,
     +     counter_bgen_all  /0/

      save n_events, counter_mc_evt, counter_mc_all, counter_rc_evt,
     +  counter_rc_all, counter_ef_all, accumul_ef_all, counter_name,
     +     counter_bgen_evt, counter_bgen_all, counter_ge_evt,
     +     counter_ge_all
#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"

      call rginit()

      if (n_events.eq.0) then
         code_eplus  = tpname('e+')
         code_eminus = tpname('e-')
         code_muplus = tpname('mu+')
         code_muminus = tpname('mu-')
         if (min0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .le.0.or.
     +        max0(code_eplus,code_eminus,code_muplus,code_muminus)
     +        .gt.ntopp()) then
            print *,' () tfstat: invalid topp pointer ',
     +           code_eplus,code_eminus,code_muplus,code_muminus
            stop 'tfstat'
         endif
      endif

      n_events = n_events + 1

      do counter=1,ncounter         ! reset event scope counters
       counter_mc_evt(counter) = 0
       counter_rc_evt(counter) = 0
       counter_ge_evt(counter) = 0
      enddo
      counter_bgen_evt = 0

      if (ibatch.eq.0.and.lref_zfout) then
       print *,' '
       print *,' R e f e r e n c e     T r a c k s :'
       print *,' '
       print '(3a5,a6,a20)',  ! headline
     +        'mc','rc','nrc','pmc','name'
      endif

      do ii=1,pstat_nrefpat  ! loop over reference tracks
       mc = pstat_refpat(ii)
*      **** check if reconstructed
       if (pmtra_rtra(mc ).gt.0) then
        jaux = pmtra_rtra(mc)
        rc = mmtra_rtra(jaux)
        nrc = 1
*       **** count
        do 10 ialia=1,20
         jaux = xmtra_rtra(jaux)
         if (jaux.gt.0) then
          nrc = nrc + 1
         else
          go to 11
         endif
 10     continue
 11     continue
       else
        rc = 0
        nrc = 0
       endif

       if (ibatch.eq.0.and.lref_zfout) then
        call tupaty(omtra_topp(mc),cname,charge,mass,'G')
        pmc = sqrt(fmtra_px(mc)**2+fmtra_py(mc)**2+fmtra_pz(mc)**2)
        print '(3i5,f6.2,1x,a19)',
     +        mc,rc,nrc,pmc,cname
       endif


       counter = 8  ! charged particles
       counter_mc_evt(counter) = counter_mc_evt(counter) + 1
       if (nrc.gt.0) then
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif
      enddo ! reference tracks

      counter = 9  ! ghosts
      do it=1,iq(jrtra+2)  ! loop over reconstructed tracks
       if (prtra_mtra(it).eq.0) then  ! check if no corresponding MC
        counter_rc_evt(counter) = counter_rc_evt(counter) + 1
       endif
      enddo  ! RC tracks
      counter_mc_evt(counter) = counter_mc_evt(8)  ! normalize to ref tr

*     **** loop over golden Bs
      do gold=1,pstat_ngold
       counter_bgen_evt = counter_bgen_evt + 1 ! count Bs
       do jgold=1,4  ! loop over stable golden particles
        mcgold = pstat_gold(jgold,gold)
        lrefpat(jgold,gold) = .false.  ! initialize ref track flag
        lrc    (jgold,gold) = .false.  ! initialize reco flag
        do 20 mc=1,pstat_nrefpat  ! gold part occurs in ref tracks ?
         if (pstat_refpat(mc).eq.mcgold) then
          lrefpat(jgold,gold) = .true.
          go to 21
         endif
 20     continue ! mc ref loop
 21     continue
*       **** check if reconstructed
        lrc(jgold,gold) = pmtra_rtra(mcgold).gt.0
       enddo
       lrefpat(5,gold) = lrefpat(1,gold).and.lrefpat(2,gold) ! J/Psi
       lrefpat(6,gold) = lrefpat(3,gold).and.lrefpat(4,gold) ! K0S
       lrefpat(7,gold) = lrefpat(5,gold).and.lrefpat(6,gold) ! B0
       lrc(5,gold) = lrc(1,gold).and.lrc(2,gold) ! J/Psi
       lrc(6,gold) = lrc(3,gold).and.lrc(4,gold) ! K0S
       lrc(7,gold) = lrc(5,gold).and.lrc(6,gold) ! J/Psi
      enddo


      counter = 3 ! l+-
      do gold=1,pstat_ngold
       do jgold=1,2
        counter = 3 ! l+-
        lepton = omtra_topp(pstat_gold(jgold,gold))
        if (lepton.eq.code_eplus.or.lepton.eq.code_eminus) then
         counter_lep = 1
        elseif (lepton.eq.code_muplus.or.lepton.eq.code_muminus) then
         counter_lep = 2
        else
         print *,' () tfstat: invalid lepton: ', lepton
         counter_lep = 2
        endif
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        counter_ge_evt(counter_lep) = counter_ge_evt(counter_lep) + 1
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         counter_mc_evt(counter_lep) = counter_mc_evt(counter_lep) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
          counter_rc_evt(counter_lep) = counter_rc_evt(counter_lep) + 1
         endif
        endif
       enddo
      enddo

      counter = 4 ! pi+-
      do gold=1,pstat_ngold
       do jgold=3,4
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=5,7
       do gold=1,pstat_ngold
        counter_ge_evt(counter) = counter_ge_evt(counter) + 1
        jgold=counter
        if (lrefpat(jgold,gold)) then
         counter_mc_evt(counter) = counter_mc_evt(counter) + 1
         if (lrc(jgold,gold)) then
          counter_rc_evt(counter) = counter_rc_evt(counter) + 1
         endif
        endif
       enddo
      enddo

      do counter=1,ncounter
*      **** event-based efficiencies
       if (counter_mc_evt(counter).gt.0) then
        counter_ef_all(counter) = counter_ef_all(counter) + 1
        counter_evtef(counter) = float(counter_rc_evt(counter))
     +                         / float(counter_mc_evt(counter))
        accumul_ef_all(counter) = accumul_ef_all(counter)
     +                                 + counter_evtef(counter)
       else
        counter_evtef(counter) = 0.
       endif
*      **** update all counters
       counter_mc_all(counter) = counter_mc_all(counter)
     +                         + counter_mc_evt(counter)
       counter_rc_all(counter) = counter_rc_all(counter)
     +                         + counter_rc_evt(counter)
       counter_ge_all(counter) = counter_ge_all(counter)
     +                         + counter_ge_evt(counter)

       if (counter_mc_all(counter).gt.0) then
        counter_allef(counter) = float(counter_rc_all(counter))
     +                         / float(counter_mc_all(counter))
       else
        counter_allef(counter) = 0.
       endif
      enddo ! updating of counters
      counter_bgen_all = counter_bgen_all + counter_bgen_evt

*     **** print reconstructed tracks
      if (ibatch.eq.0.and.lrec_zfout) then
       print *,' '
       print *,' R e c o n s t r u c t e d     T r a c k s :'
       print *,' '
       print '(a4,a5,a6,2a5,a8)',  ! headline
     +       ' trk','mc','frac','nhi','fit','chi'
       do it=1,iq(jrtra+2)
        call tfremcn(it,mc,fracmc)
        print '(i4,i5,f6.2,2i5,f8.2)',
     +       it,mc,fracmc,irtra_hsi(it)+irtra_hou(it)+irtra_hin(it),
     +       irtra_fit(it),frtra_chi(it)
       enddo
      endif

*     **** printout
      if (leff_zfout) then
       print 101, n_events,
     +            (counter_name(counter),counter_mc_evt(counter),
     +            counter_rc_evt(counter),100.*counter_evtef(counter),
     +            counter_mc_all(counter),
     +            counter_rc_all(counter),100.*counter_allef(counter),
     +            counter_ge_all(counter),
     +                               counter=1,ncounter)

 101   format(//
     + ' |=====================',
     + '====================================================| '/
     + ' |       statis',
     + 'tics from tfstat      nevents=',i6,'                        |'/
     + ' |=====================',
     + '====================================================|'/
     + ' | Counter     ',
     + '    MC(evt) RC(evt) ef(evt)  MC(run) RC(run) ef(run)',
     +      '    gen ','|'/
     + 9(' | ',a15,2i7,f7.2,5x,2i7,f7.2,i9,' |'/),
     + ' |=====================',
     + '====================================================| ')
      endif

 999  end



