*-- Author :    Rainer Mankel   25/02/96
*-- changed:    A.Spiridonov    22/04/98  /modification of tftparm.F

      subroutine tftparm1(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)

*     **** check reconstructed track parameters against MC
      implicit none
      double precision covi(5,5)
      real pa(5), pamc(5), dpa(5), ch2mc, ex(5), dpanorm(5), zref
      integer i, j, ndf, ifail, mimp, jaux, assmimp, istat, i_pack, ii,
     +     it, imc, hf, ih, icode
      real charge, mass, corc(5,5), cms, tx, ty
      character*20 cname
      
      integer ind_mimp,iso
      real dz_mimp
      
#include "arte/Arte.fi"
#include "rang/zfpar.fi"

#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/MTRA.fi"
#include "auto/GEO.fi"
#include "auto/TOPP.fi"

#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/MTRA.ff"
#include "auto/GEO.ff"
#include "auto/TOPP.ff"

      istat = 0
*   -----------
      ndf = 4
*   -----------
      zref = frtra_zf(it)

#ifdef UN_TEST_OLD
*     **** get last fitted hit (lowest z)
      ih = 0
      do 30 iihitb=1,999        ! locate hits associated with track
         if (iihitb.eq.1) then
            ind_hit = prtrx_hitb(it)
         else
            ind_hit = xrtrx_hitb(ind_hit)
         endif
         if (ind_hit.le.0) go to 31

         hit = mrtrx_hitb(ind_hit)
         if (ih.eq.0) then
            ih = hit
         else
            if (fhitb_z(
            ...

            
      do 30 hf=nrhit(),1,-1
         if (irhit_rtra(hf).eq.it) go to 31
30    continue
      print *,' tftparm1 : missing hf'
      istat = -1
      go to 999
31    continue

      ih = orhit_hitb(hf)

*     **** get mimp
      mimp = 0
      do 10 ii=1,999
         if (ii.eq.1) then
            jaux = phitb_mimp(ih)
         else
            jaux = xhitb_mimp(jaux)
         endif
         if (jaux.eq.0) go to 11
         assmimp = mhitb_mimp(jaux)
         if (omimp_mtra(assmimp).eq.imc) then
            mimp = assmimp
            go to 11
         endif
 10   continue
      istat = -1
      print *,' tftparm1 : no valid mimp found'
      go to 999
 11   continue
#endif

*     **** get mimp closest to zref

      mimp = 0
      dz_mimp = 1.e10    
      do 20 iso=1,300
        if (iso.eq.1) then
          ind_mimp = pmtra_mimp(imc)
        else
          ind_mimp = xmtra_mimp(ind_mimp)
        endif
        if (ind_mimp.le.0) go to 21
         
*        print '("tftparm1 : it,imc,mimp,zref,zmimp ",3i5,2f8.3)'
*     +        ,it,imc,mmtra_mimp(ind_mimp)
*     +        ,zref,fmimp_z(mmtra_mimp(ind_mimp))

        if(abs(fmimp_z(mmtra_mimp(ind_mimp))-zref).le.dz_mimp) then
          mimp = mmtra_mimp(ind_mimp)
          dz_mimp = abs(fmimp_z(mimp)-zref)
        end if

   20 continue
   21 continue
      
      if(mimp.eq.0) then
        istat = -1
        print *,' tftparm1 : no valid mimp found'
        go to 999
      end if

      if (abs(fmimp_z(mimp)-zref).gt.5.) then
         print *,' tftparm1 : funny z ', 
     +        fmimp_z(mimp), zref,
     +        ' it=',it,' imc=',imc,
     +        ' mimp=', mimp, ' ih=', ih
         istat = -1
         go to 999
      endif

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
       if (mimp.eq.0) then
**        print *,' tftparm1 : mimp=', mimp  ! mimp ambiguous (allowed)
        istat = -1
        go to 999
       else
        print *,' () tftparm1 : mimp=', mimp  ! mimp invalid
        stop 'tftparm'
       endif
      endif

      icode = omtra_topp( omimp_mtra(mimp) )
      call tupaty(icode,cname,charge,mass,'G')

      tx = fmimp_tx(mimp)
      ty = fmimp_ty(mimp)

      pamc(1) = fmimp_x(mimp)
     +        + tx * (zref - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + ty * (zref - fmimp_z(mimp))
      pamc(3) = tx
      pamc(4) = ty
**      pamc(5) = 0.33 * itopp_chrg(icode) / abs(fmimp_p(mimp))
      if (itopp_chrg(icode).gt.0) then
         pamc(5) = 1. / abs(fmimp_p(mimp))
      elseif (itopp_chrg(icode).lt.0) then
         pamc(5) = -1. / abs(fmimp_p(mimp))
      else
         pamc(5) = 0.
         print *,' () tftparm1 : invalid charge=',itopp_chrg(icode)
      endif

      pa(1) = frtra_xf(it)
      pa(2) = frtra_yf(it)
      pa(3) = frtra_txf(it)
      pa(4) = frtra_tyf(it)
      pa(5) = frtra_pf(it)

      do i=1,5
         do j=1,5
            i_pack = matrix_pack(i,j)
            corc(i,j) = frtra_cvf(i_pack,it)
         enddo
      enddo

*     **** add last M.S.
      cms = fgede_ms(imimp_gede(mimp)) / fmimp_p(mimp)**2
      corc(3,3) = corc(3,3) + cms
      corc(4,4) = corc(4,4) + cms

      do i=1,5
         dpa(i) = pa(i) - pamc(i)
         ex(i)  = sqrt(corc(i,i))
         dpanorm(i) = dpa(i) / ex(i)
      enddo

*     **** MC chi2
      ch2mc = 0.
      do i=1,ndf
         do j=1,ndf
            covi(i,j) = corc(i,j)
         enddo
      enddo

*     **** blank remaining elements
      do i=ndf+1,5
         do j=ndf+1,5
            covi(i,j) = 0.d0
         enddo
      enddo

**      write(*,'((a),5(/5e11.3))') 'before inv:',covi
      call dsinv(ndf,covi,5,ifail)
      if (ifail.ne.0) then
         print *,' () tftparm1 : mx inversion fails'
         istat = -1
         go to 999
      endif
**      write(*,'((a),5(/5e11.3))') 'after  inv:',covi
      do i=1,ndf
         do j=1,ndf
            ch2mc = ch2mc + dpa(i) * dpa(j) * covi(i,j)
**          print *,' chi2 contr, i,j,contr=',
**     +            i,j,dpa(i) * dpa(j) * covi(i,j)
         enddo
      enddo

      if (ifail.ne.0) then 
        print *,' =====> ifail,chi2=',ifail,ch2mc
        istat = -2
      end if

 999  end

