#include "rich/PhotonDetection.h"

RICHDetector *RICH_Detector=0;
int RICHdebug=0;

#ifdef NOARTE
 int    ArtePointer<CPOI>::nr =0;
 int    ArtePointer<CPOI>::nc =0;
 CPOI** ArtePointer<CPOI>::t  =0;
 int    ArtePointer<CPMT>::nr =0;   
 int    ArtePointer<CPMT>::nc =0;
 CPMT** ArtePointer<CPMT>::t  =0;
 int    ArtePointer<CEFF>::nr =0;
 int    ArtePointer<CEFF>::nc =0; 
 CEFF** ArtePointer<CEFF>::t  =0;
 int    ArtePointer<CPMD>::nr =0;
 int    ArtePointer<CPMD>::nc =0;
 CPMD** ArtePointer<CPMD>::t  =0;
 int    ArtePointer<CLEN>::nr =0;
 int    ArtePointer<CLEN>::nc =0;
 CLEN** ArtePointer<CLEN>::t  =0;
 int    ArtePointer<CSUP>::nr =0;
 int    ArtePointer<CSUP>::nc =0;
 CSUP** ArtePointer<CSUP>::t  =0;
 int    ArtePointer<CSPM>::nr =0;
 int    ArtePointer<CSPM>::nc =0;
 CSPM** ArtePointer<CSPM>::t  =0;
 int    ArtePointer<CPMI>::nr =0;
 int    ArtePointer<CPMI>::nc =0;
 CPMI** ArtePointer<CPMI>::t  =0;
 int    ArtePointer<CSSM>::nr =0;
 int    ArtePointer<CSSM>::nc =0;
 CSSM** ArtePointer<CSSM>::t  =0;
 int    ArtePointer<CSMI>::nr =0;
 int    ArtePointer<CSMI>::nc =0;
 CSMI** ArtePointer<CSMI>::t  =0;
 int    ArtePointer<CDIM>::nr =0;
 int    ArtePointer<CDIM>::nc =0;
 CDIM** ArtePointer<CDIM>::t  =0;
 int    ArtePointer<CPDW>::nr =0;
 int    ArtePointer<CPDW>::nc =0;
 CPDW** ArtePointer<CPDW>::t  =0;
 int    ArtePointer<CVES>::nr =0;
 int    ArtePointer<CVES>::nc =0;
 CVES** ArtePointer<CVES>::t  =0;
/* int    ArtePointer<MPHO>::nr =0;
 int    ArtePointer<MPHO>::nc =0;
 MPHO** ArtePointer<MPHO>::t  =0;
 int    ArtePointer<DRIC>::nr =0;
 int    ArtePointer<DRIC>::nc =0;
 DRIC** ArtePointer<DRIC>::t  =0;
 int    ArtePointer<CCEL>::nr =0;
 int    ArtePointer<CCEL>::nc =0;
 CCEL** ArtePointer<CCEL>::t  =0;
 int    ArtePointer<CDAQ>::nr =0;
 int    ArtePointer<CDAQ>::nc =0;
 CDAQ** ArtePointer<CDAQ>::t  =0;
 */
#endif 


// ===========================================================================
//
//   determine the supermodule, which the photon hits: no physics here
//

int RICHDetector::dodetect(Photon* p,int*daqid) {
  int k,l;
  if (p->x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  int ret=NO_LOSS;
  if ((ret=sm[k]->dodetect(p,daqid))!=SUP_LOSS_OUTOFAREA) {
    if (ret==NO_LOSS) lasthit=k;
    }
  else {
    for (l=1;l<=numsm/4;l++) {
      if ((ret=sm[k-l]->dodetect(p,daqid))!=SUP_LOSS_OUTOFAREA) {
        if (ret==NO_LOSS) lasthit=k-l;
        break;
        }
      if ((ret=sm[k+l]->dodetect(p,daqid))!=SUP_LOSS_OUTOFAREA) {
        if (ret==NO_LOSS) lasthit=k+l;
        break;
        }
      }
    }
  return ret;
  }


void RICHDetector::intersection(const StraightLine& p,double *path) {
  int k,l;
  if (p.x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  if (sm[k]->intersection(p,path)!=SUP_LOSS_OUTOFAREA) {
    lasthit=k;
    return;
    }
  for (l=1;l<=numsm/4;l++) {
    if (sm[k-l]->intersection(p,path)!=SUP_LOSS_OUTOFAREA) {
      lasthit=k-l;
      return;
      }
    if (sm[k+l]->intersection(p,path)!=SUP_LOSS_OUTOFAREA) {
      lasthit=k+l;
      return;
      }
    }
  sm[k]->intersection(p,path);
  lasthit=k;
  return;
  }



int RICHDetector::hit_in_acceptance(const StraightLine& p) {
  int k,l;
  if (p.x().y()>0) { 
    k=numsm/4;  
    }
  else { 
    k=(3*numsm)/4; 
    }
  lasthit=-1;
  int ret=0;
  double ll;
  if ((ret=sm[k]->intersection(p,&ll))==NO_LOSS) {
    lasthit=k;
    }
  else {
    for (l=1;l<=numsm/4;l++) {
      if ((ret=sm[k-l]->intersection(p,&ll))==NO_LOSS) {
        lasthit=k-l;
        break;
        }
      if ((ret=sm[k+l]->intersection(p,&ll))==NO_LOSS) {
        lasthit=k+l;
        break;
        }
      }
    }
  if (ret==SUP_LOSS_OUTOFAREA) return 0; // no supermodule is hit
  PhotonDetectorSuperModule& s=*sm[lasthit];
  //return ((s.Cell(s.localhit().x(),s.localhit().y())!=0)==NO_LOSS);
  return ((s.Cell(s.localhit().x(),s.localhit().y())!=0));
  }





void  RICHDetector::NewChannelLoop() {
  s=r=maxp=0;c=p=-1;
  }

int RICHDetector::ChannelLoop() {
  p++;
  if (p==maxp) {
    do {
      if(++c==SuperModule(s).numcol()) {
        if (++r==SuperModule(s).numrow()) {
          if (++s==NumSuperModule()) return 0;
          r=0;
          }
        c=0;
        }
      } while (SuperModule(s).Cell(r,c)==0);
    p=0;
    maxp=SuperModule(s).Cell(r,c)->pm().numchannel();
    }
  return 1;
  }

int RICHDetector::ChannelLoop(int *ss,int *rr,int *cc,int *pp) {
  if (!ChannelLoop()) return 0;
  *ss=s;
  *rr=r;
  *cc=c;
  *pp=p;
  return 1;
  }

// ------------------------------------------------------------
//
//  Determine detection efficiency for cutting in the number of generated
//  photons
//
//   mode =0:  determine only overall efficiency (to get spectral range only)
//   mode =1:  determine spectral range and max efficiency in the range
//             and factorize this out of the detection efficiencies
//   mode =2:  determine the wavelength dependent efficiency 
//             and factorize this out of the detection efficiencies
//

void RICHDetector::MaxEfficiency(Table& eff,int numpoint,int mode) {

//  find maximal collection efficiency

  double colleff;
  if (mode!=0) {
    colleff=0;
    for (NewChannelLoop();ChannelLoop();) {
      double ce=efficiency();
      if (ce>colleff&&ce<=1) colleff=ce;
      }
    for (NewChannelLoop();ChannelLoop();) {
      float& ce=efficiency();
      if (ce>=0&&ce<=1) ce/=colleff;
      if (ce>1) {
        printf("Error: collection efficiency > 1\n");
        Exit(1);
        }
      }
    }
  else colleff=1; // doesn't matter for determinataion of lmin,lmax
  
//  find maximal quantum efficiency

  PMType *pmtype;

  double lmin=1E37;
  double lmax=0;

  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    Table& eff=pmtype->Efficiency();
    if (lmin>eff.x(0))               lmin=eff.x(0);
    if (lmax<eff.x(eff.numpoints()-1)) lmax=eff.x(eff.numpoints()-1);
    }

  LensSystem* lens;
  for (lens_list.newiterator();(lens=lens_list.iterate());) {
    Table& eff=lens->WaveLengthEfficiency();
    if (lmin>eff.x(0))                 lmin=eff.x(0);
    if (lmax<eff.x(eff.numpoints()-1)) lmax=eff.x(eff.numpoints()-1);
    }

  double dl=(lmax-lmin)/(numpoint-1);

  Table qeff;    
  int i;
  for (i=0;i<numpoint;i++) {
    double l=lmin+i*dl;
    qeff.append(l,0);
    }
  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    int i;
    for (i=0;i<numpoint;i++) {
      double l=qeff.x(i);
      double e=pmtype->efficiency(l);
      if (qeff.y(i)<e) qeff.y(i)=e;
      }
    }

  if (mode!=0) {
    if (mode==1) { // only step function
      double effmax=0;
      int i;
      for (i=0;i<numpoint;i++) if (effmax<qeff.y(i)) effmax=qeff.y(i);
      for (i=0;i<numpoint;i++) if (qeff.y(i)!=0) qeff.y(i)=effmax;
      }

    for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
      Table& eff=pmtype->Efficiency();
      int i;
      for (i=0;i<eff.numpoints();i++) {
        double l=eff.x(i); 
        if (qeff.f(l)>0)  eff.y(i)/=qeff.f(l);
        }
//      pmtype->print(stdout);
      }
//    qeff.print(stdout);
//    getchar();
    }

// --------------------------------------------------------------------
//   same for lensesystem(s)
//

  Table lenseff;    
  for (i=0;i<numpoint;i++) {
    double l=lmin+i*dl;
    lenseff.append(l,0);
    }

  for (lens_list.newiterator();(lens=lens_list.iterate());) {
    int i;
    for (i=0;i<numpoint;i++) {
      double l=lmin+i*dl;
      double e=lens->WaveLengthEfficiency(l);
      if (lenseff.y(i)<e) lenseff.y(i)=e;
      }
    }

  if (mode!=0) {
    if (mode==1) { // only step function
      double effmax=0;
      int i;
      for (i=0;i<numpoint;i++) if (effmax<lenseff.y(i))  effmax=lenseff.y(i);
      for (i=0;i<numpoint;i++) if (lenseff.y(i)!=0) lenseff.y(i)=effmax;
      }

    for (lens_list.newiterator();(lens=lens_list.iterate());) {
      Table& eff=lens->WaveLengthEfficiency();
      int i;
      for (i=0;i<eff.numpoints();i++) {
        double l=eff.x(i);
        if (lenseff.f(l)>0) eff.y(i)/=lenseff.f(l);
        }
      }
    }

// ----------------------------------------------------------------------
//  return overall efficiency
  
  for (i=0;i<numpoint;i++) {
    double l=lmin+i*dl;
    eff.append(l,colleff*qeff.y(i)*lenseff.y(i));
    }

  }


// ---------------------------------------------------------------------------
//    
//    initialisation and input/output
//

RICHDetector::RICHDetector(char *path) {
  if (RICH_Detector)  memcpy(this,RICH_Detector,sizeof(RICHDetector));
  else {
    //cout<<"RICHDetector::RICHDetector(char *path)"<<endl;
  if (path) {
    char n[256],tag[256];
    strcpy(n,path);
    strcat(n,"pmtype.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpmt(n);
    while (fpmt.gettag(n)) {
      if (RICHdebug) printf("%s\n",n);
      if (!strcmp(n,"pmtype")) {
        PMType* p=new PMType(fpmt);
        pmtype_list.append(p);
        }
      else {
        fprintf(stderr,"pmtype.dat: Unknown tag: %s\n",n);
        Exit(1);
      }
    }

    strcpy(n,path);
    strcat(n,"lenssystem.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile flens(n);
    while (flens.gettag(n)) {
      if (RICHdebug) printf("%s\n",n);
      if (!strcmp(n,"LensSystem")) {
        flens.skipline(n);
        LensSystem* l=new LensSystem(flens);
        lens_list.append(l);
        }
      else {
        fprintf(stderr,"lens.dat: Unknown tag: %s\n",n);
        Exit(1);
        }
      }

    strcpy(n,path);
    strcat(n,"pm.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpm(n);
    while (fpm.gettag(n)) {
      if (!strcmp(n,"pm")) {
        fpm.skipline(n);
        PM* p=new PM(fpm,pmtype_list,lens_list);
        pm_list.append(p);     
        }
      else {
        fprintf(stderr,"pm.dat: Unknown tag: %s\n",n);
        Exit(1);
        }
      }

    strcpy(n,path);
    strcat(n,"detector.dat");
    if (RICHdebug) printf("RICHDetector: Scan %s\n",n); 
    ScriptFile fpd(n);
    while (fpd.gettag(n)) {
      if (!strcmp(n,"PhotonDetector")) {
        fpd.skipline(n);
        fpd.getline(n);
        sscanf(n,"%s %d\n",tag,&numsm);
        sm=new PhotonDetectorSuperModule* [numsm];
        int i;
        for (i=0;i<numsm;i++) {
          fpd.getline(n);
          sm[i]=new PhotonDetectorSuperModule(fpd,pm_list);
          }
        }
      else {
        fprintf(stderr,"detector.dat: Unknown tag: %s\n",n);
        Exit(1);
        }
      }

    }
  else {  // init from Arte Tables
    if (RICHdebug) { printf("RICHDetector: ArteInit PMType\n");fflush(stdout);}
    int n=ArtePointer<CPMT>::nrow();
    int i;
    for (i=1;i<=n;i++) {
      pmtype_list.append(new PMType(ArtePointer<CPMT>(i)));
      }

    if (RICHdebug) { 
      printf("RICHDetector: ArteInit LensSystem\n");fflush(stdout);
      }
      
    n=ArtePointer<CLEN>::nrow();
    for (i=1;i<=n;i++) {
      lens_list.append(new LensSystem(ArtePointer<CLEN>(i)));
      }

    if (RICHdebug) { printf("RICHDetector: ArteInit PM\n");fflush(stdout);}
    n=ArtePointer<CPMD>::nrow();
    for (i=1;i<=n;i++) {
      pm_list.append(new PM(ArtePointer<CPMD>(i),pmtype_list,lens_list));
      }
    if (RICHdebug) { 
      printf("RICHDetector: ArteInit SuperModule\n");fflush(stdout);
      }
    sm=0;
    if (!(numsm=ArtePointer<CSUP>::nrow())) {
      fprintf(stderr,
        "RICHDetector: Arte table CSUP is not yet filled.\n");
      return;
      }
    sm=new PhotonDetectorSuperModule*[numsm];
    for (i=1;i<=numsm;i++) {
      sm[i-1]=new PhotonDetectorSuperModule(ArtePointer<CSUP>(i),pm_list);
      }
    }

  if (RICHdebug) {printf("RICH init fini\n");fflush(stdout);}
  firstCEFFindex=2000000;
  numchannel=0;
  int s,r,c,p;
  for (NewChannelLoop();ChannelLoop(&s,&r,&c,&p);) {
    const int i=ExistingPM(s,r,c).CEFFindex(p);
    if (i<firstCEFFindex) firstCEFFindex=i;
    numchannel++;
    }
  if (RICHdebug) {printf("RICHDetector init ends\n");fflush(stdout);}
  }
} 

RICHDetector::~RICHDetector() {
  PMType *pmt;
  for (pmtype_list.newiterator();(pmt=pmtype_list.iterate());) delete pmt;
  PM   *pm;
  for (pm_list.newiterator();(pm=pm_list.iterate());) delete pm;
   
  int i;
  for (i=0;i<numsm;i++) delete sm[i];
  if (sm) delete sm;
}

// ---------------------------------------------------------------------------
//
//  print to ascii files
//

void RICHDetector::print() {
  FILE *fp;  

  if (!(fp=fopen("detector.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pd.dat\n");
    Exit(1);
    }

  int i;
  fprintf(fp,"#\n#\n");
  fprintf(fp,"PhotonDetector\n#\n");
  fprintf(fp,"  NumberOfSuperModules  %d\n",numsm);
  for (i=0;i<numsm;i++) {
    sm[i]->print(fp);
    }
  fclose(fp);


  if (!(fp=fopen("pmtype.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pm.dat\n");
    Exit(1);
    }
  PMType *pmtype;
  for (pmtype_list.newiterator();(pmtype=pmtype_list.iterate());) {
    pmtype->print(fp);
    }  
  fclose(fp);
  if (!(fp=fopen("lenssystem.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: lens.dat\n");
    Exit(1);
    }
  LensSystem *ls;
  for (lens_list.newiterator();(ls=lens_list.iterate());) {
    ls->print(fp);
    }  
  fclose(fp);
  if (!(fp=fopen("pm.dat","w"))) {
    fprintf(stderr,"RICHDetector::print: Can't open file: pm.dat\n");
    Exit(1);
    }
  PM *pm;
  for (pm_list.newiterator();(pm=pm_list.iterate());) {
    pm->print(fp);
    }  
  fclose(fp);
 
  } 

