#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>

//#include "rich/RICHOnline.h"
#include "Riter.h"

#ifdef RITER_DEBUG
extern HBookTuple *mtuple1;
extern HBookTuple *mtuple3;
extern  HBookHistogram *hthcer[6];
extern  HBookHistogram *hthcer1[6];
#endif

#ifdef RITER_DEBUG
void fill_ntuple_4(int iev,track_buffer *t,int itip,int iu,float *plkh,float *sfot)
{
#define NVAR 33
  //HepTuple *tuple = tfile->ntuple("ntuple_4");
char tmp[10];
float x[NVAR];
 char *names[NVAR]={"iev","rx","ry","rz",
                        "kx","ky","kz" ,"p",
                  "itip", "iu","thc","sfot",
                    "p0","p1","p2","p3","p4","p5","p6",
                    "n0","n1","n2","n3","n4","n5","n6",
                    "b0","b1","b2","b3","b4","b5","b6" };
iu=1; for (int i=2;i<6;i++)  if (plkh[iu]>plkh[iu]) itip=iu;

 x[0]=iev;
 x[1]=t->r.x();
 x[2]=t->r.y();
 x[3]=t->r.z();
 x[4]=t->dir.x();
 x[5]=t->dir.y();
 x[6]=t->dir.z();
 x[7]=t->p;
 x[8]=itip;
 x[9]=iu;
 x[10]=t->thc[itip];
 x[11]=sfot[itip];
 x[12]=plkh[0];
 x[13]=plkh[1];
 x[14]=plkh[2];
 x[15]=plkh[3];
 x[16]=plkh[4];
 x[17]=plkh[5];
 x[18]=plkh[6];
 x[19]=t->stf[0]+t->bgr[0];
 x[20]=t->stf[1]+t->bgr[1];
 x[21]=t->stf[2]+t->bgr[2];
 x[22]=t->stf[3]+t->bgr[3];
 x[23]=t->stf[4]+t->bgr[4];
 x[24]=t->stf[5]+t->bgr[5];
 x[25]=t->stf[6]+t->bgr[6];
 x[26]=t->bgr[1];
 x[27]=t->bgr[1];
 x[28]=t->bgr[2];
 x[29]=t->bgr[3];
 x[30]=t->bgr[4];
 x[31]=t->bgr[5];
 x[32]=t->bgr[1];
 for (int i=0;i<NVAR;i++) {
   sprintf(tmp,"%s",names[i]);
   mtuple1->column(tmp, x[i]);
 }

 float lam=asin(t->dir.y()/t->dir.mag());
 float phi=atan(t->dir.x()/t->dir.z());
 mtuple1->column("lam",lam);
 mtuple1->column("phi",phi);
 mtuple1->dumpData() ; //   fill ntuple 

 return;
};

#endif


RICHGeometry::RICHGeometry(){

  float anzero_mul=1.;
  x_cut   =0;
  y_cut   =0;
  z_cut   =4500;
  z_magnet=4500;
  float d_pad=9;  
  sig_sfa    =.16e-3;
  sigthc     = 0.000450;
  r_mi= 11400.0;
  char configdir[100];
  char* RICHconfigdir=getenv("RICH_CONFIGDIR");
  if (RICHconfigdir) {
    strcpy(configdir,RICHconfigdir);
    if (configdir[strlen(configdir)-1]!='/') strcat(configdir,"/");
    }
  else {
    char *hb=getenv("HB");
    if (!hb) {
      fprintf(stderr,"RICINI:  $HB is not defined. Abort.\n");
      exit(1);
      }
    strcpy(configdir,hb);
    strcat(configdir,"/geo/RICH/");
    }
                

//  char* RICHconfigdir=getenv("RICH_CONFIGDIR");

  cout << "RICHGeometry: Init geometry from " << RICHconfigdir <<endl;  

  RICHVessel   *RICH_Vessel=new RICHVessel(configdir); 
    if (!RICH_Vessel) { 
      fprintf(stderr,"RICH_Vessel cannot be initialized.Exiting...\n"); 
      exit(1); 
    } 
  RICHVessel &rv = *RICH_Vessel;
  
  // refractive index determination
  
  float lambda=0.000000290; // lambda [m]
  //ref_ind=rv.Radiator().RefractiveIndex(lambda); //temporary
  ref_ind=1.001380; //temporary
  ref_ind=1/cos(0.052);

  // reflection  plane
  
  //rv.spherical_mirror->xyview();
  rp_mu=  toHep3Vector(rv.plane_mirror->SingleMirror(3,0)->x0()); 
  rp_md=  toHep3Vector(rv.plane_mirror->SingleMirror(0,0)->x0()); 
  ezp_mu= toHep3Vector(rv.plane_mirror->SingleMirror(3,0)->ez()); 
  ezp_md= toHep3Vector(rv.plane_mirror->SingleMirror(0,0)->ez()); 
  

  an_zero = 42.00;       // N_0     ???????
  z_rich_min=8600;       // where to get RICH min point
  z_rich_max=11600;      // where to get RICH end point

  th_0= 0.172;  // maximum acceptance  y direction
  fi_0= 0.262;  // maximum acceptance  x  direction
  acc_lens= 0.157;


  // calculate average CoC
  Vec3 up;
  Vec3 dn;
  for (int icol=0;icol<rv.spherical_mirror->numcol();icol++){
    for (int irow=0;irow<rv.spherical_mirror->numrow();irow++){
      Vec3 x0=rv.spherical_mirror->SingleMirror(irow,icol)->x0();
      Vec3 ez=rv.spherical_mirror->SingleMirror(irow,icol)->ez();
      if (irow>3) 
      up+= x0+r_mi*ez;
      else
      dn+= x0+r_mi*ez;
    }
  } 
  rc_mu= 0.025*toHep3Vector(up); // 40 mirrors
  rc_md= 0.025*toHep3Vector(dn);  // 40 mirrors

  cout << "RICH_Detector " << configdir <<endl;

  RICHDetector *RICH_Detector=new RICHDetector(configdir); 
    if (!RICH_Detector) { 
      fprintf(stderr,"RICH_Detector cannot be initialized.Exiting...\n"); 
      exit(1); 
    } 
  RICHDetector &rd=*RICH_Detector;

  Hep3Vector rp_m,ezp_m;
  float xlen=432;           // dimensions of sm [mm]
  float ylen=1152;          // dimensions of sm [mm]
  for (int i=0;i<14;i++){  
    r0[i]= toHep3Vector(rd.SuperModule(i).x0());
    vx[i]= xlen*toHep3Vector(rd.SuperModule(i).ex()); // 
    vy[i]= ylen*toHep3Vector(rd.SuperModule(i).ey());
    vn[i]= -toHep3Vector(rd.SuperModule(i).ez());   

    if (i>6) {  
      rp_m=rp_md;
      ezp_m=ezp_md;
    } else {
      rp_m=rp_mu;
      ezp_m=ezp_mu;
    }
    

    r0[i]=virtual_position(r0[i],rp_m,ezp_m);
    vx[i]=virtual_direction(vx[i],ezp_m);
    vy[i]=virtual_direction(vy[i],ezp_m);
    vn[i]=virtual_direction(vn[i],ezp_m);
  }
  
  an_zero=an_zero/10.;
  float f=r_mi/2;
  sig_pad=d_pad/f/sqrt(12.);
  f_pad=f/d_pad;
  float thc=acos(1./ref_ind);
  rmax2=(1.4*thc*f);
  rmax2*=rmax2;
  
  for (int k=0;k<14;k++) {
    dvx[k]=vx[k].mag2();
    dvy[k]=vy[k].mag2();
  }
  for (int k=0;k<6;k++) {
    float d=(r0[k]+vx[k]-r0[k+1]).mag2();
    dxsm[k]=(sqrt(dvx[k])+sqrt(d))/d_pad ; // units: [padsize]
    //fprintf(stdout,"%2d %f\n", k ,dxsm[k] );
  }
  
  for (int k=7;k<13;k++) {
    float d=(r0[k]+vx[k]-r0[k+1]).mag2();
    dxsm[k]=(sqrt(dvx[k])+sqrt(d))/d_pad ; // units: [padsize]
    //    fprintf(stdout,"%2d %f\n", k ,dxsm[k] );
  }

  
  an_zero=an_zero*anzero_mul;
  p_min=.511E-3/sqrt((ref_ind-1.)*(ref_ind+1.));

  //  photon detector
  int ichan=0;
  int ipmt=0;

  for (int ism=0;ism<14;ism++) {
    for (int icol=0;icol<48;icol++) {
      for (int irow=0;irow<128;irow++){
	idet[irow][icol][ism]=-1;   // not connected
      }
    }
  } 
  for (int i=0;i<NWCHA;i++) bit_map[i]=0;  // empty event		      


  for (int ism=0;ism<NUMSM;ism++){
    for (int ir=0;ir<NUMROW;ir++){
      for (int ic=0;ic<NUMCOL;ic++){
	for (int ich=0;ich<NUMCH;ich++){
	  
	  if(!rd.ChannelExist(ism,ir,ic,ich)) continue;
	  if (ism<7)
	    ixyz[ism][ir][ic][ich]=virtual_position(toHep3Vector(rd.pos()),rp_mu,ezp_mu);
	  else 
	    ixyz[ism][ir][ic][ich]=virtual_position(toHep3Vector(rd.pos()),rp_md,ezp_md);
	  
          if (ich==0) {
	    int itp=rd.pm().numcol();
	    ipmt++;
	    int iir=ir*4;
	    int iic=ic*4;
	    if(idet[iir][iic][ism]>=0) {
	      cout << "pmt already installed here"; 
		cout <<  " sm:"<< ism<<" row:"<<ir<<" col:"<< ic<<  endl;
	      continue;
	    }	  
	    set_pmt(itp,ism,iir,iic,ichan);
	  }
	}
      }
    }
  }
  
  

  delete RICH_Vessel; 
  delete RICH_Detector;


  if(ichan>NCHAN) {
    cout << " out of memory, change parameter NCHAN to (at least)" << endl;
    cout << " #define NCHAN=" <<  ichan << " ) and recompile " << endl;
    exit (0);
  }
  printf("read ichan=%d ipmt=%d\n",ichan,ipmt);    
 


  cout << "RICHGeometry initialised " <<endl;	
};
// -------------------------------------------------------------------------------

int RICHGeometry::print() {
  // initialize geo structure  
//    RICHVessel &rv = *RICH_Vessel;  
//    cout << "ref_ind " <<  ref_ind << endl;
//    cout << "Plane Mirrors" <<endl;
//    // spherical mirrors
//    cout << "Spherical Mirrors" <<endl;
  
//    cout << rv.spherical_mirror->numrow() << endl;
//    cout << rv.spherical_mirror->numcol() << endl;
//    for (int i=0;i<rv.spherical_mirror->numrow();i++) {
//      for (int j=0;j<rv.spherical_mirror->numcol();j++) {
//        //    cout <<  i << " " << j << rv.spherical_mirror->SingleMirror(i,j)->CoC()  ;
//        //    cout << rv.spherical_mirror->SingleMirror(i,j)->radius() <<endl;
//      }
//    }  
  
  
  cout << "Init constants=========" <<endl;
  printf("z_rich_min:%f\n",z_rich_min);
  printf("z_rich_max:%f\n",z_rich_max);
  printf("an_zero:%f\n", an_zero);

  printf("ref_ind:%f\n",  ref_ind);
  printf("th_0:%f\n",  th_0);
  printf("fi_0:%f\n",  fi_0);
  printf("sig_sfa:%f\n",  sig_sfa);
  printf("sigthc:%f\n", sigthc); 
  printf("r_mi:%f\n",  r_mi);
  printf("acc_lens:%f\n", acc_lens);
  cout << "rc_mu " <<  rc_mu << endl;
  cout <<"rc_md: "<<   rc_md << endl;
  cout <<"rc_mu: "<<   rc_mu << endl;
  cout <<"rp_md: "<<   rp_md << endl;
  cout <<"rp_mu: "<<   rp_mu << endl;
  cout <<"ezp_md: "<<  ezp_md << endl;
  cout <<"ezp_mu: "<<  ezp_mu << endl;
    
  for (int i=0;i<14;i++){ 
    printf("\nsm=%d\n",i);
    cout <<" r0: " <<  r0[i] << endl;
    cout <<" vx: " <<  vx[i] << endl;
    cout <<" vy: " <<  vy[i] << endl;
    cout <<" vn: " <<  vn[i] << endl;
  }
  
  cout << "an_zero"  << an_zero<< endl;
return RITER_OK;

};
// -------------------------------------------------------------------------------
void RICHGeometry::read_pmt(FILE *fp1, int &ism,int &irow,int &icol,int &itp,long &line,int &ok)
{
  char tt[80]="";
  int irun=1;
  ism=-1;
  itp=-1;
  while (irun) {
    line++;
    fgets(&tt[0],80,fp1);
    if (strstr(tt,"type")!=NULL) {
      if(itp!=-1) {
	cout << line << " " <<  tt << endl;
	cout << "type defined again"<< endl;
      } 
      if (strstr(tt,"M16")!=NULL) itp=3;
      else  if (strstr(tt,"M4")!=NULL) itp=2;
            else  if (strstr(tt,"M1")!=NULL) itp=1;
                  else {
		    itp=1;
		    cout << line << " " <<  tt<< endl;
		    cout << "unknown pmt type, m1 assumed" << endl;
		  }
    }else if (strstr(tt,"position")!=NULL) {
          sscanf(tt,"%*s %d %d %d", &ism,&irow,&icol);
	  //          fprintf(stderr,"%d %d %d\n",ism,irow,icol);
    }
          else if (strstr(tt,"end")!=NULL) irun=0; 
  
  }
  ok=((itp>0)&&(ism>=0)&&(ism<=13)&&(irow>=0)&&(irow<=31)&&(icol>=0)&&(icol<=11));
  if (!ok) cout << "pmt improperly or not defined" << endl;
  return;
};

 //**** detector channels
//-------------------------------------------------------------      

int RICHGeometry::set_pmt(int type,int ism,int ir,int ic,int &ichan)
{
  // type : m1=1 m4=2 m16=4
  // detector
  if(ichan<NCHAN) {
    int numcol=4/type;
    int dcol=(type-1)*( 4- type);
    if (!dcol) dcol=1;
    for (int ch1=0;ch1<type;ch1++) {
      for (int ch2=0;ch2<type;ch2++) {
	int icol,irow;
	for (int i=0;i<numcol;i++) {
	  icol=ic+i+ch1*dcol;
	  for (int k=0;k<numcol;k++) {
	    irow=ir+k+ch2*dcol;
	    idet[irow][icol][ism]=ichan;
	  }
	}
	icol=ic+ch1*dcol;
	irow=ir+ch2*dcol;
	float sig;
        Hep3Vector r;
	to_xyz(ism,irow,icol,numcol,r,sig);
	ch[ichan].r=r;
	ch[ichan].sig=sig;
	ch[ichan].wt=1.;
	ch[ichan].eff=1.;
	ch[ichan].nh=0;
	//        printf("PMT ichan= %d sm=%d r=%d c=%d x=%f y=%f z=%f %d %d\n",ichan,ism,irow,icol,x,y,z,ic+ch1*dcol,ir+ch2*dcol);
	
	ichan++;
      }
    }
    return RITER_OK;
  } else {
    cout << " out of memory, change parameter NCHAN to (at least)" << endl;
    cout << " #define NCHAN=" <<  ichan << " ) and recompile " << endl;
    exit (0);
  }
  return RITER_OK;
};
/* --------------------------------------------------------------------------*/

Hep3Vector RICHGeometry::src2xyz(int ism,int ir,int ic,int ch)
 
{

  return ixyz[ism][ir][ic][ch];
};

//----------------------------------------------------------------      
void RICHGeometry::to_xyz(int ism,int ir,int ic,int nn,Hep3Vector &r,float &sig)
// detector from planar supermodules
{ 
  float a=(ic+nn/2.)/48;
  float b=(ir+nn/2.)/128;
  r=r0[ism] + a * vx[ism] + b * vy[ism]; 
  float sig0=nn*sig_pad;
  sig=sqrt(sig0*sig0+sigthc*sigthc+sig_sfa*sig_sfa);
  return;
}
//-------------------------------------------------------------      

RICHFaktor::RICHFaktor(){

  char configdir[100];
  char* RITERconfigdir=getenv("RITER_CONFIGDIR");
  if (RITERconfigdir) {
    strcpy(configdir,RITERconfigdir);
    if (configdir[strlen(configdir)-1]!='/') strcat(configdir,"/");
    }
  else {
    char *hb=getenv("HB");
    if (!hb) {
      fprintf(stderr,"RITERINI:  $HB is not defined. Abort.\n");
      exit(1);
      }
    strcpy(configdir,hb);
    strcat(configdir,"/geo/RICH/");
    }
                

  cout << "RITER: RITER_CONFIGDIR " << configdir << endl; 
  char  file_faktor[100];
  char  file_bgrfak[100];
  sprintf(file_faktor,"%s/faktor.dat",configdir);
  sprintf(file_bgrfak,"%s/bgrfak.dat",configdir);

  for (int i=0;i<10;i++) bgrfak[i]=1;
  for (int i=0;i<100;i++) faktor[i]=0;   
  // priprava: faktor
  FILE *fp=fopen(file_faktor,"r");
  if (fp==NULL) {
    fprintf(stderr,"error opening %s\n",file_faktor);
    exit(0);
  } 
  for (int j=0;j<100;j++)  fscanf(fp,"%f", &faktor[j]);
  fclose(fp);
  for (int i =0;i<100;i++) faktor[i]=max(faktor[i],1);
  
  //! priprava: bgrfak

  FILE *fp1=fopen(file_bgrfak,"r");
  if (fp1==NULL) {
    fprintf(stderr,"error opening %s\n",file_bgrfak);
    exit(0);
  } 
  for (int j=0;j<10;j++) fscanf(fp1,"%f", &bgrfak[j]);
  fclose(fp1);
};

Riter::Riter(){

  RICH_geo=new RICHGeometry();
  Faktor  =new RICHFaktor();

  
  bin=.45e-3;                  //! bin size
  niter=20;
  irm=(int) (1.2*acos(1./RICH_geo->ref_ind)/bin);
  
    // initialization for exp_no_phot;
    for (int i=0;i<nnn;i++) {
      float fi=i*2*pi/nnn;
      cfi[i]=cos(fi);
      sfi[i]=sin(fi);
    }

    p_mass[0]=0;
    p_mass[1]=.511e-3;
    p_mass[2]=105.66e-3;
    p_mass[3]=139.57e-3;
    p_mass[4]=493.68e-3;
    p_mass[5]=938.27e-3;
    for (int i=0;i<NDEL;i++) track_selected[i]=0;

};
//-------------------------------------------------------------

int Riter::main (int nfot,int ntra,int neve)
{
  //  calculate other track parameters and expected values
  //  ntra- number of tracks in the event
  //  neve event number
  ntracks=ntra;
  int itra;  // track number  
  for  (itra=0;itra<ntra;itra++) {
    calc_tracks_par(&track[itra]);
  }
   
  //! fill rich buffer
  int nt=0;
  float th_cer;
  Hep3Vector dirf;
  // loop over tracks
  int ntrapion=0;
  for  (itra=0;itra<ntra;itra++){
    zero_iter(itra,pf,irm);
    //loop over photons
    int flag=0;
    for  (int ifot=0;ifot<nfot;ifot++){
      if (foton[ifot].utez>0) {
        int calcok=calc_thcer(foton[ifot],track[itra],th_cer,dirf);
	if (calcok==RITER_OK) {
#ifdef RITER_DEBUG
          if ((track[itra].p>5) &&(itip_mc[itra]==1))  // for pions over 15 GeV
       { 
	 calc_full_thcer(foton[ifot],track[itra],th_cer,dirf);
               
	 hthcer[itip_mc[itra]]->accumulate(th_cer,1);
         if ((th_cer>0.05) && (th_cer<0.055)) flag=0;
         if ((sqrt(track[itra].dir.x()*track[itra].dir.x()+track[itra].dir.y()*track[itra].dir.y()))<
	     0.060*track[itra].dir.z())
	 hthcer1[itip_mc[itra]]->accumulate(th_cer,1);
       }
          if ((track[itra].p>15) &&(itip_mc[itra]==3))  // for pions over 15 GeV
       {
	 calc_full_thcer(foton[ifot],track[itra],th_cer,dirf);
               
	 hthcer[itip_mc[itra]]->accumulate(th_cer,1);
         if ((sqrt(track[itra].dir.x()*track[itra].dir.x()+track[itra].dir.y()*track[itra].dir.y()))<
	     0.060*track[itra].dir.z())
	 hthcer1[itip_mc[itra]]->accumulate(th_cer,1);
       }
#endif
	 if(nt<NTB) {
            
	    ring_tab(itra,ifot,th_cer,bin,pf,foton[ifot].utez,rich,nt);
	  }else {            
	    nt++;
	  }
	}
      }
    }         //ifot
    if (flag) ntrapion++;
  }           //itra
#ifdef RITER_DEBUG
  mtuple3->column("iev",neve);
  mtuple3->column("pion",ntrapion);
  mtuple3->dumpData() ; //   fill ntuple 
#endif  
  if (nt>NTB) {
    cout << "  nt=" << nt << endl;
    cout << "rich buffer overflow; event not processed" << endl;
    return RITER_ERROR;
  }
  //         ! iterate
  for (int iter=0;iter<niter;iter++) ring_iter(rich,nt,pf,ntra,nfot);
  //! calculate likelihood 
  vzero(&plkh[0][0],NHIP*NDEL);
  vzero(&sfot[0][0],NHIP*NDEL);
  int i;
  for (i=0;i<nt;i++) {
    int itra=rich[i].ihit;
    int ifot=rich[i].ifot;
    float thc=rich[i].thc;
    float wi=rich[i].w;
    float sig=foton[ifot].sig;
  
    for (int  k=0;k<NHIP;k++) {
      float thc0=track[itra].thc[k];
      float stfs=track[itra].stf[k];
      float stfb=track[itra].bgr[k];
      fill_lkh(thc,wi,thc0,sig,stfs,stfb,plkh[itra][k],sfot[itra][k]);
      
    } 
  }
  for ( itra=0;itra<ntra;itra++) {

    //!!!! samo za pi,k,p
    for (int  k=0;k<NHIP;k++) {
      float stf_all=track[itra].stf[k]+track[itra].bgr[k];
      int  kk=min(max(ifix(stf_all),0),99);
      float fak=Faktor->faktor[kk];
      float stfh=stf_all/fak;
      float stfn=sfot[itra][k]/fak;
      plkh[itra][k]=plkh[itra][k]+fak*pois_log(stfh,stfn);
      
    } 
    
    
  }
  
#ifdef RITER_DEBUG
  //! fill ntuple
  for (itra=0;itra<ntra;itra++) { 
   fill_ntuple_4(neve,&track[itra],itip_mc[itra],iu[itra],&plkh[itra][0],&sfot[itra][0]);
  }
  
#endif

  return RITER_OK;
}; 

//-------------------------------------------------------------
Hep3Vector   Riter::toRICH(int x,int y,int z,Hep3Vector s){
return 10.*Hep3Vector(x,y,z)+((RICH_geo->z_rich_min-10*z)/s.z())* s;
};

//**** likelihood
int  Riter::fill_lkh(float x,float wi,float x0,float sig,float sph,float bph,float &plkh,float &sfot)
{
#define sq2pi 2.50663
  
  float xx=(x-x0)/sig;
  float f;
  if ((fabs(xx)>3)||(x0==0)) {
    f=fun_bgr(x);
  } else {
    f=sph/sig/sq2pi*exp(-(xx*xx)/2)+fun_bgr(x);
  }

  if ((f<=0)||((sph+bph)<=0)) return RITER_ERROR;//! za vsak slicaj (tak foton zavrzem)
  f=f/(sph+bph);
  plkh+=log(f)*wi;
  sfot+=wi;
  //  printf("f%f sph%f bph%f plkh%f sfot%f <<\n",f,sph,bph, plkh, sfot);
  return RITER_OK;
};
//-------------------------------------------------------------

float  Riter::fun_bgr(float x)
  //  float x; // units of x: [rad]
{
  float a0=-.3893e-1, a1=25.28, a2=-1022., a3=.3531e5; //! c4f10
  float dx=.002;
  float fun_b= max(((a0+x*(a1+x*(a2+a3*x)))/dx),0.); 
  return fun_b;
};
//------------------------------------------------------------
inline float pois_log(float mean,float n)
//! log(poisson(mean,n))
{
  if (mean==0) {
    if (n==0) {
      return 0.;
    } else {
      return -1000.;
    }
  } else {
    float n1=n+1.;
    return n*log(mean)-mean-alogam(n1);
  } 
};
//-------------------------------------------------------------
//**** parameters of a track, expected values

void Riter::measured_dir(track_buffer &t)

// error in track is added here - tomi's mc doesn't smear tracks
// t.r() should already be on rich entrance 
{       
  float p1y=.1703e-4, p2y=58.09, p3y=.8552;
  float p1z=.3507e-4, p2z=77.28, p3z=.8573;
  
  float p_mom=max(t.p,.01);   // treshold for electrons
  float sy=p1y*(1+exp(log(p2y/p_mom)*p3y));
  float sz=p1z*(1+exp(log(p2z/p_mom)*p3z));
  //  printf("t.p=%f sy=%f sz=%f %f\n", t.p,sy,sz,rnd());
  t.sig=sqrt(sy*sy+sz*sz)/2.;
  t.dir.setX(t.dir.x()+sy*sqrt(-2.*log(1.-rnd()))*cos(2.*pi*rnd()));
  t.dir.setY(t.dir.y()+sz*sqrt(-2.*log(1.-rnd()))*cos(2.*pi*rnd()));   
  t.dir=t.dir.unit(); 
  return;
};

//-------------------------------------------------------------     
int Riter::select_track(track_buffer *t)
{ 

  // charged particle
  //if (gean_mass(t->ipart) <=0) return 0;  
  // momentum cut (above electron treshold)
  if (t->p<=RICH_geo->p_min) return 0; 

  //! origin cut (track and momentum should be measured)
  //if (t->r_orig[2]*10>=RICH_geo->z_cut) return 0;

  //! (for numerics reason) 
  //if (t->dir.x()<=0.5) return 0;

//   Hep3Vector r1(0,0,RICH_geo->z_magnet);
//    float path;
//    premica(t->r,t->dir,r1,path,3);
//    return ((fabs(r1.x())>RICH_geo->x_cut)&&(fabs(r1.y())>RICH_geo->y_cut));

return 1;
};
//-------------------------------------------------------------
int Riter::print_tracks_par(track_buffer *t) {
  cout << "**************tracks_par************************" << endl;
  cout << "point at the entrance of RICH " << t->r << endl;
  cout << "direction of the track        " << t->dir << endl;
  cout << "sigma (dir)                   " << t->sig << endl;
  cout << "itype                         " << t->itype << endl;
  cout << "mean photon emmision r0       " << t->r0 << endl;
  cout << "particle hit r1u              " << t->r1u << endl;
  cout << "particle hit r1d              " << t->r1d << endl;
  cout << "particle dir  diru            " << t->diru << endl;
  cout << "particle dir  dird            " << t->dird << endl;
  cout << "ring centers  rcu             " << t->rcu << endl;
  cout << "ring centers  rcd             " << t->rcd << endl;
  cout << "which mirror   =1 upper       " << t->wm << endl;
  cout << "expected cerenkov angles for {e,mu,pi,k,p}  " ;
  for (int j=0;j<6;j++) cout << t->thc[j] << " ";
  cout << endl;
  cout << "expected number of signal photons for {..}  " ;
  for (int j=0;j<6;j++) cout << t->stf[j] << " ";
  cout << endl;
  cout << "expected number of bgr photons for {..}     " ;
  for (int j=0;j<6;j++) cout << t->bgr[j] << " ";
  cout << endl;
 return RITER_OK;
};


//-------------------------------------------------------------
int  Riter::calc_tracks_par(track_buffer *t)

// t.r() should already be on rich entrance 
{
  Hep3Vector  r1, r2;
  int seka;
  float sig_mean[NHIP], acg[NHIP];
  
  // particle hit on upper and lower mirror spheres
  presek_sfera(t->r,t->dir,RICH_geo->r_mi,RICH_geo->rc_mu,t->r1u,r2,seka);
  if (!seka) {
    cout << t->r << t->dir << t->r1u << endl;

    printf("calc_tracks_par: presek_sfera=.false.\n");
    exit(1);
  }
  presek_sfera(t->r,t->dir,RICH_geo->r_mi,RICH_geo->rc_md,t->r1d,r2,seka);
  if(!seka)  {
    printf("calc_tracks_par: presek_sfera=.false.\n");
    exit(1);
  }
  // which mirror is actually hit
  t->wm=(t->r1u.y()>0);
  // mean photon emission point
  if (t->wm) t->r0=(t->r+t->r1u)*0.5;   
  else       t->r0=(t->r+t->r1d)*0.5;
  
  // reflected track: upper mirror
  t->diru=t->dir;
  r1=t->r1u;
  
  odboj_na_sferi(r1,t->diru,RICH_geo->r_mi,RICH_geo->rc_mu);
  // ring center: upper mirror reflection (supermodule plane)
  float au,ad,bu,bd;
  int ismd,ismu;
  presek_detector(t->r1u,t->diru,0,t->rcu,au,bu,ismu);
  // reflected track: lower mirror
  t->dird=t->dir;
  r1=t->r1d;  
  odboj_na_sferi(r1,t->dird,RICH_geo->r_mi,RICH_geo->rc_md);
  // ring center: lower mirror reflection (best sphere detector!!!)
  presek_detector(t->r1d,t->dird,7,t->rcd,ad,bd,ismd);
  
  // expected cerenkov angles, number of signal and bgr photons
  float path=2.*(t->r-t->r0).mag();
  float theta=acos(t->dir.z());
  float alfa,beta;
  int ism;
  if(t->wm) {
    r1=t->rcu;
    alfa=au;
    beta=bu;
    ism=ismu;
  } else {
    r1=t->rcd;
    alfa=ad;
    beta=bd;
    ism=ismd;
  }
  //!! to kasneje spremeni (tudi obe klicani rutini)
  //!! ali je to vredu - r1 ??
  int i;
  for (i=1;i<NHIP-1;i++) {
    t->thc[i]=cher_angle(t->p,p_mass[i],RICH_geo->ref_ind);
    exp_no_phot(t->thc[i],path,theta,alfa,beta,ism,t->stf[i],sig_mean[i],acg[i]);
    //    printf("iz rutine t->stf%f sig%f acg%f\n ",t->stf[i],sig_mean[i],acg[i]);
  }
  t->thc[0]=0;
  t->thc[6]=t->thc[1];
  t->stf[0]=0;
  t->stf[6]=2*t->stf[1];

  float ffot=1.;
  int  k=(int) fabs(t->dir.y()/.025);
  k=min(k,9);
  float fpoz=Faktor->bgrfak[k];
  // to be changed
  
  for (i=0;i<NHIP;i++) {
    t->bgr[i]=exp_no_bgr(i,t->thc,sig_mean,acg);
    t->bgr[i]=t->bgr[i]*ffot*fpoz;
    //printf(" t->bgr[%d] %f t->thc%f,sig_mean%f,acg%f\n",i,t->bgr[i],t->thc[i],sig_mean[i],acg[i]);
  }
  return RITER_OK;
};
//-------------------------------------------------------------

int  Riter::presek_detector(Hep3Vector &r,Hep3Vector &dir,int kje,Hep3Vector &r1,float  &alfa,float  &beta,int &ism)
    // not optimized
  //int kje;               // 0=up, 7=down
{
  Hep3Vector p0, p;
  float sn;
  alfa=-1;
  for (int k=kje+6;((k>=kje)&&(alfa<0));k--) {
    ism=k;
    sn=dir*RICH_geo->vn[k];
    if(sn==0) continue;
    p0=r-RICH_geo->r0[k];
    float s=p0*RICH_geo->vn[k];
    s=-s/sn;
    p=p0+s*dir;
    
    alfa=(p*RICH_geo->vx[k])/RICH_geo->dvx[k];
  }
  //  fprintf(stdout,"kje: %d alfa>=0 : %f dvx=%f\n",k,alfa,RICH_geo->dvx[k]);

  if(sn==0) {
    alfa=1000.;
    beta=1000.;
    p=alfa*RICH_geo->vx[ism]+beta*RICH_geo->vy[ism];         
  } else  beta=(p*RICH_geo->vy[ism])/RICH_geo->dvy[ism];
  r1=p+RICH_geo->r0[ism];
  alfa*=48.;             // pad units
  beta*=128.;
  return RITER_OK;
};
//-------------------------------------------------------------

int  Riter::exp_no_phot(float thc,float path,float theta, float a, float b, int ism, float &stfs, float &sig_mean, float &acg)
  
  // calculates expected number of photons
  //    float thc;   // expected cerenkov angle
  //    float path;  // track length in the radiator
  //    float theta; // angle berween track and p-beam pipe 
  //    float a, b;
  //    int ism;
  //    float stfs, sig_mean, acg;
{     
  // detector
  
  double  sthc=sin(thc);
  sthc*=sthc;
  double dstfs=RICH_geo->an_zero*path*sthc;
  stfs=(float)  dstfs;
  sig_mean=0.;
  acg=0.;
  if(stfs<=0) return RITER_ERROR;
  stfs*=acc_the(theta);

  float col_c=a;
  float row_c=b;
  float r_ch=thc*RICH_geo->f_pad;
  int in=0;
  int k;
  for (int i=0;i<nnn;i++) {
    float row=row_c+r_ch*sfi[i];
    if((row<0)||(row>=128)) continue;
    int irow=(int) row;
    k=ism;
    float col=col_c+r_ch*cfi[i];
    if((col>=48)&&(((k+1)%7)!=0)) {
      col=col-RICH_geo->dxsm[k];
      k++;
    } else { 
      if((col<0)&&((k%7)!=0)) {
	k--;
	col=col+RICH_geo->dxsm[k];
      }
    }

    if((col<0)||(col>=48)) continue;
    int icol=ifix(col);
    int ii=RICH_geo->idet[irow][icol][k];
    if(ii>=0) {

      in++;
      sig_mean+=RICH_geo->ch[ii].sig*RICH_geo->ch[ii].sig;
    }
  }
  acg=((float) in)/nnn;
  stfs*=acg; 
  if(in!=0) sig_mean=sqrt(sig_mean/in);

  //  printf("pred return stfs%f acg%f sigmean%f in %d nnn %d\n",stfs,acg,sig_mean,in,nnn);
  return RITER_OK;
};
//-------------------------------------------------------------

float  Riter::acc_the(float theta)
{
  float thmin=0.010;
  float thmax=0.080;
  int i;
  static  float  c[6]={0,0.56264e-01,50.825,-1152.7,12156.,-49153.};
  if(theta<=thmin) theta=thmin; 
  if(theta>thmax) theta=thmax;
  double cons=c[0];
  double acc_th=c[0];
  for (i=2;i<=5;i++) {
    cons=cons+c[i]*power(thmax,i-1);
    acc_th=acc_th+c[i]*power(theta,i-1);
  }
  //printf("acc_th %f %f %f \n ", acc_th, cons,(float)( acc_th/cons));
  return (float)( acc_th/cons);
};
//-------------------------------------------------------------      

float  Riter::exp_no_bgr(int i,float *thc,float *sig,float *acg)
  
  //int i;//   ! should have values 0,1,2,3,4
  //float *thc, *sig, *acg;
  //float *stfb;
  
#define  nchb 160 
{
  float bgr[nchb];
  float bin=.5e-3;
  float xxx[nchb], yyy[nchb];
  short start=1;
  short hip[NHIP][NHIP]= { {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1},
			   {0,1,1,1,1,1,1} };


  if(start) {
    start=0;
    for  (int k=0;k<nchb;k++){
      float x=(k+.5)*bin;
      bgr[k]=fun_bgr(x)*bin;
    }
  }
  oznaci_bine(&xxx[0],&yyy[0],nchb,bin,&hip[i][0],sig,thc,acg);
  float stfb=0.;
  for (int k=0;k<nchb;k++) stfb+=bgr[k]*xxx[k];  
  return stfb;
};
//-------------------------------------------------------------      

void Riter::oznaci_bine( float *xxx, float *yyy, int nchbc ,float bin, 
		  short *hip, float *sig, float *th, float *acg)
{   
  vzero(xxx,nchbc);
  vzero(yyy,nchbc);
  for (int i=1;i<=5;i++){
    if(hip[i]&&(th[i]>0)) {
      float dx=3.*sig[i];
      int k1=  max((int) ((th[i]-dx)/bin),0);
      int k2=  min((int) ((th[i]+dx)/bin),nchbc-1);
      for (int k=k1;k<=k2;k++) {
	xxx[k]=xxx[k]+acg[i];
	yyy[k]++;
      }
    }
  }
  for (int k=0;k<nchbc;k++) {
    if(yyy[k]) xxx[k]/=yyy[k];
  }
  return;
};
//-------------------------------------------------------------      

int  Riter::part_type(float p_mass)

  //float p_mass;               // [gev]
  //int *itype;
  // itype =1  electron
  //       =2  muon
  //       =3  pion
  //       =4  kaon
  //       =5  proton
  //       =0   ?
{
  float pm=p_mass*1000.;
  if((pm>0.4)&&(pm<0.6 )) return 1;
  if((pm>100)&&(pm<110 )) return 2;
  if((pm>130)&&(pm<150 )) return 3;
  if((pm>400)&&(pm<600 )) return 4;
  if((pm>900)&&(pm<1000)) return 5;
  return 0;
};
//-------------------------------------------------------------      
float Riter::gean_mass(int ipart) {
  
static  float masa[16]={ 0.,.511E-3,.511E-3,0.,.106,.106,-1.,.140,.140,-1.,
		   .494,.494,-1.,.938,.938,-1.};
  
  if ((ipart<=0)||(ipart>16)) {
    return -1;
  } else {
    return masa[ipart-1];
  }
  return -1;
};
//-------------------------------------------------------------      
int Riter::itip_gean(int ipart) {
  
static  int  itip[16]={0,1,1,0,2,2,0,3,3,0,4,4,0,5,5,0};
  if ((ipart<=0)||(ipart>16)) {
    return 0;
  } else {
    return itip[ipart-1];
  }
  return RITER_OK;
};
//-------------------------------------------------------------      
int Riter::itip_lund(int ipart) {
  
  // return =1  electron
  //        =2  muon
  //        =3  pion
  //        =4  kaon
  //        =5  proton
  //        =0   ?

  if (abs(ipart)== 11)  return 1; 
  if (abs(ipart)== 13)  return 2; 
  if (abs(ipart)== 211) return 3; 
  if (abs(ipart)== 321) return 4; 
  if (abs(ipart)== 2212) return 5; 
  if  (abs(ipart) < 6) return 0;
  return ipart;
};
//------------------------------------------------------------- 
int Riter::test_hyp(float *thc,int itype,float th_cer,float dthc)
  
  // to moram se malo spremeniti
{ 
  int ok;
  if(itype>0) {
    int i=itype;
    ok=(fabs(th_cer-thc[i])<dthc)&&(thc[i]>0);
  } else {
    ok=0;
    for (int i=0;i<NHIP;i++)    ok=ok||((fabs(th_cer-thc[i])<dthc)&&(thc[i]>0));
    
  }
  if (ok) return RITER_OK; else return RITER_ERROR;
};

float  Riter::cher_angle(float p,float mass,float ref_ind)
  
  // calculates cerenkov angle
{
  
  if((mass<=0)||(p<0)) {
    cout << " error: mass = " <<  mass << endl;
    cout << " momentum    = " << p << endl ;
    exit(0);
  }
  float a=p/mass;
  float b=a/sqrt(1.+a*a)*ref_ind;
  if(b>1)  return acos(1./b);
  else     return 0. ;
};
//-------------------------------------------------------------      
//**** iterative ring search

void Riter::zero_iter(int ihit,float pf[256][NDEL],int &irm)
  
  // zacetni priblizek za pf
  
  //  int ihit;		// stevilka delca
  //  float *pf;        // histogram (radij,delec)
  //  int *irm;		// max. radij v kanalih
{
  if(irm>255) {
    cout << "itrack=" <<  ihit << "    irm=" << irm << endl;
    irm=255;
    cout << "max. ring radius too large --> set to 255" << endl;
  }
  int ir;
  for (ir=0;ir<= irm;ir++)      pf[ir][ihit]=1;
  for (ir= irm+1;ir<=255;ir++)  pf[ir][ihit]=0;
};
//-------------------------------------------------------------      

int  Riter::ring_tab(int ihit,int ifot,float thc,float bin,float pf[256][NDEL],float utez,richtab *rich,int &n)
// table of radiuses and weights
// every time this function is called
// new particle is inserted in the table
// table is reset if you set n to zero before the call
  /*
    int ihit;		    // stevilka delca
    int ifot;		    // stevilka fotona
    float thc;                  // cerenkov radij fotona
    float bin;                  // bin size
    float *pf;                  // histogram (radij,delec)
    float utez;                 // utez fotona (povprecno stevilo, effi...)
    richtab *rich;              // tabela radijev in utezi
                                // rich.w =  rezultat iteracij
    int *n;                     // stevec tab. radijev, predno zacnes filanje,
				// ga postavi na 0
  */
{
  int  ir= (int) (thc/bin);
  if(ir>255) return RITER_ERROR;
  if(utez<=0) return RITER_ERROR;
  if(pf[ir][ihit]!=0) {
    rich[n].ir=ir;
    rich[n].ihit=ihit;
    rich[n].ifot=ifot;
    rich[n].utez=utez;
    rich[n].thc=thc;
    rich[n].w=utez;
    n++;	
  }
  return RITER_OK;
};  
//-------------------------------------------------------------      

void Riter::ring_iter(richtab *rich,int n,float pf[256][NDEL],int nh,int nf)
// iteracijska procedura
  /*
    richtab *rich;
    int n;
    float *pf;          // histogram (radij,delec)
    int nh;		// stevilo delcev, oznaceni od 1 do nh
    int nf;                // stevilo fotonov, oznaceni od 1 do nf
  */
{
float spf[65536];		// vsota verjetnosti po delcih za i-ti foton
                                // pozor ifot<65537 !!! to nekje testiraj
 
 if(nh>1024) {
   cout << " ring_iter: nh>1024 " << endl;
   exit(0);
 }
 if(nf>65536) {
   cout << " ring_iter: nf>65536 " << endl;
   exit(0);
 }
 
 // filanje spf
 vzero(spf,nf);
 int i;
 for (i=0;i<n;i++) spf[rich[i].ifot]+=pf[rich[i].ir][rich[i].ihit];
 // nove utezi
 for (i=0;i<n;i++) {
   int ifot=rich[i].ifot;
   if(spf[ifot]) rich[i].w=pf[rich[i].ir][rich[i].ihit]/spf[ifot]*rich[i].utez;
   else          rich[i].w=0.;
 }
   // filanje pf
 vzero(&pf[0][0],256*nh);
 for (i=0;i<n;i++) pf[rich[i].ir][rich[i].ihit]+=rich[i].w;
 
 return;
}

//-------------------------------------------------------------      
int  Riter::calc_full_thcer(photon_buffer &f,track_buffer  &t,float &th_cer,Hep3Vector &dirf)
  
//**** cherenkov angle calculation (for known hit-particle)
  // th_cer   cerenkov angle (result)
  // dirf   photon direction (result)
  
  // returned value =OK, if result exists 
{
  int ok;
  Hep3Vector r1, r2;
  if (f.rf.y()>0) {    // upper detector (and mirror)
    // coarse limitation
    if (!((f.rf-t.rcu).mag2()<RICH_geo->rmax2*1.2)) {
      //cout << "rf " << f.rf << endl;
      //cout << "rcu" << t.rcu << endl;
      //cout << "mag2=" << (f.rf-t.rcu).mag2() << "< rmax2="  << RICH_geo->rmax2 << endl;
      //return 1;        
    }
    // approximate cerenkov angle calculation
    r1=f.rf-t.r1u;
    HepDouble s=r1*t.diru;
    HepDouble sn=r1.mag2();
    s=1.-s*s/sn;
    if(s<0) th_cer=0.;
    else    th_cer=sqrt(s);
    // accurate cerenkov angle calculation
    
    if ( cerenkov_kot_0(t.r0,t.dir,f.rf,RICH_geo->rc_mu,RICH_geo->r_mi,th_cer,dirf) !=RITER_OK ) return 3;
    presek_sfera(t.r,dirf,RICH_geo->r_mi,RICH_geo->rc_mu,r1,r2,ok);
    if (!ok) return 5;
    ok=((t.wm)||(r1.y()>0));
  } else {
    // coarse limitation
    //if (!((f.rf-t.rcd).mag2()<RICH_geo->rmax2*1.2)) return 6;
    
    // approximate cerenkov angle calculation
    r1=f.rf-t.r1d;
     float s=r1*t.dird;
     float sn=r1.mag2();
     s=1.-s*s/sn;
    if(s<0) th_cer=0.;
    else    th_cer=sqrt(s);
        // accurate cerenkov angle calculation
    
    if ( cerenkov_kot_0(t.r0,t.dir,f.rf,RICH_geo->rc_md,RICH_geo->r_mi,th_cer,dirf) !=RITER_OK ) return  8;
    
    presek_sfera(t.r,dirf,RICH_geo->r_mi,RICH_geo->rc_md,r1,r2,ok);
    if (!ok) return 10;
    ok=((!(t.wm))||(r1.y()<0));
  }
  if (ok) return RITER_OK; else return 11;
};




//-------------------------------------------------------------      

int  Riter::calc_thcer(photon_buffer &f,track_buffer  &t,float &th_cer,Hep3Vector &dirf)
  
//**** cherenkov angle calculation (for known hit-particle)
  // th_cer   cerenkov angle (result)
  // dirf   photon direction (result)
  
  // returned value =OK, if result exists 
{
  int ok;
  Hep3Vector r1, r2;
  float dx0=1.0e-3;   // max error if emission point taken at mirror
  if (f.rf.y()>0) {    // upper detector (and mirror)
    // coarse limitation
    if (!((f.rf-t.rcu).mag2()<RICH_geo->rmax2)) {
      //cout << "rf " << f.rf << endl;
      //cout << "rcu" << t.rcu << endl;
      //cout << "mag2=" << (f.rf-t.rcu).mag2() << "< rmax2="  << RICH_geo->rmax2 << endl;
      return 1;        
    }
    // approximate cerenkov angle calculation
    r1=f.rf-t.r1u;
    HepDouble s=r1*t.diru;
    HepDouble sn=r1.mag2();
    s=1.-s*s/sn;
    if(s<0) th_cer=0.;
    else    th_cer=sqrt(s);
    float sig=sqrt(f.sig*f.sig+t.sig*t.sig);
    float dx=3.*sig+dx0;
    if (test_hyp(t.thc,t.itype,th_cer,dx) !=RITER_OK ) {
             return 2 ;
    }
    // accurate cerenkov angle calculation
    
    if ( cerenkov_kot_0(t.r0,t.dir,f.rf,RICH_geo->rc_mu,RICH_geo->r_mi,th_cer,dirf) !=RITER_OK ) return 3;

    if ( test_hyp(t.thc,t.itype,th_cer,3.*sig) != RITER_OK ) {
      return 4;
    }
    presek_sfera(t.r,dirf,RICH_geo->r_mi,RICH_geo->rc_mu,r1,r2,ok);
    if (!ok) return 5;
    ok=((t.wm)||(r1.y()>0));
  } else {
    // coarse limitation
    if (!((f.rf-t.rcd).mag2()<RICH_geo->rmax2)) return 6;
    
    // approximate cerenkov angle calculation
    r1=f.rf-t.r1d;
     float s=r1*t.dird;
     float sn=r1.mag2();
     s=1.-s*s/sn;
    if(s<0) th_cer=0.;
    else    th_cer=sqrt(s);
    float sig=sqrt(f.sig*f.sig+t.sig*t.sig);
    float dx=3.*sig+dx0;
    
    if ( test_hyp(t.thc,t.itype,th_cer,dx)!= RITER_OK ) {
      return  7;
    }
    // accurate cerenkov angle calculation
    
    if ( cerenkov_kot_0(t.r0,t.dir,f.rf,RICH_geo->rc_md,RICH_geo->r_mi,th_cer,dirf) !=RITER_OK ) return  8;
    
    if ( test_hyp(t.thc,t.itype,th_cer,3.*sig)!= RITER_OK ) {
      return 9;
    }
    presek_sfera(t.r,dirf,RICH_geo->r_mi,RICH_geo->rc_md,r1,r2,ok);
    if (!ok) return 10;
    ok=((!(t.wm))||(r1.y()<0));
  }
  if (ok) return RITER_OK; else return 11;
};
//-------------------------------------------------------------      

int  Riter::cerenkov_kot(Hep3Vector &r0,Hep3Vector &dir,Hep3Vector &rh,Hep3Vector &rc,float r_mi,float &th_cer,Hep3Vector &dirf)

  // calculation of cerenkov angle from photon hit on detector and part. track
  
  /*
r0;                // point of photon emission (mid point on part. track)
dir;               // particle direction (unit vector)
rh;                // photon hit on detector
rc;
r_mi;              // center of curvature of mirror

th_cer;            // result if
dirf               // result (photon direction vector) if
ok ;               // returned value OK
  */
{
  Hep3Vector r1, r2,rr;
  float r1n, r2n;
  
  float a, b, alfa, th, fi;
  float c1, c2, s_alfa;
  int iter;
  r1=r0-rc;
  r2=rh-rc;
  r1n=r1.mag();
  r2n=r2.mag();
  a=r1n/r_mi;
  b=r2n/r1n;
  alfa=acos((r1*r2)/r1n/r2n);
  if (  resi_sin(a,b,alfa,th,fi,iter,100)!= RITER_OK) return RITER_ERROR;
  s_alfa=sin(alfa);
  c1=r_mi/r1n*sin(alfa-fi)/s_alfa;
  c2=r_mi/r2n*sin(fi)/s_alfa;
  rr=(c1-1.)*r1+c2*r2;
  dirf=rr*(1/rr.mag());
  th_cer=acos(dirf*dir);     
  return RITER_OK;
}
//-------------------------------------------------------------      

int  Riter::resi_sin(float a,float b,float c,float &x, float &y,int & iter,int max_iter)

  // find solution of equations:	sin(x) = a*sin(x+y)
  //		     		       sin(x+y)= b*sin(c+x-y)
  // by iteration
  
  //float a,b,c;                   // coeficients
  //float *x,*y;                   // result
  //int *iter;                     // number of iterations performed
  //int max_iter;                  // max. number of iterations
  //int *ok                      // if all ok
{
  float dxy=1.e-7;          // accuracy
  float xy, abb;
  
  abb=1.-2*a*b+b;
  if(abb==0) {
    iter=0;
    return RITER_ERROR;
  }
  
  x=a*b*c/abb;
  y=(1.-a)*b*c/abb;
  
  for (int i=0;i<max_iter;i++){
    float x1=x;
    float y1=y;
    float abb=b*sin(c+x1-y1);
    if(fabs(abb)>1) {
      iter=i+1;
      return RITER_ERROR;
    }
    xy=asin(abb);
    abb=a*sin(xy);
    if(fabs(abb)>1) {
      iter=i+1;
      return RITER_ERROR;
    }
    x=asin(abb);
    y=xy-x;
    if((fabs(x-x1)<dxy)&&(fabs(y-y1)<dxy)) {
      iter=i+1;
      return RITER_OK;
    }
  }
  
  iter=max_iter;
  return RITER_OK;
};
//-------------------------------------------------------------        

int  Riter::cerenkov_kot_0( Hep3Vector &r0, Hep3Vector &dir, Hep3Vector &rh, Hep3Vector &rc,HepDouble r_mi,float &th_cer,Hep3Vector &dirf)

// calculation of cerenkov angle from photon hit on detector and part. track
//!!! aproksimacija - resi_sin: linear apr
  /*
      Hep3Vector *r0;   // point of photon emission (mid point on part. track)
      Hep3Vector *dir;               // particle direction (unit vector)
      Hep3Vector *rh;                // photon hit on detector
      Hep3Vector *rc; 
      float       r_mi;          // center of curvature of mirror

      float *th_cer;                 // result if
      Hep3Vector *dirf;              // result (photon direction vector) if
      int ok;                      // returned value OK
  */
{ 
  int ok=RITER_ERROR;
  Hep3Vector r1, r2, rr; 
  float r1n, r2n;
  float a, b, alfa, th, fi;
  float c1, c2, s_alfa;
  
  r1=r0-rc;
  r2=rh-rc;
  
  r1n=r1.mag();	
  r2n=r2.mag();	
  a=r1n/r_mi;
  b=r2n/r1n;
  alfa=(r1*r2)/r1n/r2n;
  alfa=max(min(alfa,1.),-1.);
  alfa=acos(alfa);
  if (  resi_sin_0(a,b,alfa,th,fi)!=RITER_OK) return RITER_ERROR;
  s_alfa=sin(alfa);
  c1=r_mi/r1n*sin(alfa-fi)/s_alfa;
  c2=r_mi/r2n*sin(fi)/s_alfa;
     
  rr=(c1-1.)*r1+c2*r2;
  dirf=rr*(1/rr.mag());   
  alfa=dirf*dir;
  alfa=max(min(alfa,1.),-1.);
  th_cer=acos(alfa);     
  ok=RITER_OK;
  return RITER_OK;
};
//-------------------------------------------------------------      

int  Riter::resi_sin_0(float a,float b,float c,float &x,float &y)
  
  // find solution of equations:	sin(x) = a*sin(x+y)
  //				sin(x+y)=b*sin(c+x-y)
  // approximative solution (second order)
  
  //float a,b,c;                // coeficients
  //float *x,*y;                  // result
  //int ok;                // if all ok
{      
  float abb=1.-2*a*b+b;
  if(abb==0) {
    return RITER_ERROR;
  }
  
  x=a*b*c/abb;
  y=(1.-a)*b*c/abb;
  
  float sx=sin(x);
  float cx=cos(x);
  float sxy=sin(x+y);
  float cxy=cos(x+y);
  float scxy=sin(c+x-y);
  float ccxy=cos(c+x-y);
  
  float a11=cx-a*cxy;
  float a12=-a*cxy;
  float b1=a*sxy-sx;
  float a21=cxy-b*ccxy;
  float a22=cxy+b*ccxy;
  float b2=b*scxy-sxy;
  
  float d=a11*a22-a12*a21;
  if(d==0) {
    return RITER_ERROR;
  }
  
  x=x+(b1*a22-b2*a12)/d;
  y=y+(b2*a11-b1*a21)/d;
  return RITER_OK;
};
//-------------------------------------------------------------      	      


void Riter::premica(Hep3Vector &rinit,Hep3Vector &dir,Hep3Vector &rfinl,float  &path,HepInt izb)

//to calculate the second point or the distance between two points
//of line given by:
//rinit   initial point (input)
//dir     unit vector of line direction (input)
//rfinl   final point (input/output)
//path    distance between initial and final points (input/output)
//depending on parameter
//izb =0  path given
//    =1  rfinl(1) given
//    =2  rfinl(2) given
//    =3  rfinl(3) given
//calculates three other unknowns
	
{
  if(izb) {
    
    if(com(dir,izb)) path=(com(rfinl,izb)-com(rinit,izb))/com(dir,izb);

    else {
      cout << "line perpendicular to axis:" << izb << endl;
      exit(0);
    }
  }
  rfinl=rinit+path*(dir);
  return;
};


void Riter::presek_sfera( Hep3Vector  &r,Hep3Vector  &dir,HepDouble radij, Hep3Vector  &rc, Hep3Vector  &r1, Hep3Vector  &r2, int &seka)

//crossection of a line r(),dir() and sphere of radius radij and center rc()
//r1() is concave r2() convex crossection if seka=.true.
{
  Hep3Vector r0;
  r0=r-rc;
  HepDouble rdir=r0*dir;
  float rr=r0.mag2();
  HepDouble d=rdir*rdir+radij*radij-rr;
  if(d<0) {
    seka=0;
    return;
  } else {
    seka=1;
    d=sqrt(d);
    r1=r+(d-rdir)*dir;
    r2=r-(d+rdir)*dir;
    
  }
  return;
};    


void Riter::odboj_na_sferi(Hep3Vector &r,Hep3Vector &dir,HepDouble radij,Hep3Vector &rc)

//geometrical reflection on a sphere of radius radij and with center at rc()
//r() on input:  point where a ray hits the sphere
//    on output: focus, i.e. a point where reflected ray crosses the optical
//		 axis (opt. axis is paralel to impact ray)
//dir() on input: ray's direction (unit vector) before reflection
//      on output: ray's direction (unit vector) after reflection

{
  Hep3Vector n= (r-rc).unit();
  //  n=n.unit();	//normala
  HepDouble a=dir*n;      //scalar product
  r=radij/2./a*dir+rc;
  dir=dir-2.*a*n;
  return;
};

 
// -------------------------------------------------------------------------------
//  void fill_ntuple_5(int ism,int icol,int irow,channel *ch)
//  {
//    //HepTuple *tuple = tfile->ntuple("ntuple_5");

//  #define nvar5_nt 10
//    float x[nvar5_nt];
//    char tmp[10];
//    char *names[nvar5_nt]={ "ISM" , "ICOL","IROW","X","Y","Z","SIG","WT","EFF","NH"};  

//    x[0]=ism;
//    x[1]=icol;
//    x[2]=irow;
//    x[3]=ch->r.x();
//    x[4]=ch->r.y();
//    x[5]=ch->r.z();
//    x[6]=ch->sig;
//    x[7]=ch->wt;
//    x[8]=ch->eff;
//    x[9]=ch->nh;
//    for (int i=0;i<nvar5_nt;i++) {
//      sprintf(tmp,"%s",names[i]);
//      //ntuple->column(names[i], x[i]);
//    }
//    //ntuple->dumpData();
//    return;
//  }

























