#include <iostream>
#include <arte/arte.hh>
//#include <stdlib.h>
//#include <stdio.h>
//#include <math.h>
#include "arte/RSEG_cmp.hh"


#include "rise/RICHEventMC.h"  
#include "Riter.h"




#ifdef RITER_DEBUG
  HBookTuple *mtuple1; 
  HBookTuple *mtuple2; 
  HBookTuple *mtuple3; 
#define MAXHIST 10
  HBookHistogram *hRICH[MAXHIST];
#endif
int myneve=0;


// ---------------------------------------------------------------------------
int  Riter::Fillfotons_HITB(){
  // fill photon structure ****************************************
  int nhitb=0;
  for(ArteTable<HITB>::iterator hitbit=ArteTable<HITB>::begin();
      hitbit!=ArteTable<HITB>::end();++hitbit) {
    ArtePointer<HITB> hitb(hitbit);

    ArteRelationIterator<MIMP> hbmimp = hitb->mimp;
    ArtePointer<MTRA>imtra((*hbmimp)->mtra);

    //    if (imtra->topp->lund!=211) continue; // select only pions 
 
    ArtePointer<GEDE> gede(hitb->gede); 
    if(gede->cmp==5){        // 5 = RICH 
 //       int id=(*hitb->digb.begin())->id;      
//        int ch =  id%100; id=id/100;
//        int col=  id%100; id=id/100;
//        int row=  id%100; 
//        int  sm=  id/100;
 

      //  cout  << RICH_geo->src2xyz(sm,row,col,ch); 
      //  cout << hitb->x << " " <<  hitb->y<< " " <<  hitb->z <<  endl;
      
      foton[nhitb].rf =10.*Hep3Vector(hitb->x,hitb->y,hitb->z);
      if (hitb->y>0) {
         foton[nhitb].rf=virtual_position(foton[nhitb].rf, 
					  RICH_geo->rp_mu, 
					  RICH_geo->ezp_mu);
      } else {
	foton[nhitb].rf=virtual_position(foton[nhitb].rf, 
					 RICH_geo->rp_md, 
					 RICH_geo->ezp_md);
      }  
                
      float sig  = sqrt(sqr( RICH_geo->sig_pad )+ 
                        sqr( RICH_geo->sigthc  )+
                        sqr( RICH_geo->sig_sfa ));
      foton[nhitb].sig  = sig;
      foton[nhitb].utez = 1;
      nhitb++;  

#ifdef RITER_DEBUG        
      if ( myneve<100 ) {
	mtuple2->column("iev",myneve);	
	mtuple2->column("phi",hitb->q);	
	mtuple2->column("lam",hitb->r);
	mtuple2->column("id",(*hitb->digb.begin())->id);
	mtuple2->column("lund",itip_lund(imtra->topp->lund));

	mtuple2->dumpData() ; //   fill ntuple 
      }
      if ( myneve<10 ) hRICH[myneve]->accumulate(hitb->q,hitb->r,1.);
#endif
    }
  }   
return nhitb;
}  
// -------------------------------------------------------------------------
int  Riter::Filltracks_MIMP(){
   int itra=0;

  RICHrings *rich=new RICHrings;
  // loop over RICH MC particles (= at least one photon is radiated)
  

  for ( rich->begin(); rich->valid(); rich->next() ) {
     float tx=rich->tx();
     float ty=rich->ty();
     Hep3Vector r=toHep3Vector(rich->x());
     Hep3Vector mver=10*Hep3Vector(rich->vertex()->x,rich->vertex()->y,rich->vertex()->z);
     int lund=rich->topp()->lund;
     

     //     if (lund !=211) continue; // select only pions
     //     if (rich->momentum()<15) continue; // cut  15 Gev
     //     cout<< "lund:"<< lund<< r<< mver <<  endl;

      if  (fabs(ty)> RICH_geo->th_0) continue;
      if  (fabs(tx)> RICH_geo->fi_0) continue;
      if  (mver.z()> RICH_geo->z_rich_min) continue; // particle should be 
     itip_mc[itra]=itip_lund(lund);
 
     track[itra].dir = Hep3Vector(tx,ty,1).unit();
     track[itra].r    = 10.*r+((RICH_geo->z_rich_min-10*r.z())/track[itra].dir.z())* track[itra].dir;
    
     track[itra].p=min(1000,rich->momentum()); 
     track[itra].itype =0;    //  ???? particle type from MC
     //	track[itra].itype = lund;    //  ???? particle type from MC

     track[itra].sig   = 0;      
     //measured_dir(track[itra]);

    if (select_track(track)) itra++;
  }
  delete rich;  
  cout <<    itra << "MIMP  =>" << endl;
  return itra;
}
// ---------------------------------------------------------------------------

int  Riter::Filltracks_MIMP1(){  
  // fill photon structure ****************************************
  int itra=0;
  int unsigned indx=0;
  cerr << " Filltracks_MIMP1" << endl;
  for(ArteTable<MTRA>::iterator hitbit=ArteTable<MTRA>::begin();
      hitbit!=ArteTable<MTRA>::end();++hitbit) {
    
    ArtePointer<MTRA> mtra(hitbit);
    for(ArteRelationIterator<MIMP> itmimp = mtra->mimp.begin();
        itmimp != mtra->mimp.end();++itmimp )
      {                          
	ArtePointer<MIMP> mimp(itmimp);
	
       	if (indx!= mtra.index()) {
	  indx= mtra.index();
	  if ( mimp->z < 600 ) continue; 
	  if ( mimp->z > (RICH_geo->z_rich_max/10) ) continue; 

	  if ( mimp->p < 0.1 ) continue; 
	  if  (fabs(mimp->ty)> RICH_geo->th_0) continue;
	  if  (fabs(mimp->tx)> RICH_geo->fi_0) continue;

	  cout << "index " << mtra.index(); 
	  cout << " lund "    << mtra->topp->lund  << " : ";
	  cout << "("<<mimp->x << ","<<mimp->y << ","<<mimp->z << "==" ;
	  cout << mimp->tx << " ," << mimp->ty << "):" <<  mimp->p << "," << endl; 
	  
	  track[itra].dir = Hep3Vector(mimp->tx,mimp->ty,1).unit();
	  track[itra].r    = toRICH(mimp->x,mimp->y,mimp->z,track[itra].dir);
	  track[itra].p=min(1000,fabs(mimp->p)); 
	  track[itra].itype =itip_lund(mtra->topp->lund); 
	  track[itra].itype =0; 
	  track[itra].sig   = 0; 
	  
	  //	  mimp= (*mtra->mimp.end());
	  itra++;
	}
       
	
	//   **************************************************
      }
  }
  cerr << " Filltracks_MIMP1 out" << endl;
  return itra;
}  

int  Riter::Filltracks_MIMP2(){  
  // fill photon structure ****************************************
  int itra=0;
  int unsigned indx=0;
  cerr << " Filltracks_MIMP2" << endl;
  for(ArteTable<MIMP>::iterator hitbit=ArteTable<MIMP>::begin();
      hitbit!=ArteTable<MIMP>::end();++hitbit) {
    
    ArtePointer<MIMP> mimp(hitbit);
    
    if ( mimp->z < 600 ) continue; 
    if ( mimp->z > (RICH_geo->z_rich_min/10+100.) ) continue; 
    if ( mimp->p < 0.1 ) continue; 
    if  (fabs(mimp->ty)> RICH_geo->th_0) continue;
    if  (fabs(mimp->tx)> RICH_geo->fi_0) continue;
    int lund=mimp->mtra->topp->lund;
    cout << "index " << indx; 
    cout << " lund "    << lund  << " : ";
    cout << "("<<mimp->x << ","<<mimp->y << ","<<mimp->z << "==" ;
    cout << mimp->tx << " ," << mimp->ty << "):" <<  mimp->p << "," << endl; 
    
    
    track[itra].dir = Hep3Vector(mimp->tx,mimp->ty,1).unit();
    track[itra].r    = 10.*Hep3Vector(mimp->x,mimp->y,mimp->z)+
      ((RICH_geo->z_rich_min-10*mimp->z)/track[itra].dir.z())* track[itra].dir;
    // pf signed according to charge
    track[itra].p=min(1000,fabs(mimp->p)); 
    track[itra].itype =itip_lund(lund);    //  part type from MC     
    track[itra].sig   = 0; 
    
    itra++;
  }
  
  cerr << itra <<"tracks  Filltracks_MIMP1 out" << endl;
  return itra;
}  

// -------------------------------------------------------------------------

int  Riter::Filltracks_RPNT(){
  int itra=0;
  
  // fill track structure **************************************

  int alltracks=0;
  for(ArteTable<RTRA>::iterator rtra1it=ArteTable<RTRA>::begin();
      rtra1it!=ArteTable<RTRA>::end();++rtra1it) {
    
    ArtePointer<RTRA> rtra(rtra1it);
    track_selected[alltracks]=0;

    //      cout << " index " << rtra->mtra.index(); 
    //      cout << " code"    << rtra->mtra->topp->gean << endl;

    //if ((rtra->fit%10)==0) 
    for ( ArteRelationIterator<RPNT> rpntIt = rtra->rpnt.begin();
	  rpntIt != rtra->rpnt.end(); ++rpntIt ) {
      ArtePointer<RPNT> rp(*rpntIt);
      // ************************************************************
      // track selection is done here
      // ************************************************************
      if  (rp->zf<600) continue;
      if  (rp->zf>1250) continue;

      if  (fabs(rp->tyf)> RICH_geo->th_0) continue;
      if  (fabs(rp->txf)> RICH_geo->fi_0) continue;
 
      track_selected[alltracks]=1;
      track[itra].dir = Hep3Vector(rp->txf,rp->tyf,1).unit();
      track[itra].r    = 10.*Hep3Vector(rp->xf,rp->yf,rp->zf)+
	((RICH_geo->z_rich_min-10*rp->zf)/track[itra].dir.z())* track[itra].dir;
      // pf signed according to charge
      if (rp->pf!=0)    track[itra].p=min(1000,fabs(1/rp->pf)); 
      else track[itra].p=0;          
      track[itra].itype = 0;    //  ???? particle type from MC
      track[itra].sig   = sqrt(rp->cvf[5]+rp->cvf[9]); 

      if (select_track(track)) itra++;
      break;
      // ************************************************************
    }
    alltracks++;    
  }
#ifdef RITER_DEBUG
  cout <<    itra << "points on track  found out of tracks=>" << alltracks<< endl;
#endif
return itra;
}

// -------------------------------------------------------------------------

int  Riter::Filltracks_RSEG(){
  int itra=0;
  
  // fill track structure **************************************

  int alltracks=0;
  for(ArteTable<RSEG>::iterator rtra1it=ArteTable<RSEG>::begin();
      rtra1it!=ArteTable<RSEG>::end();++rtra1it) {
    
    ArtePointer<RSEG> rtra(rtra1it);
    if (rtra->cmp==Rsegc::patt) { 

      //      ArtePointer<MTRA>imtra(rtra->mtra);
      //      cout << " index " << imtra.index(); 
      //      cout << " code"    << imtra->topp->gean << endl;

      // ************************************************************
      // track selection is done here
      // ************************************************************
      if  (rtra->zf<500) continue;
      if  (rtra->ze>1250) continue;

      if  (fabs(rtra->tye)> RICH_geo->th_0) continue;
      if  (fabs(rtra->txe)> RICH_geo->fi_0) continue;
 

      track[itra].dir = Hep3Vector(rtra->txe,rtra->tye,1).unit();
      track[itra].r    = 10.*Hep3Vector(rtra->xe,rtra->ye,rtra->ze)+
	((RICH_geo->z_rich_min-10*rtra->ze)/track[itra].dir.z())* track[itra].dir;
      // pf signed according to charge
      if (rtra->pe!=0)    track[itra].p=min(1000,fabs(1/rtra->pe)); 
      else track[itra].p=0;          
      track[itra].itype = 0;    //  ???? particle type from MC
      track[itra].sig   = sqrt(rtra->cvf[5]+rtra->cvf[9]); 
      
      itra++;
      
      // ************************************************************
    }
    alltracks++;    
  }
#ifdef RITER_DEBUG
  cout <<    itra << "points on track  found out of tracks=>" << alltracks<< endl;
  
#endif
  return itra;
}


// --------------------------------------------------------------------------

int  Riter::Filltracks_RCCL(){
  int itra=0;
  
  // fill track structure **************************************
  for(ArteTable<RCCL>::iterator rtra1it=ArteTable<RCCL>::begin();
      rtra1it!=ArteTable<RCCL>::end();++rtra1it) {
    
    ArtePointer<RCCL> rtra(rtra1it);
      // ************************************************************
      // track selection is done here
      // ************************************************************
      if  (fabs(rtra->y/rtra->z)> RICH_geo->th_0) continue;
      if  (fabs(rtra->x/rtra->z)> RICH_geo->fi_0) continue;
      Hep3Vector drx = Hep3Vector(rtra->x/rtra->z,rtra->y/rtra->z,1).unit();
      track[itra].dir = drx;
      track[itra].r    = 10.*Hep3Vector(rtra->x,rtra->y,rtra->z)+
	((RICH_geo->z_rich_min-10*rtra->z)/drx.z())* drx;
      // pf signed according to charge
      if (rtra->esum!=0)    track[itra].p=min(1000,rtra->esum); 
      else track[itra].p=0;          
      track[itra].itype = 0;    //  ???? particle type from MC
      track[itra].sig   = sqrt(rtra->cve[5]+rtra->cve[9]); 

      itra++;
      // ************************************************************
  
  }
#ifdef RITER_DEBUG
  cout <<    itra << "clusters found  =>" << endl;
#endif
  return itra;
}

// -------------------------------------------------------------------------------

void Riter::FillRTRA() {
  int itra=0;
  int alltracks=0;
  for(ArteTable<RTRA>::iterator rtra1it=ArteTable<RTRA>::begin();
      rtra1it!=ArteTable<RTRA>::end();++rtra1it) {    
    ArtePointer<RTRA> rtra(rtra1it);
    //cout << rtra->fit<< " fit " << endl;
    if (track_selected[alltracks]) {
      float sum=0;
      for (int i=1;i<6;i++) sum+=plkh[itra][i];
      int type=0;
      for (int i=1;i<6;i++) if (plkh[itra][i]>plkh[itra][0]) type=1;
      if (!type) sum=sum*10; 
      if (sum!=0) sum=1/sum;  else sum=0;
      rtra->lre =plkh[itra][1]*sum;
      rtra->lrmu=plkh[itra][2]*sum;
      rtra->lrpi=plkh[itra][3]*sum;
      rtra->lrk =plkh[itra][4]*sum;
      rtra->lrp =plkh[itra][5]*sum;
      rtra->flr=1;
      itra++;
    } else {
      rtra->flr=0;
    }
    alltracks++;
  }


}
// --------------------------------------------------------------------------

//  void Riter::FillRSEG() {
//   for (int itra=0;itra<ntracks;itra++) { 
//     int itip=1; for (int i=2;i<6;i++)  if (plkh[itra][i]>plkh[itra][itip]) itip=i;   
   
//     RSEG r;
//     ArtePointer<RSEG>rseg;
//     // float lam=asin(track[itra].dir.y()/track[itra].dir.mag());
//     // float phi=atan(track[itra].x()/track[itra].dir.z());
   
//     r.xf=track[itra].r.x();
//     r.yf=track[itra].r.y();
//     r.zf=track[itra].r.z();
//     r.txf=track[itra].dir.x()/track[itra].dir.z();
//     r.tyf=track[itra].dir.z()/track[itra].dir.z();
//     r.pf=sfot[itra][itip];
//     r.dtim=track[itra].thc[itip];
                     
//     r.cvf[ 0]=plkh[itra][1];
//     r.cvf[ 1]=plkh[itra][2];
//     r.cvf[ 2]=plkh[itra][3];
//     r.cvf[ 3]=plkh[itra][4];
//     r.cvf[ 4]=plkh[itra][5];
//     r.cmp = Rsegc::rich;
//     rseg=ArteTable<RSEG>::push_back(r);
//   }
//  }

// --------------------------------------------------------------------------
int  Riter::Riter_evnt(){

  //  int itra=Filltracks_MIMP();
  // int itra=Filltracks_RSEG();
  //   int itra=Filltracks_RCCL();

  int itra=Filltracks_RPNT();
  int nhitb=Fillfotons_HITB();
  main(nhitb,itra,myneve);
  FillRTRA();

  //FillRSEG();
  return RITER_OK;
};



Riter *reco_Riter;

#ifdef RITER_DEBUG
 HBookHistogram *hthcer[6];
 HBookHistogram *hthcer1[6];
#endif

extern "C" {
  void Riter_init_(){
#ifdef RITER_DEBUG
     mtuple1=new HBookTuple("tracks",2000,"ARTE"); 
     mtuple2=new HBookTuple("hitb",2001,"ARTE"); 
     mtuple3=new HBookTuple("info",2002,"ARTE"); 
     hthcer[1]  =new   HBookHistogram("thcer el",        200,0.050,0.055);
     hthcer1[1] =new   HBookHistogram("thcer el >60mrad",200,0.050,0.055);
     hthcer[3]  =new   HBookHistogram("thcer pions",     200,0.050,0.055);
     hthcer1[3] =new   HBookHistogram("thcer pions >60mrad",200,0.050,0.055);
#endif
      reco_Riter=new Riter(); 
     
  }
 
 
  void Riter_evnt_(){
#ifdef RITER_DEBUG
    cout << "RITER start_evnt" << endl;

     char tmpc[10];
     sprintf(tmpc,"%d",myneve);
     if (myneve < MAXHIST)  
     hRICH[myneve]=new   HBookHistogram(tmpc,200,-.25,.25,200,-.25,.25,1000+myneve); 
   
#endif

    reco_Riter->Riter_evnt();
    myneve++;


#ifdef RITER_DEBUG
    cout << "RITER end_evnt" << endl;
#endif
  }
  
  void Riter_stop_(){
    delete reco_Riter;
  }
}
  
	   







