#include  <stdio.h>

#include "silarte/silarte.hh"

#include "aframelib.h"
#include "iol.h"
#include "silraw.h"
#include "marvin.h"
#include "vdsleda.h"
#include "holmes.h"
#include "svdalign.h"
#include "sileff.h"

#include  "grr.h"

// some arguments for aframe
extern       int    nArg;
extern const char **vArg;

//-----------------------------------------------------------------

int SvdInit()
{
  char *routine = "SvdInit";

  // Initilialize some control words
  aframe_store_program_name(vArg[0]);

  // initialize parameters of other packages
  aframe_param_init();
  iol_param_init();
  vdsleda_param_init();
  silraw_param_init();
  silarte_param_init();
  marvin_param_init();
  holmes_param_init();
  svdalign_param_init();
  sileff_param_init();

  // preferences are loaded here
  if ( aframe_process_args(nArg, vArg, AFRAME_CLI) != AFRAME_OK ) {
    aframe_mess(routine,GRR_SFATAL,"Error processing arguments.");
    return GRR_FISHY;
  }

  return GRR_OK;
}
