/* Global Includes: */
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>

#include "silarte/../CVStag.silarte"
#include "silarte/silarte.hh"

#include "grr.h"

#include "iol.h"
#include "aframelib.h"


/* functions and iol-structure are C-callable */
extern "C" {

/* structure for IOL */
Silarte_Iol_t silarte_iol = {
   xcvsMODULE_silarte     ,IOL_NVERBS(Silarte_Iol_t,0),
  {"version"              ,xcvsVERSION_silarte,        IOL_TYPE_STRING},
  {"hit resolution"       ,0.0030             ,  " " , IOL_TYPE_FLOAT},
  {"efficiency"           ,-1.                ,  " " , IOL_TYPE_FLOAT},
  {"double hit resolution",-1.                ,  " " , IOL_TYPE_FLOAT},
  {"noise rate"           ,0.                 ,  " " , IOL_TYPE_FLOAT},
  {"debug mode"           ,0                  ,  " " , IOL_TYPE_FLAG},
};

/* ------------------------------------------------------------------------
 *
 *  Initialize aframe.
 *
 *  To be called before everything else.
 *  Done is (among others):
 *    - Some initialization
 *
 * ------------------------------------------------------------------------ */
int silarte_param_init()
{
  char  mess[256];
  char *routine = "silarte_param_init";

  /* initialize iol parameters of silarte package */
  iol_declare_structure((IOL_GENERIC *) &silarte_iol);

  sprintf(mess,"silarte version %s started.",silarte_iol.version.value);
  aframe_output_error_mess(mess,routine,GRR_SINFO);

  return GRR_OK;

}

}  /* end of extern C */
