*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_LAY(X1,Y1,X2,Y2,X3,Y3,N_BLOK,AA,BB,CC,DD)

**********************************************************************
*
* Description: determined the plane coefficients in each of TRD blok.
*
*
* Called from: TRD_TRA
*
*          in: X1,Y1,X2,Y2,X3,Y3 - X, Y coordinates
*         out: AA, BB, CC, DD    - plane coefficient
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      
      REAL X1, Y1, X2, Y2, X3, Y3, Z1, Z2, Z3, AA, BB, CC, DD,
     +     EE, FF, MM, X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      INTEGER N_BLOK

      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT

      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)

C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
c      PRINT *,'START LAYER analysis for TRD'
C
      Z1 = Z_BL_ST(N_BLOK,1)
      Z2 = Z_BL_ST(N_BLOK,16)
      Z3 = Z_BL_ST(N_BLOK,16)
C
      EE = (Y2 - Y1)*(Z3 - Z1) - (Z2 - Z1)*(Y3 - Y1)
      FF = (X2 - X1)*(Z3 - Z1) - (Z2 - Z1)*(X3 - X1)
      MM = (X2 - X1)*(Y3 - Y1) - (Y2 - Y1)*(X3 - X1)
C
      AA = EE
      BB = -1.*FF
      CC = MM
      DD = Y1*FF - X1*EE - Z1*MM
C
c              WRITE
c     +  (*,'(''LAYER_TRD==>'',4(1X,F9.3), I4)')
c     +    AA, BB, CC, DD, N_BLOK
C
c      PRINT *,'STOP LAYER analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_TRA
************************************************************************
