*-- Author :         Ruediger Mahn
*-- Last change :        17-Nov-97
************************************************************
      SUBROUTINE VTWIR(iw)
*                                                          *
* Action :  Fill Wire Buffer of Vertex Package             *
*                                                          *
* Input :  iw  number of wire in table GTAR                *
*                                                          *
************************************************************

*** Variable declaration
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GTAR.fi"

#include "vt/vtwire.fi"

      INTEGER  iw, verti,ifail

      DOUBLE PRECISION  pihalf, dwtar

*** Data definition
      PARAMETER  ( pihalf=1.5707963 )

*** Declaration of statement functions

#include "arte/Arte.ff"
#include "auto/GTAR.ff"

*** Begin
* Wire orientation
      IF (ABS(FGTAR_DY(iw)).GT.ABS(FGTAR_DX(iw))) THEN
        IF (FGTAR_X(iw).LT.0.) THEN
          verti = -1
        ELSE
          verti = 1
        ENDIF
      ELSE
        verti = 0
      ENDIF

* Wire Position and rotation angles
      XW(1,iw) = DBLE(FGTAR_X(iw))
      XW(2,iw) = DBLE(FGTAR_Y(iw))
      XW(3,iw) = DBLE(FGTAR_Z(iw))
      THEW(iw) = 0.D0
      PHIW(iw) = verti*pihalf

* RMS Width and length of wire (in beam direction)
      dwtar = MIN(FGTAR_DX(iw),FGTAR_DY(iw))
      SIGTW(iw) = DBLE(dwtar)/SQRT(12.D0)
      SIGLW(iw) = FGTAR_DZ(iw)/SQRT(12.D0)


      RETURN
      END

************************************************************
* End of VTWIRE                                            *
************************************************************
