/*----------------------------------------------------------------
 *
 *   OTrDecode Library:                               
 *
 *----------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include "OTrDecode.h"
#include <string.h>
#include <signal.h>
/*
#include "component.h"
#include "grr.h"
#include "etb.h"
*/

extern int good_tdc[MAXFED];

/******************************************************************************/
/*                                                                            */
/* unsigned char *OTr_decode_TDC_init(                                        */
/*        Tables_filename    -- File with list of cable  tables,              */
/*        TDC_table_filename -- "crate+board" to FED correspondence table     */
/*       );                                                                   */
/*                                                                            */
/* table stucture:                                                            */
/*                                                                            */
/* bit:                desciption:                                            */
/* 0,1                 Namber of lines in cable  tables (Nstr)                */
/* 2 -- Nstr*50+2      lines                                                  */
/* Nstr*50+3 --                                                               */
/*  Nstr*50+2+132000   FED->Connectors                                        */
/* Nstr*50+3+132000 -                                                         */
/* -Nstr*50+2+170000   (FED,Conn)->line                                       */
/* Nstr*50+3+170000 -                                                         */
/*  Nstr*50+2+470000   (SL,Layer,Sector,ftbASD)->line                         */
/*                                                                            */
/*                                                                            */
/* Return:      Pointer to beginning of table or NULL if error.               */
/* Description: Fills table for fast decoding.                                */
/******************************************************************************/

unsigned char *OTr_decode_TDC_init(const char *Tables_filename,
                                   const char *TDC_table_filename){
FILE *Table,*TDC_Table,*File;
unsigned int  i,j,k;
unsigned int  Nstr=1;
unsigned int  offset;
unsigned int  FED;
unsigned int  pos=0;

unsigned char Side;
unsigned char SL;
unsigned char Layer;
unsigned char Sector;
unsigned char ftbASD;

unsigned char Crate;
unsigned char Slot;
unsigned char Conn;

char *str;
char *Filename;
char *buffer;  
/*----------------------------------------------------------------------------*/
  Filename=malloc(256);
  str=malloc(256);
  buffer=malloc(1000000);
  for(i=0;i<1000000;i++) buffer[i]=0;

  if(str==NULL || Filename==NULL || buffer==NULL){ 
         printf("\n\nMemory allocation error\n\n");
         return NULL;
  }

  Table=fopen(Tables_filename,"r");
  if(Table==NULL){ 
         printf("\n\nError: Can't open file %s\n\n",Tables_filename);
         return NULL;
  } 

  TDC_Table=fopen(TDC_table_filename,"r");
  if(TDC_Table==NULL){ 
         printf("\n\nError: Can't open file %s\n\n",TDC_table_filename);
         return NULL;
  } 

/*----------------------------------------------------------------------------*/

  do{   /*-----------------Tables loop----------------------------------------*/
     if(fscanf(Table,"%s",Filename)==EOF) break; 

     File=fopen(Filename,"r");
     if(File==NULL){ 
         printf("\n\nError: Can't open file %s\n\n",Filename);
         return NULL;
     } 
    
     fgets(str, 255, File);
     do{ /*-----------------String loop---------------------------------------*/
        if(fgets(str, 255, File)==NULL) break; 
        j=0; 
        for(i=0;i<=254;i++) {
           if(str[i]==0) break;
	   if(str[i]=='m' || str[i]=='p' || str[i]=='t' || str[i]=='s'){
              j++;
       	      if(j==1){                                 /*---gencha1---*/
		if(str[i-1]=='+') Side=2;               /*-Right side--*/
		else if(str[i-1]=='-') Side=1;          /*-Left side---*/
		else Side=10;                           /*---No side---*/
		k=0;
		if(str[i]=='m') k=0;                    /*-----MC------*/
		if(str[i]=='p') k=10;                   /*-----PC------*/
		if(str[i]=='t') k=20;                   /*-----TC------*/
		if(str[i]=='s') k=30;                   /*-----MS------*/
		buffer[2+Nstr*50]=Side;
		buffer[2+Nstr*50+1]=k+atoi(str+i+1);    /*-----SL------*/
		buffer[2+Nstr*50+2]=atoi(str+i+3);      /*----Layer----*/
		buffer[2+Nstr*50+3]=atoi(str+i+5);      /*----Sector---*/
		buffer[2+Nstr*50+4]=(int)(atoi(str+i+8)/256);
		buffer[2+Nstr*50+5]=atoi(str+i+8)%256;  /*-----Ch0-----*/
	      }  
	      if(j==2){                                 /*---gencha2---*/
		buffer[2+Nstr*50+6]=atoi(str+i+3);
		buffer[2+Nstr*50+7]=atoi(str+i+5);
		buffer[2+Nstr*50+8]=(int)(atoi(str+i+8)/256);
		buffer[2+Nstr*50+9]=atoi(str+i+8)%256;  /*-----Ch1-----*/
	      }
	      if(j==3){                                 /*---modcha1---*/
		buffer[2+Nstr*50+10]=atoi(str+i+3);
		buffer[2+Nstr*50+11]=atoi(str+i+5);
		buffer[2+Nstr*50+12]=atoi(str+i+8);
		buffer[2+Nstr*50+13]=atoi(str+i+11);
	      }
	      if(j==4){                                 /*---modcha2---*/
		buffer[2+Nstr*50+14]=atoi(str+i+3);
		buffer[2+Nstr*50+15]=atoi(str+i+5);
		buffer[2+Nstr*50+16]=atoi(str+i+8);
		buffer[2+Nstr*50+17]=atoi(str+i+11);
	      }
	      if(j==5){                                 /*----modhv----*/
		buffer[2+Nstr*50+18]=atoi(str+i+3);
		buffer[2+Nstr*50+19]=atoi(str+i+5);
		buffer[2+Nstr*50+20]=atoi(str+i+8);
		buffer[2+Nstr*50+21]=atoi(str+i+11);
	      }
	      if(j==6){                                 /*----ftbpos---*/
		buffer[2+Nstr*50+22]=atoi(str+i+3);
		buffer[2+Nstr*50+23]=atoi(str+i+5);
		buffer[2+Nstr*50+24]=str[i+8];
		buffer[2+Nstr*50+25]=atoi(str+i+9);
	      }
	      if(j==7){                                 /*----ftbasd---*/
		buffer[2+Nstr*50+26]=atoi(str+i+3);     
		buffer[2+Nstr*50+27]=atoi(str+i+5);
		buffer[2+Nstr*50+28]=atoi(str+i+8);     /*---ftbASD----*/
	      }
	      if(j==8){                                 /*----ftbhv----*/
		buffer[2+Nstr*50+29]=atoi(str+i+3);     
		buffer[2+Nstr*50+30]=atoi(str+i+5);
		buffer[2+Nstr*50+31]=atoi(str+i+8);    
	      }
	      if(j==9){                                 /*----ftbcab---*/
		buffer[2+Nstr*50+32]=atoi(str+i+3);     
		buffer[2+Nstr*50+33]=atoi(str+i+5);
		buffer[2+Nstr*50+34]=atoi(str+i+8);    
	      }
	      if(j==10){                                /*----lvpos----*/
		buffer[2+Nstr*50+35]=atoi(str+i+3);
		buffer[2+Nstr*50+36]=str[i+6];
		buffer[2+Nstr*50+37]=atoi(str+i+7);
	      }
	      if(j==11){                                /*----lvcab----*/
		buffer[2+Nstr*50+38]=atoi(str+i+3);     
		buffer[2+Nstr*50+39]=atoi(str+i+5);
		buffer[2+Nstr*50+40]=atoi(str+i+8);    
	      }
	      if(j==12){                                /*---tdccab----*/
		buffer[2+Nstr*50+41]=atoi(str+i+3);     
		buffer[2+Nstr*50+42]=atoi(str+i+5);
		buffer[2+Nstr*50+43]=atoi(str+i+8);    
	      }
	      if(j==13){                                /*---tdccon----*/
		buffer[2+Nstr*50+44]=atoi(str+i+3);     
		buffer[2+Nstr*50+45]=atoi(str+i+5);
		buffer[2+Nstr*50+46]=atoi(str+i+8);
		Nstr++;    
	      }

	   }
	}	
     }while(1);  /*----------end of string loop-------------------------------*/
     fclose(File); 
  }while(1); /*--------------end of tables loop-------------------------------*/ 
  buffer[0]=(int)(Nstr/256); buffer[1]=Nstr%256;

/*-----------------------(add FED in strings)---------------------------------*/
  fgets(str, 100, TDC_Table);
  fgets(str, 100, TDC_Table);
  do{ /*-----------------String-loop------------------------------------------*/
        if(fgets(str, 100, TDC_Table )==NULL) break; 

    	   if(str[0]=='+') Side=2;             /*-Right side--*/
           else if(str[0]=='-') Side=1;        /*-Left side---*/
           else Side=10;                       /*---No side---*/
           j=0;
           if(str[1]=='m') j=0;                /*-----MC------*/
	   if(str[1]=='p') j=10;               /*-----PC------*/
	   if(str[1]=='t') j=20;               /*-----TC------*/
	   if(str[1]=='s') j=30;               /*-----MS------*/
           SL=j+atoi(str+2);
           Crate=atoi(str+4);
           Slot=atoi(str+6);
	   FED=atoi(str+10);
    
  
           for(i=0;i<=Nstr;i++){
             if(Side==buffer[2+i*50] && SL==buffer[2+i*50+1] &&
                Crate==buffer[2+i*50+44] && Slot==buffer[2+i*50+45]){
		 buffer[2+50*i+47]=(int)(FED/256); /*---FED---*/
		 buffer[2+50*i+48]=FED%256;
		
              
	     }   
	   }
  }while(1);  /*----------end of string loop----------------------------------*/
  fclose(TDC_Table); 

/*-------------------(make links (FED,Conn)->String)--------------------------*/
  j=0;
  for(i=0;i<Nstr;i++){
     FED=buffer[2+50*i+47]*256+buffer[2+50*i+48];  
     if(FED!=0){   
       if((buffer[2+50*Nstr+(FED-1)*2]*256+buffer[2+50*Nstr+(FED-1)*2+1])==0){
          j++;
	  buffer[2+50*Nstr+(FED-1)*2]=(int)(j/256);
	  buffer[2+50*Nstr+(FED-1)*2+1]=j%256;
       }
       pos=buffer[2+50*Nstr+(FED-1)*2]*256+buffer[2+50*Nstr+(FED-1)*2+1];
       buffer[2+50*Nstr+132000+pos*16+(buffer[2+50*i+46]-1)*2]=(int)(i/256);
       buffer[2+50*Nstr+132000+pos*16+(buffer[2+50*i+46]-1)*2+1]=i%256;
     }
  }


/*-------------------(make links (SL,Layer,Sector,ftbASD)->String-------------*/
   for(i=0;i<Nstr;i++){
      SL=buffer[2+50*i+1];
      Layer=buffer[2+50*i+26];
      Sector=buffer[2+50*i+27];
      ftbASD=buffer[2+50*i+28];
      offset=SL*7200+Layer*2400+Sector*200+ftbASD*2;
      buffer[2+50*Nstr+170000+offset]=(int)(i/256);
      buffer[2+50*Nstr+170000+offset+1]=i%256;
   }

/*----------------------------------------------------------------------------*/

  free(Filename);
  free(str);
  fclose(Table);
  return buffer;
}

/******************************************************************************/
/* int OTr_decode_TDC_to_Wire(                                                */
/*         unsigned char *Table -- Pointer returned by OTr_decode_TDC_init,   */
/*         int FED     -- TDC board ID,                                       */
/*         int Ch      -- Channel,                                            */
/*         int *SL     -- SuperLayer,                                         */
/*         int *Layer  -- Layer,                                              */
/*         int *Sector -- Sector,                                             */
/*         int *ASD    -- ASD,                                                */
/*         int *Wire   -- Wire                                                */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description: Convert (FED,Channel) to (SuperLayer,Layer,Sector,ASD,Wire).  */
/******************************************************************************/

int OTr_decode_TDC_to_Wire(unsigned char *buf,int FED,int ch,int *SL,
                            int *Layer,int *Sector,int *ASD,int *Wire){
int pos;
int offset;
int line;
    if(FED<1 || FED>65536)  return 0; 
    if(ch<0 || ch>127) return 0;       
           offset=(buf[0]*256+buf[1])*50+2;
           pos=buf[offset+(FED-1)*2]*256+buf[offset+(FED-1)*2+1]; 
	   line=buf[offset+132000+pos*16+(int)(ch/16)*2]*256+
	              buf[offset+132000+pos*16+(int)(ch/16)*2+1];
           if(line==0) return 0;
           *SL=buf[2+line*50+1];
	   *Layer=buf[2+line*50+2];
	   *Sector=buf[2+line*50+3];
	   *ASD=buf[2+line*50+28];
           
           if(*SL==0 || *Layer==0 || *Sector==0 || *ASD==0) return 0; 
           *Wire=ch%16+1;
	   return 1;
}

/******************************************************************************/
/* int OTr_decode_TDC_to_ModW(                                                */
/*         unsigned char *Table -- Pointer returned by OTr_decode_TDC_init,   */
/*         int FED     -- TDC board ID,                                       */
/*         int Ch      -- Channel,                                            */
/*         int *SL     -- SuperLayer,                                         */
/*         int *Layer  -- Layer,                                              */
/*         int *Module -- Module namber,                                      */
/*         int *Sector -- Sector namber,                                      */
/*         int *Wire   -- Wire in module                                      */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description:Convert (FED,Channel) to (SuperLayer,Layer,Module,Sector,Wire).*/
/******************************************************************************/

int OTr_decode_TDC_to_ModW(unsigned char *buf,int FED,int ch,int *SL,
                           int *Layer,int *Module,int *Sector,int *Wire){
int pos;
int offset;
int line;
    if(FED<1 || FED>65536)  return 0; 
    if(ch<0 || ch>127) return 0;       
           offset=(buf[0]*256+buf[1])*50+2;
           pos=buf[offset+(FED-1)*2]*256+buf[offset+(FED-1)*2+1]; 
	   line=buf[offset+132000+pos*16+(int)(ch/16)*2]*256+
	              buf[offset+132000+pos*16+(int)(ch/16)*2+1];
           if(line==0) return 0;
           *SL=buf[2+line*50+1];
	   *Layer=buf[2+line*50+2];
	   *Module=buf[2+line*50+11];         
	   *Sector=buf[2+line*50+12];

           if(*SL==0 || *Layer==0 ||*Module==0) return 0; 
           *Wire=ch%16+buf[2+line*50+13];
	   return 1;
}



/******************************************************************************/
/* int OTr_decode_Wire_to_TDC(                                                */
/*         unsigned char *Table -- Pointer returned by OTr_decode_TDC_init,   */
/*         int SL     -- SuperLayer,                                          */
/*         int Layer  -- Layer,                                               */
/*         int Sector -- Sector namber,                                       */
/*         int ASD    -- ASD in sector,                                       */
/*         int *Side  -- Side,                                                */
/*         int *Crate -- Create,                                              */
/*         int *Slot  -- Slot,                                                */
/*         int *Conn  -- Connector,                                           */
/*         int *FED   -- FED                                                  */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description: Convert (SL,Layer,Sector,ASD) ot (Side,Crate,Slot,Conn,FED).  */
/******************************************************************************/

int OTr_decode_Wire_to_TDC(unsigned char *buf,int SL,int Layer,int Sector,
               int ASD,int *Side,int *Crate,int *Slot,int *Conn,int *FED){
unsigned int Nstr;
unsigned int offset;
unsigned int line;
      if(SL<1 || SL>33) return 0;
      if(Layer<1 || Layer>3) return 0;
      if(Sector<1 || Sector>12) return 0;
      if(ASD<0 || ASD>100) return 0;

      Nstr=buf[0]*256+buf[1];
      offset=SL*7200+Layer*2400+Sector*200+ASD*2;
      line=buf[2+50*Nstr+170000+offset]*256+
                       buf[2+50*Nstr+170000+offset+1];
      if(line==0) return 0;
     *Side=buf[2+line*50];
     *Crate=buf[2+line*50+44];
     *Slot=buf[2+line*50+45];
     *Conn=buf[2+line*50+46];
     *FED=buf[2+line*50+47]*256+buf[2+line*50+48];
    return 1;
}
 


/******************************************************************************/
/* int OTrGetConnector(                                                       */
/*         unsigned char *Table -- Pointer returned by OTr_decode_TDC_init,   */
/*         int SL     -- SuperLayer,                                          */
/*         int Layer  -- Layer,                                               */
/*         int Sector -- Sector namber,                                       */
/*         int ASD    -- ASD in sector,                                       */
/*         int *FED   -- FED                                                  */
/*         int *Conn  -- Connector,                                           */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description: Convert (SL,Layer,Sector,ASD) ot (Conn,FED).                  */
/******************************************************************************/
int OTrGetConnector(unsigned char *buf,int SL,int Layer,int Sector,
		    int ASD,int *FED,int *Conn){
int tmp;

return OTr_decode_Wire_to_TDC(buf,SL,Layer,Sector,ASD,&tmp,&tmp,&tmp,Conn,FED);
}
 

/******************************************************************************/
/* void OTr_decode_TDC_quit(                                                  */
/*        unsigned char *Table -- Pointer returned by OTr_decode_TDC_init     */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description: Free memory used by table for fast decoding.                  */
/******************************************************************************/

void OTr_decode_TDC_quit(unsigned char *Table){
  free(Table);
}



/******************************************************************************/
/* int convert(                                                               */
/*        unsigned char *Table -- Pointer returned by OTr_decode_TDC_init     */
/*        int FROM,                                                           */
/*        int TO,                                                             */
/*        int *arg                                                            */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description:                                                               */
/******************************************************************************/

int convert(unsigned char *buf,int FROM,int TO,int *arg){
int i,j,Nstr;
int offset[14]={2,6,10,14,18,22,26,29,32,35,38,41,44,47};
    Nstr=buf[0]*256+buf[1];
    for(i=0;i<=Nstr;i++){
      if(arg[0]==buf[i*50+2] && arg[1]==buf[i*50+3]){  
        for(j=2;j<arg[6];j++){
	  if(arg[j]!=buf[offset[FROM-1]+i*50+j]) break;   
        }
        if(j==arg[6]) break;
      }
    }
    if(i>=Nstr) return 0;
    arg[2]=buf[offset[TO-1]+i*50+2];
    arg[3]=buf[offset[TO-1]+i*50+3];
    arg[4]=buf[offset[TO-1]+i*50+4];
    arg[5]=buf[offset[TO-1]+i*50+5];
    if(TO==7 || TO==8 ||  TO==9 || TO==11 || TO==12 ||
       TO==13 || TO==10) arg[6]=5;
    if(TO==1 || TO==2 || TO==3 || TO==4 || TO==5 || TO==6) arg[6]=6;
    if(TO==14) arg[6]=1;

    return 1;
}

/******************************************************************************/
/* int convert_str(                                                           */
/*        unsigned char *Table -- Pointer returned by OTr_decode_TDC_init     */
/*        int FROM,                                                           */
/*        int TO,                                                             */
/*        char *str                                                           */
/*     );                                                                     */
/*                                                                            */
/* Return:      1 or 0 if error.                                              */
/* Description:                                                               */
/******************************************************************************/
int convert_str(unsigned char *buf,int FROM,int TO,char *str){
int i,j,k;
int Side;
int  arg[7];

 if(str[1]=='m' || str[1]=='p' || str[1]=='t' || str[1]=='s'){
       if(str[0]=='+') Side=2;                 /*-Right side--*/
       else if(str[0]=='-') Side=1;            /*-Left side---*/
       else Side=10;                           /*---No side---*/
       k=0;
       if(str[1]=='m') k=0;                    /*-----MC------*/
       if(str[1]=='p') k=10;                   /*-----PC------*/
       if(str[1]=='t') k=20;                   /*-----TC------*/
       if(str[1]=='s') k=30;                   /*-----MS------*/

       arg[0]=Side; 
       arg[1]=k+atoi(str+2);

   switch(FROM){ 
   case 1: case 2:
     {
       arg[2]=atoi(str+4);
       arg[3]=atoi(str+6);
       arg[4]=(int)(atoi(str+9)/256);
       arg[5]=atoi(str+9)%256;
       arg[6]=6;
       break; 
     }
   case 7: case 8: case 9: case 11: case 12: case 13: 
     {
       arg[2]=atoi(str+4);
       arg[3]=atoi(str+6);
       arg[4]=atoi(str+9);
       arg[5]=0;
       arg[6]=5;
       break; 
     }
   case 3: case 4: case 5:
     {
       arg[2]=atoi(str+4);
       arg[3]=atoi(str+6);
       arg[4]=atoi(str+9);
       arg[5]=atoi(str+12);
       arg[6]=6;
       break; 
     }
   case 6:
     {
       arg[2]=atoi(str+4);
       arg[3]=atoi(str+6);
       arg[4]=str[9];
       arg[5]=atoi(str+10);
       arg[6]=6;       
       break; 
     }
   case 10: 
     {
       arg[2]=atoi(str+4);
       arg[3]=str[7];
       arg[4]=atoi(str+8);
       arg[5]=0;
       arg[6]=5;       
       break;         
     }
   }
   if(convert(buf,FROM,TO,&arg[0])){
     for(i=5;i<100;i++) str[i]=0;
     if(TO==1 || TO==2)
       sprintf(str+3,"-%i-%i-%i",arg[2],arg[3],arg[4]*256+arg[5]);
     if(TO==7 || TO==8 ||  TO==9 || TO==11 || TO==12 || TO==13)
       sprintf(str+3,"-%i-%i-%i",arg[2],arg[3],arg[4]);
     if(TO==3 || TO==4 || TO==5)
       sprintf(str+3,"-%i-%i-%i-%i",arg[2],arg[3],arg[4],arg[5]);
     if(TO==6) sprintf(str+3,"-%i-%i-%C%i",arg[2],arg[3],arg[4],arg[5]);
     if(TO==10) sprintf(str+3,"-%i-%C%i",arg[2],arg[3],arg[4]);

     return 1;
   }else return 0;
 }
}

/*----------------------------------------------------------------
 *
 * OTrGetEvent(
 *
 *      *input          - pointer to input file
 *      *event          - pointer event data  
 *      length          - length of the event
 *      prflag          - print flag
 *                )
 *
 *      Return:         0 if ok.
 *         
 *      Description:    Reads the events from file.
 *
 *      Author:         U.Uwer
 *
 *---------------------------------------------------------------
 */
int OTrGetEvent(FILE *input, EVENT_HDR *event, int length, int prflag) {
  int rc;
  rc=ETB_read_event(input, event, length);
  if (rc!=ETB_ok) {
    printf("***OTrGetEvent: Error reading event from file\n");
    return rc;}
     
  if (prflag) {
    rc = ETB_dump_event(stdout,event); 
    if (rc!=ETB_ok) {
      printf("***OTrGetEvent: Error dumping event\n");
    }
  }
  return ETB_ok;
}

/*----------------------------------------------------------------
 *
 * OTrGetTDC(
 *
 *      *event          - pointer event data  
 *      length          - length of the event
 *      tdc[]           - array of pointers on TDC data      
 *      iprflag         - print flag: printouts if >0  
 *                )
 *
 *      Return:         number of TDCs found (0 if nothing found) 
 *                      -1 on error 
 *         
 *      Description:    fills the array TDC[] 
 *
 *      Author:         U.Uwer
 *
 *---------------------------------------------------------------
 */
int OTrGetTDC(EVENT_HDR *event, int length,
	      unsigned char *TDC[MAXFED],int prflag){ 

  int nb_feds, fedid; 
  int i, id, ch, rc;
  static ETB_fed all_feds[MAXFED];


  for (i=0; i<MAXFED;i++) TDC[i]=0;

  /* -------- do event dump  ------ */
  if (prflag) {
    printf("Event at pointer %X with length %d\n", (int) event, length);  
    if (prflag>=2) {
      rc = ETB_dump_event(stdout,event); 
      if (rc!=ETB_ok) {
	printf("Error dumping event\n");
      }
    }
  }

  /* -------- get FEDs for our component Ids  ------ */
  rc=ETB_get_feds (event, COMPID, MAXFED, all_feds, &nb_feds); 
  if (rc!=ETB_ok) {
    printf("Error getting FEDs for *event= %x rc= %d \n", (int) event, rc);
    /* return -1; */
  } 
  if (prflag) {
    printf("FED list contains %d FEDs\n", nb_feds);
    ETB_dump_feds (stdout, event, all_feds, nb_feds); 
  }

  /* -------- loop over all FEDs and fill TDC[][]  ------ */
  for(id=0;id<nb_feds;id++){
    fedid=all_feds[id].hdr.fedid;
    if (fedid<MAXFED && fedid>0 ) {
      good_tdc[fedid]++;
      TDC[fedid]=(unsigned char *)all_feds[id].data;
    } else {
      printf("FEDID= %d >= %d -> skip FED block\n", fedid, MAXFED);
    }
  }
  return nb_feds;
} 



/*----------------------------------------------------------------
 *
 * OTrGetASD8(
 *      buf             - Pointer returned by OTr_decode_TDC_init
 *      tdc[]           - array returned by OTrGetTDC     
 *      asd8[]          - asd containing the data of required ASD8 
 *      SL              - SuperLayer ID
 *      lay             - layer ID 
 *      sec             - sector ID
 *      asd             - asd ID  of required ASD8
 *                )
 *
 *      Return:         0 if  ok
 *                      1 if error
 *         
 *      Description:    returns the data of an ASD8 specified by
 *                      lay, sec, asd.
 *
 *      Warning:        This code is not written in ANSI C
 * 
 *      Author:         U.Uwer
 *
 *---------------------------------------------------------------
 */
int OTrGetASD8(unsigned char *buf,
               unsigned char *TDC[MAXFED], unsigned char asd8[16],
	       char SL,char lay, char sec, char asd){

int connector, brd, i, ierr;

  OTrGetConnector(buf,SL,lay, sec, asd,&brd,&connector);
  if (connector>=0) {
    if (brd>0 && brd<MAXFED && connector>0 && connector<9) { 
      if (TDC[brd]!=0) {
	for (i=0; i<16; i++) 
	  asd8[i]=*(unsigned char *)(TDC[brd]+(connector-1)*16+i);
	ierr=0;
      } else {
	printf("***OTrGetASD8: Error - Bad TDC data\n"); 
	ierr=1;}
    } else { 
      printf("***OTrGetASD8: Error TDC/Connector ID out of range\n"); 
      ierr=1;}
  } else {
    printf("***OTrGetASD8: Error for ASD(Lay|Sec|ASD)= %d|%d|%d \n", 
	   lay, sec, asd); 
    ierr=1;
  }
  return ierr;
}


/*----------------------------------------------------------------
 *
 * OTrGetMask(
 *
 *      *filename       - name of the mask file
 *      tdcId           - TDC ID: 1..11      
 *      channelId       - channel ID: 0...127
 *                )
 *
 *      Return:         Noise Occupnacy (int) in percent.
 *         
 *      Description:    returns the noise occupancy of a given channel 
 *                      in percent. The current version uses the file
 *                      masks/masks.dat as reference.
 *
 *      Warning:        This code is not written in ANSI C
 * 
 *      Author:         W.Hulsbergen
 *
 *---------------------------------------------------------------
 */
int OTrGetMask(char *filename, const int tdcId, const int channelId)
{
  /* #define FILENAME "masks/masks.dat" */
  static char masks[MAXFED][NCHANNEL] ;
  static char first = 1;
  masks[0][0] = 1;
  
  if(first)
    {
      int nTdcs ;
      nTdcs = OTrReadAsciMask(filename, MAXFED, NCHANNEL, masks) ;
      first = 0;
      if (nTdcs<0) printf("***OTrGetMask: Error laoding mask\n"); 
    }
  if(tdcId>=0 && tdcId<MAXFED && channelId>=0 && channelId<NCHANNEL)
    return (int)masks[tdcId][channelId] ;
  return -1 ;
  /* #undef FILENAME */
}

int OTrReadAsciMask(char *filename, const int maxNTdcs, 
		 const int maxNChannels, char masks[MAXFED][NCHANNEL])
{
  int nTdcs,tdcIt;
  FILE* infile;

  infile = fopen(filename,"r") ;
  if (!infile) {
    printf("***OTrReadAsciMask: Error reading noise occupancy file %s\n", 
	   filename);
    return -1;
  }
  fscanf(infile,"%d", &nTdcs) ;
  if(nTdcs<=0) return -1;

  for(tdcIt=0; tdcIt<nTdcs && tdcIt<maxNTdcs ; tdcIt++)
    {
      int tdcId, channelIt ;
      fscanf(infile, "%d", &tdcId) ;
      if(tdcId<0 || tdcId>=nTdcs) return -2;
      for(channelIt=0; channelIt<maxNChannels; channelIt++)
	{
	  int maskvalue;
	  fscanf(infile, "%d", &maskvalue) ;
	  masks[tdcId][channelIt] = (char)maskvalue ;
	};
    };
  return nTdcs;
};

/*----------------------------------------------------------------
 *
 * OTrGetEvtInfo(
 *
 *      flag            - flag to define which info is returned
 *      *event          - pointer event data  
 *      length          - length of the event
 *      compid          - compid form which the event info is taken 
 *                        (compid=0 -> event info is taken from HDR)
 *                )
 *
 *      Return:         event info
 *                      -1 on error 
 *         
 *      Description:    function returns event info taken from 
 *                      event header (compid=0) or the first fed of 
 *                      compid.
 *
 *      Author:         U.Uwer
 *
 *---------------------------------------------------------------
 */
int OTrGetEvtInfo(int flag, EVENT_HDR *event, int length, 
                  short compid) {
  EVT_DATA *data;
  EVT_DATA_RECORD all_daqs[MAXDAQ];
  int nb_daqs; 
  int rc;
 
  if (ETB_get_daqs(event, MAXDAQ, all_daqs, &nb_daqs)) {
    printf("OTrGetEvtInfo> ***Error getting  DAQ Blocks.\n");
    return -1;
  }
  
  if (nb_daqs==0) {
    printf("OTrGetEvtInfo> No DAQ Blocks found.\n");
    return -1;}
  /* printf("OTrGetEvtInfo> found %d DAQ Blocks\n", nb_daqs); */
  data = (EVT_DATA *) &(all_daqs[0].data.run_number);
  
  /* 
     printf("RunNb, BX_Long, physBX, FLTBX, fltevt, sltevnt  = %d %d %d %d %d %
d \n", 
     data->run_number, data->BX_long, data->physBX,
     data->FLT_BX,  data->fltevt, event->sltevt);
     */
  
  if (flag==INFO_SLT_EVENT) return event->sltevt; 
  if (flag==INFO_BX_LONG) return  data->BX_long;
  if (flag==INFO_FLT_BX) return  data->FLT_BX;
  if (flag==INFO_PHYS_BX) return  data->physBX;
  
  return 0;
}

