#include "wax/OTrSectionCluster.hh"

#ifdef USE_ROOT
//ClassImp(OTrSectionCluster) ;
void 
OTrSectionCluster::Draw(int color) 
{
  for(HitContainer::const_iterator hitIt = begin() ; hitIt!= end() ; hitIt++)
    ((OTrHit*)(*hitIt))->Draw(color) ;
}
#endif

void 
OTrSectionCluster::Dump() const
{
  cout << "Gede: " << GetGede()->GetGEDEIndex()  
       << "(" << GetGede()->GetPMin().x() 
       << "," << GetGede()->GetPMin().z() 
       << "," << GetGede()->GetPMax().x()
       << "," << GetGede()->GetPMax().z()
       << "," << GetGede()->GetEPitch()
       << "," << GetGede()->GetEStereoAngle()
       << ") WireNr's: " ;
  for(HitIterator hitIt = begin() ; hitIt!= end() ; hitIt++)
    cout << (*hitIt)->GetWire()->GetWireNumber() << "(" 
	 << (*hitIt)->GetWire()->GetRawX() << "," 
	 << (*hitIt)->GetWire()->GetRawZ() << ") " ;
  cout << endl ;
}

bool
OTrSectionCluster::ValidNHits() const
{

  int monolayerOcc[4] = {0,0,0,0} ;
  for(HitIterator hitIt = begin() ; hitIt!= end() ; hitIt++)
    monolayerOcc[(*hitIt)->GetWire()->GetMonoLayer()]++ ;
  return monolayerOcc[0]<2 && monolayerOcc[1]<2 && monolayerOcc[2]<2 &&
    monolayerOcc[3]<2 ; 
  // Here too, it is important that the wires are ordered !!
  return !fHits.empty() && 
    (fHits.size()==1 || SameSectionCluster(fHits.front()->GetWire(),
					   fHits.back()->GetWire())) ;
} ;

signed char
OTrSectionCluster::GetLRSign(const OTrHit* hitIt) const {
  char sign=0 ;
  switch(size()) 
    { 
    case 0: break ;
    case 1: break ;
    case 2:
      if(abs(front()->GetWire()->GetPRWireNumber()-
	     back()->GetWire()->GetPRWireNumber())==1) break;
    default:
      int prWireNumber=hitIt->GetWire()->GetPRWireNumber() ;
      float averagePRWireNumber = 0.5*(front()->GetWire()->GetPRWireNumber()+ 
				       back()->GetWire()->GetPRWireNumber()) ;
      // 0.1 just for safety (avwirenr is not int)
      if(prWireNumber > averagePRWireNumber+0.1)  sign=-2 ; 
      else if(prWireNumber < averagePRWireNumber-0.1) sign=+2 ;
//       cout << prWireNumber << " " << size() << " " 
// 	   << hitIt->GetWire()->GetRawX() << " " << (int)sign << endl ;
    } ;
  return sign;
};
