#ifndef __OTrIteratorBase__
#define __OTrIteratorBase__

template<class S>
class OTrIteratorBase
{
private:
  S* fCur ;
  S* fEnd ;
public:
  OTrIteratorBase(S* a, S* b) {
    fCur = a;
    fEnd = b ;
  };
  inline S* next() { return ++fCur ; } ;
  inline bool valid() const { return fCur != fEnd ; };
  inline S& operator*() { return *fCur ; } ;
  inline S& operator->(){ return *fCur ; } ;
  inline bool operator==(const S* a) const { return fCur==a; }; 
  inline S* current() { return fCur ; } ;
};

template<class S>
class OTrConstIteratorBase
{
private:
  const S* fCur ;
  const S* fEnd ;
public:
  OTrConstIteratorBase(const S* a, const S* b) {
    fCur = a;
    fEnd = b ;
  };
  inline const S* next() { return ++fCur ; } ;
  inline bool valid() const { return fCur != fEnd ; };
  inline const S& operator*() const { return *fCur ; } ;
  inline const S& operator->() const { return *fCur ; } ;
  inline bool operator==(const S* a) const { return fCur==a; }; 
  inline const S* current() const { return fCur ; } ;
};

#endif
