#ifndef __OTR_RESIDUALPROFILE_HH__
#define __OTR_RESIDUALPROFILE_HH__

#ifdef USE_ROOT

#ifndef ROOT_TH2
#include <TH2.h>
#endif

class OTrResidualProfile : public TH2F
{
public:
  OTrResidualProfile() : TH2F() {} ;
  OTrResidualProfile(TString& name, TString& title, 
		     int nxbins, float xmin, float xmax, 
		     int nybins, float ymin, float ymax) ;
  virtual Int_t Fill(Axis_t x, Axis_t y, Stat_t w=1) ;
  virtual void Reset() ;
  virtual void FitWidthsBare() ;
  virtual void FitWidths() ;
  virtual float GetWidth(int binx)      { return fWidth[binx-1] ; }
  virtual float GetWidthError(int binx) { return fWidthErr[binx-1] ; }
  virtual int GetFitFlag(int binx)      { return fFitFlag[binx-1] ; }
  virtual float GetBinCenter(int binx)  { return GetXaxis()->GetBinCenter(binx) ; }
private:
  double* fWidth ;
  double* fWidthErr ;
  int*   fFitFlag ;
  double* fSumW ;
  double* fSumY ;
  double* fSumY2 ;
  float fAverageWidth ;
  float fAverageWidthError ;
};

#endif // USE_ROOT

#endif





