#ifndef __OTR_RUNSUMMARY_HH__
#define __OTR_RUNSUMMARY_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif

class OTrEvent ;

class OTrEventSummary 
{
public:
  OTrEventSummary() ;
  OTrEventSummary(const OTrEvent*) ;
  int GetId() const { return fId ; } ;
  int GetNHits() const { return fNHits ; } ;
  int GetNGoodHits() const { return fNGoodHits ; } ;
  int GetNBadHits() const { return fNBadHits ; } ;
  //float GetAvTdc() const { return fTdcSum/float(fNHits) ; } ;
private:
  int fId ;
  int fNHits ;
  int fNBadHits ;
  int fNGoodHits ;
  //float fTdcSum ;
};  

class OTrRunSummary
{
public:
  typedef vector<OTrEventSummary> Container ;
  OTrRunSummary() ;
  void Add(const OTrEvent* ) ;
#ifdef USE_ROOT
  void Draw(int n=1) ;
#endif
private:
  Container fEventSummaries ;
};

#endif
