#ifndef __OTR_TDCHISTOGRAM_HH__
#define __OTR_TDCHISTOGRAM_HH__

class OTrTdcHistogram ;

#ifdef USE_ROOT

#ifndef __OTR_OBSERVABLE_HH__
#include "OTrObservable.hh"
#endif
#ifndef ROOT_TH1
#include <TH1.h>
#endif

class OTrTdcHistogram: public TH1D
{
public:
  // consructors, destructor, assignment
  OTrTdcHistogram();
  OTrTdcHistogram( const TH1D& );
  virtual ~OTrTdcHistogram();

  /// return the bin number with the maximum content
  int MaximumBin();

  /// x with maximum number of entries
  inline double MaximumX() { return GetBinCenter( MaximumBin() ); } 

  ///
  OTrFObservable GetPeakValue( bool withGaussianFit = false );

  /// fit to an asymmetric Gaussian
  OTrFObservable FitAsymmetricGaussian( OTrFObservable& width );

  /// fit to the sum of two error functions
  OTrFObservable FitTwoErrorFunctions();

};

#endif //USE_ROOT

#endif
