#ifndef __OTR_TRACK_HH__
#define __OTR_TRACK_HH__

#ifndef __OTR_RECONSTRUCTEDTRACKINTERFACE_HH__
#include "OTrReconstructedTrackInterface.hh"
#endif

// #ifdef __OTR_CLASSDEF__
//  #ifndef ROOT_Rtypes
//  #include <Rtypes.h>
//  #endif
// #endif

class OTrTrackCandidate ;

class OTrTrack : public OTrReconstructedTrackInterface,
		 private OTrTrackDescription4D
{
public:
  // constructors, destructor, assignment
  OTrTrack() {} ;
  OTrTrack(const OTrTrackCandidate*) ; 
  virtual ~OTrTrack() {} ;

  // setters and getters
  using OTrTrackDescription4D::GetQ ;
  using OTrTrackDescription4D::GetCov ;
  using OTrTrackDescription4D::GetTx ;
  using OTrTrackDescription4D::GetTy ;
  using OTrTrackDescription4D::GetX ;
  using OTrTrackDescription4D::GetY ;
  virtual float GetMinChi2Probability() const { return fgMinChi2Probability ; }

  // other methods
  bool Fit(int) ;
  bool SearchHitsAndFit() ;
  bool Valid() ;

  //#ifdef __OTR_CLASSDEF__
  //ClassDef(OTrTrack,0)
  //#endif
private:
  // methods
  bool ValidNHits(const OTrReconstructedHit* doNotTakeThisHit=0) const ;
  // data members
  static unsigned int fgMinNHits ;
  static int fgMaxNSteps ;
  static int fgMaxNStepsForEtaConvergence ;
  static int fgMaxNStepsForChi2Convergence ;
  static float fgMinChi2Probability  ;
};

#endif
